/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.42.0-dev-20230903(e7d7a5b072e74702a912a4c855a3bda21a7757e7)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var te=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/arrays","vs/base/common/arraysFind","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/rangeMapping","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/advancedLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ne=function(O){for(var n=[],R=0,M=O.length;R<M;R++)n[R]=te[O[R]];return n};const Ee=this,Re=typeof global=="object"?global:{};var ge;(function(O){O.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(ge||(ge={}));var ge;(function(O){class n{constructor(u,f,v){this.type=u,this.detail=f,this.timestamp=v}}O.LoaderEvent=n;class R{constructor(u){this._events=[new n(1,"",u)]}record(u,f){this._events.push(new n(u,f,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=R;class M{record(u,f){}getEvents(){return[]}}M.INSTANCE=new M,O.NullLoaderEventRecorder=M})(ge||(ge={}));var ge;(function(O){class n{static fileUriToFilePath(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(M,i){return M.length>=i.length&&M.substr(0,i.length)===i}static endsWith(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,i){if(M){let u;for(u in M)M.hasOwnProperty(u)&&i(u,M[u])}}static isEmpty(M){let i=!0;return n.forEachProperty(M,()=>{i=!1}),i}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let i=Array.isArray(M)?[]:{};return n.forEachProperty(M,(u,f)=>{f&&typeof f=="object"?i[u]=n.recursiveClone(f):i[u]=f}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(ge||(ge={}));var ge;(function(O){function n(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}O.ensureError=n;class R{static validateConfigurationOptions(u){function f(v){if(v.phase==="loading"){console.error('Loading "'+v.moduleId+'" failed'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}if(v.phase==="factory"){console.error('The factory function of "'+v.moduleId+'" has thrown an exception'),console.error(v),console.error("Here are the modules that depend on it:"),console.error(v.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=f),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(O.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const v=n(new Error("INVALID cached data configuration, 'path' MUST be set"));v.phase="configuration",u.onError(v),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,f=null){let v=O.Utilities.recursiveClone(f||{});return O.Utilities.forEachProperty(u,(o,r)=>{o==="ignoreDuplicateModules"&&typeof v.ignoreDuplicateModules<"u"?v.ignoreDuplicateModules=v.ignoreDuplicateModules.concat(r):o==="paths"&&typeof v.paths<"u"?O.Utilities.forEachProperty(r,(g,e)=>v.paths[g]=e):o==="config"&&typeof v.config<"u"?O.Utilities.forEachProperty(r,(g,e)=>v.config[g]=e):v[o]=O.Utilities.recursiveClone(r)}),R.validateConfigurationOptions(v)}}O.ConfigurationOptionsUtil=R;class M{constructor(u,f){if(this._env=u,this.options=R.mergeConfigurationOptions(f),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let v=this.options.nodeRequire.main.filename,o=Math.max(v.lastIndexOf("/"),v.lastIndexOf("\\"));this.options.baseUrl=v.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(u,f)=>{Array.isArray(f)?this.sortedPathsRules.push({from:u,to:f}):this.sortedPathsRules.push({from:u,to:[f]})}),this.sortedPathsRules.sort((u,f)=>f.from.length-u.from.length)}cloneAndMerge(u){return new M(this._env,R.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let f;for(let v=0,o=this.sortedPathsRules.length;v<o;v++)if(f=this.sortedPathsRules[v],O.Utilities.startsWith(u,f.from)){let r=[];for(let g=0,e=f.to.length;g<e;g++)r.push(f.to[g]+u.substr(f.from.length));return r}return[u]}_addUrlArgsToUrl(u){return O.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let f=0,v=u.length;f<v;f++)u[f]=this._addUrlArgsToUrl(u[f]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let f=u,v;if(!O.Utilities.endsWith(f,".js")&&!O.Utilities.isAbsolutePath(f)){v=this._applyPaths(f);for(let o=0,r=v.length;o<r;o++)this.isBuild()&&v[o]==="empty:"||(O.Utilities.isAbsolutePath(v[o])||(v[o]=this.options.baseUrl+v[o]),!O.Utilities.endsWith(v[o],".js")&&!O.Utilities.containsQueryString(v[o])&&(v[o]=v[o]+".js"))}else!O.Utilities.endsWith(f,".js")&&!O.Utilities.containsQueryString(f)&&(f=f+".js"),v=[f];return this._addUrlArgsIfNecessaryToUrls(v)}requireToUrl(u){let f=u;return O.Utilities.isAbsolutePath(f)||(f=this._applyPaths(f)[0],O.Utilities.isAbsolutePath(f)||(f=this.options.baseUrl+f)),this._addUrlArgsIfNecessaryToUrl(f)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}O.Configuration=M})(ge||(ge={}));var ge;(function(O){class n{constructor(r){this._env=r,this._scriptLoader=null,this._callbackMap={}}load(r,g,e,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:c}=r.getConfig().getOptionsLiteral();c?this._scriptLoader=new R:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new R;let h={callback:e,errorback:d};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(h);return}this._callbackMap[g]=[h],this._scriptLoader.load(r,g,()=>this.triggerCallback(g),c=>this.triggerErrorback(g,c))}triggerCallback(r){let g=this._callbackMap[r];delete this._callbackMap[r];for(let e=0;e<g.length;e++)g[e].callback()}triggerErrorback(r,g){let e=this._callbackMap[r];delete this._callbackMap[r];for(let d=0;d<e.length;d++)e[d].errorback(g)}}class R{attachListeners(r,g,e){let d=()=>{r.removeEventListener("load",h),r.removeEventListener("error",c)},h=_=>{d(),g()},c=_=>{d(),e(_)};r.addEventListener("load",h),r.addEventListener("error",c)}load(r,g,e,d){if(/^node\|/.test(g)){let h=r.getConfig().getOptionsLiteral(),c=f(r.getRecorder(),h.nodeRequire||O.global.nodeRequire),_=g.split("|"),m=null;try{m=c(_[1])}catch(y){d(y);return}r.enqueueDefineAnonymousModule([],()=>m),e()}else{let h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript"),this.attachListeners(h,e,d);const{trustedTypesPolicy:c}=r.getConfig().getOptionsLiteral();c&&(g=c.createScriptURL(g)),h.setAttribute("src",g);const{cspNonce:_}=r.getConfig().getOptionsLiteral();_&&h.setAttribute("nonce",_),document.getElementsByTagName("head")[0].appendChild(h)}}}function M(o){const{trustedTypesPolicy:r}=o.getConfig().getOptionsLiteral();try{return(r?self.eval(r.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(r){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(r)),this._cachedCanUseEval}load(r,g,e,d){if(/^node\|/.test(g)){const h=r.getConfig().getOptionsLiteral(),c=f(r.getRecorder(),h.nodeRequire||O.global.nodeRequire),_=g.split("|");let m=null;try{m=c(_[1])}catch(y){d(y);return}r.enqueueDefineAnonymousModule([],function(){return m}),e()}else{const{trustedTypesPolicy:h}=r.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(r)){fetch(g).then(_=>{if(_.status!==200)throw new Error(_.statusText);return _.text()}).then(_=>{_=`${_}
//# sourceURL=${g}`,(h?self.eval(h.createScript("",_)):new Function(_)).call(self),e()}).then(void 0,d);return}try{h&&(g=h.createScriptURL(g)),importScripts(g),e()}catch(_){d(_)}}}}class u{constructor(r){this._env=r,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(r){this._didInitialize||(this._didInitialize=!0,this._fs=r("fs"),this._vm=r("vm"),this._path=r("path"),this._crypto=r("crypto"))}_initNodeRequire(r,g){const{nodeCachedData:e}=g.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,h=r("module");function c(_){const m=_.constructor;let y=function(N){try{return _.require(N)}finally{}};return y.resolve=function(N,C){return m._resolveFilename(N,_,!1,C)},y.resolve.paths=function(N){return m._resolveLookupPaths(N,_)},y.main=process.mainModule,y.extensions=m._extensions,y.cache=m._cache,y}h.prototype._compile=function(_,m){const y=h.wrap(_.replace(/^#!.*/,"")),w=g.getRecorder(),N=d._getCachedDataPath(e,m),C={filename:m};let S;try{const A=d._fs.readFileSync(N);S=A.slice(0,16),C.cachedData=A.slice(16),w.record(60,N)}catch{w.record(61,N)}const s=new d._vm.Script(y,C),a=s.runInThisContext(C),l=d._path.dirname(m),p=c(this),b=[this.exports,p,this,m,l,process,Re,Buffer],L=a.apply(this.exports,b);return d._handleCachedData(s,y,N,!C.cachedData,g),d._verifyCachedData(s,y,N,S,g),L}}load(r,g,e,d){const h=r.getConfig().getOptionsLiteral(),c=f(r.getRecorder(),h.nodeRequire||O.global.nodeRequire),_=h.nodeInstrumenter||function(y){return y};this._init(c),this._initNodeRequire(c,r);let m=r.getRecorder();if(/^node\|/.test(g)){let y=g.split("|"),w=null;try{w=c(y[1])}catch(N){d(N);return}r.enqueueDefineAnonymousModule([],()=>w),e()}else{g=O.Utilities.fileUriToFilePath(this._env.isWindows,g);const y=this._path.normalize(g),w=this._getElectronRendererScriptPathOrUri(y),N=!!h.nodeCachedData,C=N?this._getCachedDataPath(h.nodeCachedData,g):void 0;this._readSourceAndCachedData(y,C,m,(S,s,a,l)=>{if(S){d(S);return}let p;s.charCodeAt(0)===u._BOM?p=u._PREFIX+s.substring(1)+u._SUFFIX:p=u._PREFIX+s+u._SUFFIX,p=_(p,y);const b={filename:w,cachedData:a},L=this._createAndEvalScript(r,p,b,e,d);this._handleCachedData(L,p,C,N&&!a,r),this._verifyCachedData(L,p,C,l,r)})}}_createAndEvalScript(r,g,e,d,h){const c=r.getRecorder();c.record(31,e.filename);const _=new this._vm.Script(g,e),m=_.runInThisContext(e),y=r.getGlobalAMDDefineFunc();let w=!1;const N=function(){return w=!0,y.apply(null,arguments)};return N.amd=y.amd,m.call(O.global,r.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),c.record(32,e.filename),w?d():h(new Error(`Didn't receive define call in ${e.filename}!`)),_}_getElectronRendererScriptPathOrUri(r){if(!this._env.isElectronRenderer)return r;let g=r.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${r}`}_getCachedDataPath(r,g){const e=this._crypto.createHash("md5").update(g,"utf8").update(r.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(g).replace(/\.js$/,"");return this._path.join(r.path,`${d}-${e}.code`)}_handleCachedData(r,g,e,d,h){r.cachedDataRejected?this._fs.unlink(e,c=>{h.getRecorder().record(62,e),this._createAndWriteCachedData(r,g,e,h),c&&h.getConfig().onError(c)}):d&&this._createAndWriteCachedData(r,g,e,h)}_createAndWriteCachedData(r,g,e,d){let h=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),c=-1,_=0,m;const y=()=>{setTimeout(()=>{m||(m=this._crypto.createHash("md5").update(g,"utf8").digest());const w=r.createCachedData();if(!(w.length===0||w.length===c||_>=5)){if(w.length<c){y();return}c=w.length,this._fs.writeFile(e,Buffer.concat([m,w]),N=>{N&&d.getConfig().onError(N),d.getRecorder().record(63,e),y()})}},h*Math.pow(4,_++))};y()}_readSourceAndCachedData(r,g,e,d){if(!g)this._fs.readFile(r,{encoding:"utf8"},d);else{let h,c,_,m=2;const y=w=>{w?d(w):--m===0&&d(void 0,h,c,_)};this._fs.readFile(r,{encoding:"utf8"},(w,N)=>{h=N,y(w)}),this._fs.readFile(g,(w,N)=>{!w&&N&&N.length>0?(_=N.slice(0,16),c=N.slice(16),e.record(60,g)):e.record(61,g),y()})}}_verifyCachedData(r,g,e,d,h){d&&(r.cachedDataRejected||setTimeout(()=>{const c=this._crypto.createHash("md5").update(g,"utf8").digest();d.equals(c)||(h.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,_=>{_&&h.getConfig().onError(_)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function f(o,r){if(r.__$__isRecorded)return r;const g=function(d){o.record(33,d);try{return r(d)}finally{o.record(34,d)}};return g.__$__isRecorded=!0,g}O.ensureRecordedNodeRequire=f;function v(o){return new n(o)}O.createScriptLoader=v})(ge||(ge={}));var ge;(function(O){class n{constructor(o){let r=o.lastIndexOf("/");r!==-1?this.fromModulePath=o.substr(0,r+1):this.fromModulePath=""}static _normalizeModuleId(o){let r=o,g;for(g=/\/\.\//;g.test(r);)r=r.replace(g,"/");for(r=r.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(r);)r=r.replace(g,"/");return r=r.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),r}resolveModule(o){let r=o;return O.Utilities.isAbsolutePath(r)||(O.Utilities.startsWith(r,"./")||O.Utilities.startsWith(r,"../"))&&(r=n._normalizeModuleId(this.fromModulePath+r)),r}}n.ROOT=new n(""),O.ModuleIdResolver=n;class R{constructor(o,r,g,e,d,h){this.id=o,this.strId=r,this.dependencies=g,this._callback=e,this._errorback=d,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,r){try{return{returnedValue:o.apply(O.global,r),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(o,r,g,e){return o.shouldInvokeFactory(r)?o.shouldCatchError()?this._safeInvokeFunction(g,e):{returnedValue:g.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(o,r,g,e){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let h=R._invokeFactory(r,this.strId,this._callback,g);d=h.producedError,o.record(22,this.strId),!d&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(d){let h=O.ensureError(d);h.phase="factory",h.moduleId=this.strId,h.neededBy=e(this.id),this.error=h,r.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}O.Module=R;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let r=this._strModuleIdToIntModuleId.get(o);return typeof r>"u"&&(r=this._nextId++,this._strModuleIdToIntModuleId.set(o,r),this._intModuleIdToStrModuleId[r]=o),r}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class i{constructor(o){this.id=o}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class u{constructor(o,r,g){this.id=o,this.pluginId=r,this.pluginParam=g}}O.PluginDependency=u;class f{constructor(o,r,g,e,d=0){this._env=o,this._scriptLoader=r,this._loaderAvailableTimestamp=d,this._defineFunc=g,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new f(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,r){let g=h=>h.replace(/\\/g,"/"),e=g(o),d=r.split(/\n/);for(let h=0;h<d.length;h++){let c=d[h].match(/(.*):(\d+):(\d+)\)?$/);if(c){let _=c[1],m=c[2],y=c[3],w=Math.max(_.lastIndexOf(" ")+1,_.lastIndexOf("(")+1);if(_=_.substr(w),_=g(_),_===e){let N={line:parseInt(m,10),col:parseInt(y,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],r=0;for(let g=0,e=this._modules2.length;g<e;g++){let d=this._modules2[g];if(!d)continue;let h=this._buildInfoPath[d.id]||null,c=this._buildInfoDefineStack[d.id]||null,_=this._buildInfoDependencies[d.id];o[r++]={id:d.strId,path:h,defineLocation:h&&c?f._findRelevantLocationInStack(h,c):null,dependencies:_,shim:null,exports:d.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,r){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:o,callback:r}}defineModule(o,r,g,e,d,h=new n(o)){let c=this._moduleIdProvider.getModuleId(o);if(this._modules2[c]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let _=new R(c,o,this._normalizeDependencies(r,h),g,e,h);this._modules2[c]=_,this._config.isBuild()&&(this._buildInfoDefineStack[c]=d,this._buildInfoDependencies[c]=(_.dependencies||[]).map(m=>this._moduleIdProvider.getStrModuleId(m.id))),this._resolve(_)}_normalizeDependency(o,r){if(o==="exports")return i.EXPORTS;if(o==="module")return i.MODULE;if(o==="require")return i.REQUIRE;let g=o.indexOf("!");if(g>=0){let e=r.resolveModule(o.substr(0,g)),d=r.resolveModule(o.substr(g+1)),h=this._moduleIdProvider.getModuleId(e+"!"+d),c=this._moduleIdProvider.getModuleId(e);return new u(h,c,d)}return new i(this._moduleIdProvider.getModuleId(r.resolveModule(o)))}_normalizeDependencies(o,r){let g=[],e=0;for(let d=0,h=o.length;d<h;d++)g[e++]=this._normalizeDependency(o[d],r);return g}_relativeRequire(o,r,g,e){if(typeof r=="string")return this.synchronousRequire(r,o);this.defineModule(O.Utilities.generateAnonymousModule(),r,g,e,null,o)}synchronousRequire(o,r=new n(o)){let g=this._normalizeDependency(o,r),e=this._modules2[g.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(o,r){let g=this._config.shouldRecordStats();r?this._config=new O.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let r=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),r.dependencies,r.callback,null,r.stack)}}_createLoadError(o,r){let g=this._moduleIdProvider.getStrModuleId(o),e=(this._inverseDependencies2[o]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));const d=O.ensureError(r);return d.phase="loading",d.moduleId=g,d.neededBy=e,d}_onLoadError(o,r){const g=this._createLoadError(o,r);this._modules2[o]||(this._modules2[o]=new R(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let e=[];for(let c=0,_=this._moduleIdProvider.getMaxModuleId();c<_;c++)e[c]=!1;let d=!1,h=[];for(h.push(o),e[o]=!0;h.length>0;){let c=h.shift(),_=this._modules2[c];_&&(d=_.onDependencyError(g)||d);let m=this._inverseDependencies2[c];if(m)for(let y=0,w=m.length;y<w;y++){let N=m[y];e[N]||(h.push(N),e[N]=!0)}}d||this._config.onError(g)}_hasDependencyPath(o,r){let g=this._modules2[o];if(!g)return!1;let e=[];for(let h=0,c=this._moduleIdProvider.getMaxModuleId();h<c;h++)e[h]=!1;let d=[];for(d.push(g),e[o]=!0;d.length>0;){let c=d.shift().dependencies;if(c)for(let _=0,m=c.length;_<m;_++){let y=c[_];if(y.id===r)return!0;let w=this._modules2[y.id];w&&!e[y.id]&&(e[y.id]=!0,d.push(w))}}return!1}_findCyclePath(o,r,g){if(o===r||g===50)return[o];let e=this._modules2[o];if(!e)return null;let d=e.dependencies;if(d)for(let h=0,c=d.length;h<c;h++){let _=this._findCyclePath(d[h].id,r,g+1);if(_!==null)return _.push(o),_}return null}_createRequire(o){let r=(g,e,d)=>this._relativeRequire(o,g,e,d);return r.toUrl=g=>this._config.requireToUrl(o.resolveModule(g)),r.getStats=()=>this.getLoaderEvents(),r.hasDependencyCycle=()=>this._hasDependencyCycle,r.config=(g,e=!1)=>{this.configure(g,e)},r.__$__nodeRequire=O.global.nodeRequire,r}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let r=this._moduleIdProvider.getStrModuleId(o),g=this._config.moduleIdToPaths(r),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(r.indexOf("/")===-1||e.test(r))&&g.push("node|"+r);let d=-1,h=c=>{if(d++,d>=g.length)this._onLoadError(o,c);else{let _=g[d],m=this.getRecorder();if(this._config.isBuild()&&_==="empty:"){this._buildInfoPath[o]=_,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}m.record(10,_),this._scriptLoader.load(this,_,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=_),m.record(11,_),this._onLoad(o)},y=>{m.record(12,_),h(y)})}};h(null)}_loadPluginDependency(o,r){if(this._modules2[r.id]||this._knownModules2[r.id])return;this._knownModules2[r.id]=!0;let g=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(r.id),[],e,null,null)};g.error=e=>{this._config.onError(this._createLoadError(r.id,e))},o.load(r.pluginParam,this._createRequire(n.ROOT),g,this._config.getOptionsLiteral())}_resolve(o){let r=o.dependencies;if(r)for(let g=0,e=r.length;g<e;g++){let d=r[g];if(d===i.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(d===i.MODULE){o.unresolvedDependenciesCount--;continue}if(d===i.REQUIRE){o.unresolvedDependenciesCount--;continue}let h=this._modules2[d.id];if(h&&h.isComplete()){if(h.error){o.onDependencyError(h.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let c=this._findCyclePath(d.id,o.id,0)||[];c.reverse(),c.push(d.id),console.warn(c.map(_=>this._moduleIdProvider.getStrModuleId(_)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(o.id),d instanceof u){let c=this._modules2[d.pluginId];if(c&&c.isComplete()){this._loadPluginDependency(c.exports,d);continue}let _=this._inversePluginDependencies2.get(d.pluginId);_||(_=[],this._inversePluginDependencies2.set(d.pluginId,_)),_.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let r=this.getRecorder();if(o.isComplete())return;let g=o.dependencies,e=[];if(g)for(let _=0,m=g.length;_<m;_++){let y=g[_];if(y===i.EXPORTS){e[_]=o.exports;continue}if(y===i.MODULE){e[_]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(y===i.REQUIRE){e[_]=this._createRequire(o.moduleIdResolver);continue}let w=this._modules2[y.id];if(w){e[_]=w.exports;continue}e[_]=null}const d=_=>(this._inverseDependencies2[_]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));o.complete(r,this._config,e,d);let h=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,h)for(let _=0,m=h.length;_<m;_++){let y=h[_],w=this._modules2[y];w.unresolvedDependenciesCount--,w.unresolvedDependenciesCount===0&&this._onModuleComplete(w)}let c=this._inversePluginDependencies2.get(o.id);if(c){this._inversePluginDependencies2.delete(o.id);for(let _=0,m=c.length;_<m;_++)this._loadPluginDependency(o.exports,c[_])}}}O.ModuleManager=f})(ge||(ge={}));var ee,ge;(function(O){const n=new O.Environment;let R=null;const M=function(v,o,r){typeof v!="string"&&(r=o,o=v,v=null),(typeof o!="object"||!Array.isArray(o))&&(r=o,o=null),o||(o=["require","exports","module"]),v?R.defineModule(v,o,r,null,null):R.enqueueDefineAnonymousModule(o,r)};M.amd={jQuery:!0};const i=function(v,o=!1){R.configure(v,o)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return R.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){R.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return R.getConfig().getOptionsLiteral()},u.reset=function(){R=R.reset()},u.getBuildInfo=function(){return R.getBuildInfo()},u.getStats=function(){return R.getLoaderEvents()},u.define=M;function f(){if(typeof O.global.require<"u"||typeof require<"u"){const v=O.global.require||require;if(typeof v=="function"&&typeof v.resolve=="function"){const o=O.ensureRecordedNodeRequire(R.getRecorder(),v);O.global.nodeRequire=o,u.nodeRequire=o,u.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=u:(n.isElectronRenderer||(O.global.define=M),O.global.require=u)}O.init=f,(typeof O.global.define!="function"||!O.global.define.amd)&&(R=new O.ModuleManager(n,O.createScriptLoader(n),M,u,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&u.config(O.global.require),ee=function(){return M.apply(null,arguments)},ee.amd=M.amd,typeof doNotInitLoader>"u"&&f())})(ge||(ge={}));var ve=this&&this.__awaiter||function(O,n,R,M){function i(u){return u instanceof R?u:new R(function(f){f(u)})}return new(R||(R=Promise))(function(u,f){function v(g){try{r(M.next(g))}catch(e){f(e)}}function o(g){try{r(M.throw(g))}catch(e){f(e)}}function r(g){g.done?u(g.value):i(g.value).then(v,o)}r((M=M.apply(O,n||[])).next())})};ee(te[15],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let R=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(c,_){let m;return _.length===0?m=c:m=c.replace(/\{(\d+)\}/g,(y,w)=>{const N=w[0],C=_[N];let S=y;return typeof C=="string"?S=C:(typeof C=="number"||typeof C=="boolean"||C===void 0||C===null)&&(S=String(C)),S}),R&&(m="\uFF3B"+m.replace(/[aouei]/g,"$&$&")+"\uFF3D"),m}function u(c,_){let m=c[_];return m||(m=c["*"],m)?m:null}function f(c){return c.charAt(c.length-1)==="/"?c:c+"/"}function v(c,_,m){return ve(this,void 0,void 0,function*(){const y=f(c)+f(_)+"vscode/"+f(m),w=yield fetch(y);if(w.ok)return yield w.json();throw new Error(`${w.status} - ${w.statusText}`)})}function o(c){return function(_,m){const y=Array.prototype.slice.call(arguments,2);return i(c[_],y)}}function r(c,_,...m){return i(_,m)}n.localize=r;function g(c){}n.getConfiguredDefaultLocale=g;function e(c){R=c}n.setPseudoTranslation=e;function d(c,_){var m;return{localize:o(_[c]),getConfiguredDefaultLocale:(m=_.getConfiguredDefaultLocale)!==null&&m!==void 0?m:y=>{}}}n.create=d;function h(c,_,m,y){var w;const N=(w=y["vs/nls"])!==null&&w!==void 0?w:{};if(!c||c.length===0)return m({localize:r,getConfiguredDefaultLocale:()=>{var l;return(l=N.availableLanguages)===null||l===void 0?void 0:l["*"]}});const C=N.availableLanguages?u(N.availableLanguages,c):null,S=C===null||C===M;let s=".nls";S||(s=s+"."+C);const a=l=>{Array.isArray(l)?l.localize=o(l):l.localize=o(l[c]),l.getConfiguredDefaultLocale=()=>{var p;return(p=N.availableLanguages)===null||p===void 0?void 0:p["*"]},m(l)};typeof N.loadBundle=="function"?N.loadBundle(c,C,(l,p)=>{l?_([c+".nls"],a):a(p)}):N.translationServiceUrl&&!S?ve(this,void 0,void 0,function*(){var l;try{const p=yield v(N.translationServiceUrl,C,c);return a(p)}catch(p){if(!C.includes("-"))return console.error(p),_([c+".nls"],a);try{const b=C.split("-")[0],L=yield v(N.translationServiceUrl,b,c);return(l=N.availableLanguages)!==null&&l!==void 0||(N.availableLanguages={}),N.availableLanguages["*"]=b,a(L)}catch(b){return console.error(b),_([c+".nls"],a)}}}):_([c+s],a,l=>{if(s===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${C}. Falling back to the default language:`,l),_([c+".nls"],a)})}n.load=h}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function R(g,e){var d;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(g,e)}catch(h){console.warn(h);return}try{return(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy(g,e)}catch(h){console.warn(h);return}}const M=R("amdLoader",{createScriptURL:g=>g,createScript:(g,...e)=>{const d=e.slice(0,-1).join(","),h=e.pop().toString();return`(function anonymous(${d}) { ${h}
})`}});function i(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function u(){return new Promise((g,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const d=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(d).then(c=>{if(c.status!==200)throw new Error(c.statusText);return c.text()}).then(c=>{c=`${c}
//# sourceURL=${d}`,(M?globalThis.eval(M.createScript("",c)):new Function(c)).call(globalThis),g()}).then(void 0,e);return}M?importScripts(M.createScriptURL(d)):importScripts(d),g()})}function f(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function v(g){u().then(()=>{f(),require([g],function(e){setTimeout(function(){const d=e.create((h,c)=>{globalThis.postMessage(h,c)},null);for(globalThis.onmessage=h=>d.onmessage(h.data,h.ports);r.length>0;){const h=r.shift();d.onmessage(h.data,h.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&f();let o=!0;const r=[];globalThis.onmessage=g=>{if(!o){r.push(g);return}o=!1,v(g.data)}}(),ee(te[16],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMaxIdxBy=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.reverseOrder=n.booleanComparator=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.findLastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupAdjacentBy=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function R(x,U=0){return x[x.length-(1+U)]}n.tail=R;function M(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}n.tail2=M;function i(x,U,q=($,Q)=>$===Q){if(x===U)return!0;if(!x||!U||x.length!==U.length)return!1;for(let $=0,Q=x.length;$<Q;$++)if(!q(x[$],U[$]))return!1;return!0}n.equals=i;function u(x,U){const q=x.length-1;U<q&&(x[U]=x[q]),x.pop()}n.removeFastWithoutKeepingOrder=u;function f(x,U,q){return v(x.length,$=>q(x[$],U))}n.binarySearch=f;function v(x,U){let q=0,$=x-1;for(;q<=$;){const Q=(q+$)/2|0,ae=U(Q);if(ae<0)q=Q+1;else if(ae>0)$=Q-1;else return Q}return-(q+1)}n.binarySearch2=v;function o(x,U){let q=0,$=x.length;if($===0)return 0;for(;q<$;){const Q=Math.floor((q+$)/2);U(x[Q])?$=Q:q=Q+1}return q}n.findFirstInSorted=o;function r(x,U,q){if(x=x|0,x>=U.length)throw new TypeError("invalid index");const $=U[Math.floor(U.length*Math.random())],Q=[],ae=[],oe=[];for(const ce of U){const fe=q(ce,$);fe<0?Q.push(ce):fe>0?ae.push(ce):oe.push(ce)}return x<Q.length?r(x,Q,q):x<Q.length+oe.length?oe[0]:r(x-(Q.length+oe.length),ae,q)}n.quickSelect=r;function g(x,U){const q=[];let $;for(const Q of x.slice(0).sort(U))!$||U($[0],Q)!==0?($=[Q],q.push($)):$.push(Q);return q}n.groupBy=g;function*e(x,U){let q,$;for(const Q of x)$!==void 0&&U($,Q)?q.push(Q):(q&&(yield q),q=[Q]),$=Q;q&&(yield q)}n.groupAdjacentBy=e;function d(x){return x.filter(U=>!!U)}n.coalesce=d;function h(x){let U=0;for(let q=0;q<x.length;q++)x[q]&&(x[U]=x[q],U+=1);x.length=U}n.coalesceInPlace=h;function c(x){return!Array.isArray(x)||x.length===0}n.isFalsyOrEmpty=c;function _(x){return Array.isArray(x)&&x.length>0}n.isNonEmptyArray=_;function m(x,U=q=>q){const q=new Set;return x.filter($=>{const Q=U($);return q.has(Q)?!1:(q.add(Q),!0)})}n.distinct=m;function y(x,U){const q=w(x,U);if(q!==-1)return x[q]}n.findLast=y;function w(x,U){for(let q=x.length-1;q>=0;q--){const $=x[q];if(U($))return q}return-1}n.findLastIndex=w;function N(x,U){return x.length>0?x[0]:U}n.firstOrDefault=N;function C(x,U){let q=typeof U=="number"?x:0;typeof U=="number"?q=x:(q=0,U=x);const $=[];if(q<=U)for(let Q=q;Q<U;Q++)$.push(Q);else for(let Q=q;Q>U;Q--)$.push(Q);return $}n.range=C;function S(x,U,q){const $=x.slice(0,U),Q=x.slice(U);return $.concat(q,Q)}n.arrayInsert=S;function s(x,U){const q=x.indexOf(U);q>-1&&(x.splice(q,1),x.unshift(U))}n.pushToStart=s;function a(x,U){const q=x.indexOf(U);q>-1&&(x.splice(q,1),x.push(U))}n.pushToEnd=a;function l(x,U){for(const q of U)x.push(q)}n.pushMany=l;function p(x){return Array.isArray(x)?x:[x]}n.asArray=p;function b(x,U){for(const q of x){const $=U(q);if($!==void 0)return $}}n.mapFind=b;function L(x,U,q){const $=E(x,U),Q=x.length,ae=q.length;x.length=Q+ae;for(let oe=Q-1;oe>=$;oe--)x[oe+ae]=x[oe];for(let oe=0;oe<ae;oe++)x[oe+$]=q[oe]}n.insertInto=L;function A(x,U,q,$){const Q=E(x,U),ae=x.splice(Q,q);return L(x,Q,$),ae}n.splice=A;function E(x,U){return U<0?Math.max(U+x.length,0):Math.min(U,x.length)}var P;(function(x){function U(ae){return ae<0}x.isLessThan=U;function q(ae){return ae<=0}x.isLessThanOrEqual=q;function $(ae){return ae>0}x.isGreaterThan=$;function Q(ae){return ae===0}x.isNeitherLessOrGreaterThan=Q,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(P||(n.CompareResult=P={}));function T(x,U){return(q,$)=>U(x(q),x($))}n.compareBy=T;function k(...x){return(U,q)=>{for(const $ of x){const Q=$(U,q);if(!P.isNeitherLessOrGreaterThan(Q))return Q}return P.neitherLessOrGreaterThan}}n.tieBreakComparators=k;const D=(x,U)=>x-U;n.numberComparator=D;const F=(x,U)=>(0,n.numberComparator)(x?1:0,U?1:0);n.booleanComparator=F;function V(x){return(U,q)=>-x(U,q)}n.reverseOrder=V;function W(x,U){if(x.length===0)return;let q=x[0];for(let $=1;$<x.length;$++){const Q=x[$];U(Q,q)>0&&(q=Q)}return q}n.findMaxBy=W;function j(x,U){if(x.length===0)return;let q=x[0];for(let $=1;$<x.length;$++){const Q=x[$];U(Q,q)>=0&&(q=Q)}return q}n.findLastMaxBy=j;function z(x,U){return W(x,(q,$)=>-U(q,$))}n.findMinBy=z;function K(x,U){if(x.length===0)return-1;let q=0;for(let $=1;$<x.length;$++){const Q=x[$];U(Q,x[q])>0&&(q=$)}return q}n.findMaxIdxBy=K;class se{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let q=this.firstIdx;for(;q<this.items.length&&U(this.items[q]);)q++;const $=q===this.firstIdx?null:this.items.slice(this.firstIdx,q);return this.firstIdx=q,$}takeFromEndWhile(U){let q=this.lastIdx;for(;q>=0&&U(this.items[q]);)q--;const $=q===this.lastIdx?null:this.items.slice(q+1,this.lastIdx+1);return this.lastIdx=q,$}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const U=this.items[this.firstIdx];return this.firstIdx++,U}takeCount(U){const q=this.items.slice(this.firstIdx,this.firstIdx+U);return this.firstIdx+=U,q}}n.ArrayQueue=se;class t{constructor(U){this.iterate=U}toArray(){const U=[];return this.iterate(q=>(U.push(q),!0)),U}filter(U){return new t(q=>this.iterate($=>U($)?q($):!0))}map(U){return new t(q=>this.iterate($=>q(U($))))}findLast(U){let q;return this.iterate($=>(U($)&&(q=$),!0)),q}findLastMaxBy(U){let q,$=!0;return this.iterate(Q=>(($||P.isGreaterThan(U(Q,q)))&&($=!1,q=Q),!0)),q}}n.CallbackIterable=t,t.empty=new t(x=>{})}),ee(te[17],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MonotonousArray=n.findFirstIdxMonotonousOrArrLen=n.findFirstMonotonous=n.findLastIdxMonotonous=n.findLastMonotonous=void 0;function R(v,o){const r=M(v,o);return r===-1?void 0:v[r]}n.findLastMonotonous=R;function M(v,o,r=0,g=v.length){let e=r,d=g;for(;e<d;){const h=Math.floor((e+d)/2);o(v[h])?e=h+1:d=h}return e-1}n.findLastIdxMonotonous=M;function i(v,o){const r=u(v,o);return r===v.length?void 0:v[r]}n.findFirstMonotonous=i;function u(v,o,r=0,g=v.length){let e=r,d=g;for(;e<d;){const h=Math.floor((e+d)/2);o(v[h])?d=h:e=h+1}return e}n.findFirstIdxMonotonousOrArrLen=u;class f{constructor(o){this._items=o,this._findLastMonotonousLastIdx=0}findLastMonotonous(o){if(f.assertInvariants){if(this._lastPredicate){for(const g of this._items)if(this._lastPredicate(g)&&!o(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._lastPredicate=o}const r=M(this._items,o,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=r+1,r===-1?void 0:this._items[r]}}n.MonotonousArray=f,f.assertInvariants=!1}),ee(te[29],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class R{constructor(u){this.fn=u,this.lastCache=void 0,this.lastArgKey=void 0}get(u){const f=JSON.stringify(u);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(u)),this.lastCache}}n.LRUCachedFunction=R;class M{get cachedValues(){return this._map}constructor(u){this.fn=u,this._map=new Map}get(u){if(this._map.has(u))return this._map.get(u);const f=this.fn(u);return this._map.set(u,f),f}}n.CachedFunction=M}),ee(te[30],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=void 0;class R{constructor(){this.map=new Map}add(i,u){let f=this.map.get(i);f||(f=new Set,this.map.set(i,f)),f.add(u)}delete(i,u){const f=this.map.get(i);f&&(f.delete(u),f.size===0&&this.map.delete(i))}forEach(i,u){const f=this.map.get(i);f&&f.forEach(u)}get(i){const u=this.map.get(i);return u||new Set}}n.SetMap=R}),ee(te[31],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function R(v,o){const r=Math.pow(10,o);return Math.round(v*r)/r}class M{constructor(o,r,g,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,r))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=R(Math.max(Math.min(1,e),0),3)}static equals(o,r){return o.r===r.r&&o.g===r.g&&o.b===r.b&&o.a===r.a}}n.RGBA=M;class i{constructor(o,r,g,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=R(Math.max(Math.min(1,r),0),3),this.l=R(Math.max(Math.min(1,g),0),3),this.a=R(Math.max(Math.min(1,e),0),3)}static equals(o,r){return o.h===r.h&&o.s===r.s&&o.l===r.l&&o.a===r.a}static fromRGBA(o){const r=o.r/255,g=o.g/255,e=o.b/255,d=o.a,h=Math.max(r,g,e),c=Math.min(r,g,e);let _=0,m=0;const y=(c+h)/2,w=h-c;if(w>0){switch(m=Math.min(y<=.5?w/(2*y):w/(2-2*y),1),h){case r:_=(g-e)/w+(g<e?6:0);break;case g:_=(e-r)/w+2;break;case e:_=(r-g)/w+4;break}_*=60,_=Math.round(_)}return new i(_,m,y,d)}static _hue2rgb(o,r,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?o+(r-o)*6*g:g<1/2?r:g<2/3?o+(r-o)*(2/3-g)*6:o}static toRGBA(o){const r=o.h/360,{s:g,l:e,a:d}=o;let h,c,_;if(g===0)h=c=_=e;else{const m=e<.5?e*(1+g):e+g-e*g,y=2*e-m;h=i._hue2rgb(y,m,r+1/3),c=i._hue2rgb(y,m,r),_=i._hue2rgb(y,m,r-1/3)}return new M(Math.round(h*255),Math.round(c*255),Math.round(_*255),d)}}n.HSLA=i;class u{constructor(o,r,g,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=R(Math.max(Math.min(1,r),0),3),this.v=R(Math.max(Math.min(1,g),0),3),this.a=R(Math.max(Math.min(1,e),0),3)}static equals(o,r){return o.h===r.h&&o.s===r.s&&o.v===r.v&&o.a===r.a}static fromRGBA(o){const r=o.r/255,g=o.g/255,e=o.b/255,d=Math.max(r,g,e),h=Math.min(r,g,e),c=d-h,_=d===0?0:c/d;let m;return c===0?m=0:d===r?m=((g-e)/c%6+6)%6:d===g?m=(e-r)/c+2:m=(r-g)/c+4,new u(Math.round(m*60),_,d,o.a)}static toRGBA(o){const{h:r,s:g,v:e,a:d}=o,h=e*g,c=h*(1-Math.abs(r/60%2-1)),_=e-h;let[m,y,w]=[0,0,0];return r<60?(m=h,y=c):r<120?(m=c,y=h):r<180?(y=h,w=c):r<240?(y=c,w=h):r<300?(m=c,w=h):r<=360&&(m=h,w=c),m=Math.round((m+_)*255),y=Math.round((y+_)*255),w=Math.round((w+_)*255),new M(m,y,w,d)}}n.HSVA=u;class f{static fromHex(o){return f.Format.CSS.parseHex(o)||f.red}static equals(o,r){return!o&&!r?!0:!o||!r?!1:o.equals(r)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:u.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof M)this.rgba=o;else if(o instanceof i)this._hsla=o,this.rgba=i.toRGBA(o);else if(o instanceof u)this._hsva=o,this.rgba=u.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&M.equals(this.rgba,o.rgba)&&i.equals(this.hsla,o.hsla)&&u.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=f._relativeLuminanceForComponent(this.rgba.r),r=f._relativeLuminanceForComponent(this.rgba.g),g=f._relativeLuminanceForComponent(this.rgba.b),e=.2126*o+.7152*r+.0722*g;return R(e,4)}static _relativeLuminanceForComponent(o){const r=o/255;return r<=.03928?r/12.92:Math.pow((r+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const r=this.getRelativeLuminance(),g=o.getRelativeLuminance();return r>g}isDarkerThan(o){const r=this.getRelativeLuminance(),g=o.getRelativeLuminance();return r<g}lighten(o){return new f(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new f(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r,g,b:e,a:d}=this.rgba;return new f(new M(r,g,e,d*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new f(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r,g,b:e,a:d}=this.rgba;return new f(new M(o.rgba.r-d*(o.rgba.r-r),o.rgba.g-d*(o.rgba.g-g),o.rgba.b-d*(o.rgba.b-e),1))}toString(){return this._toString||(this._toString=f.Format.CSS.format(this)),this._toString}static getLighterColor(o,r,g){if(o.isLighterThan(r))return o;g=g||.5;const e=o.getRelativeLuminance(),d=r.getRelativeLuminance();return g=g*(d-e)/d,o.lighten(g)}static getDarkerColor(o,r,g){if(o.isDarkerThan(r))return o;g=g||.5;const e=o.getRelativeLuminance(),d=r.getRelativeLuminance();return g=g*(e-d)/e,o.darken(g)}}n.Color=f,f.white=new f(new M(255,255,255,1)),f.black=new f(new M(0,0,0,1)),f.red=new f(new M(255,0,0,1)),f.blue=new f(new M(0,0,255,1)),f.green=new f(new M(0,255,0,1)),f.cyan=new f(new M(0,255,255,1)),f.lightgrey=new f(new M(211,211,211,1)),f.transparent=new f(new M(0,0,0,0)),function(v){let o;(function(r){let g;(function(e){function d(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:v.Format.CSS.formatRGBA(s)}e.formatRGB=d;function h(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}e.formatRGBA=h;function c(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:v.Format.CSS.formatHSLA(s)}e.formatHSL=c;function _(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}e.formatHSLA=_;function m(s){const a=s.toString(16);return a.length!==2?"0"+a:a}function y(s){return`#${m(s.rgba.r)}${m(s.rgba.g)}${m(s.rgba.b)}`}e.formatHex=y;function w(s,a=!1){return a&&s.rgba.a===1?v.Format.CSS.formatHex(s):`#${m(s.rgba.r)}${m(s.rgba.g)}${m(s.rgba.b)}${m(Math.round(s.rgba.a*255))}`}e.formatHexA=w;function N(s){return s.isOpaque()?v.Format.CSS.formatHex(s):v.Format.CSS.formatRGBA(s)}e.format=N;function C(s){const a=s.length;if(a===0||s.charCodeAt(0)!==35)return null;if(a===7){const l=16*S(s.charCodeAt(1))+S(s.charCodeAt(2)),p=16*S(s.charCodeAt(3))+S(s.charCodeAt(4)),b=16*S(s.charCodeAt(5))+S(s.charCodeAt(6));return new v(new M(l,p,b,1))}if(a===9){const l=16*S(s.charCodeAt(1))+S(s.charCodeAt(2)),p=16*S(s.charCodeAt(3))+S(s.charCodeAt(4)),b=16*S(s.charCodeAt(5))+S(s.charCodeAt(6)),L=16*S(s.charCodeAt(7))+S(s.charCodeAt(8));return new v(new M(l,p,b,L/255))}if(a===4){const l=S(s.charCodeAt(1)),p=S(s.charCodeAt(2)),b=S(s.charCodeAt(3));return new v(new M(16*l+l,16*p+p,16*b+b))}if(a===5){const l=S(s.charCodeAt(1)),p=S(s.charCodeAt(2)),b=S(s.charCodeAt(3)),L=S(s.charCodeAt(4));return new v(new M(16*l+l,16*p+p,16*b+b,(16*L+L)/255))}return null}e.parseHex=C;function S(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=r.CSS||(r.CSS={}))})(o=v.Format||(v.Format={}))}(f||(n.Color=f={}))}),ee(te[32],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class R{constructor(i,u,f,v){this.originalStart=i,this.originalLength=u,this.modifiedStart=f,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=R}),ee(te[4],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(m){setTimeout(()=>{throw m.stack?h.isErrorNoTelemetry(m)?new h(m.message+`

`+m.stack):new Error(m.message+`

`+m.stack):m},0)}}emit(m){this.listeners.forEach(y=>{y(m)})}onUnexpectedError(m){this.unexpectedErrorHandler(m),this.emit(m)}onUnexpectedExternalError(m){this.unexpectedErrorHandler(m)}}n.ErrorHandler=R,n.errorHandler=new R;function M(_){v(_)||n.errorHandler.onUnexpectedError(_)}n.onUnexpectedError=M;function i(_){v(_)||n.errorHandler.onUnexpectedExternalError(_)}n.onUnexpectedExternalError=i;function u(_){if(_ instanceof Error){const{name:m,message:y}=_,w=_.stacktrace||_.stack;return{$isError:!0,name:m,message:y,stack:w,noTelemetry:h.isErrorNoTelemetry(_)}}return _}n.transformErrorForSerialization=u;const f="Canceled";function v(_){return _ instanceof o?!0:_ instanceof Error&&_.name===f&&_.message===f}n.isCancellationError=v;class o extends Error{constructor(){super(f),this.name=this.message}}n.CancellationError=o;function r(){const _=new Error(f);return _.name=_.message,_}n.canceled=r;function g(_){return _?new Error(`Illegal argument: ${_}`):new Error("Illegal argument")}n.illegalArgument=g;function e(_){return _?new Error(`Illegal state: ${_}`):new Error("Illegal state")}n.illegalState=e;class d extends Error{constructor(m){super("NotSupported"),m&&(this.message=m)}}n.NotSupportedError=d;class h extends Error{constructor(m){super(m),this.name="CodeExpectedError"}static fromError(m){if(m instanceof h)return m;const y=new h;return y.message=m.message,y.stack=m.stack,y}static isErrorNoTelemetry(m){return m.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class c extends Error{constructor(m){super(m||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}n.BugIndicatingError=c}),ee(te[9],ne([0,1,4]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(v,o){if(!v)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}n.ok=M;function i(v,o="Unreachable"){throw new Error(o)}n.assertNever=i;function u(v){if(!v()){debugger;v(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}n.assertFn=u;function f(v,o){let r=0;for(;r<v.length-1;){const g=v[r],e=v[r+1];if(!o(g,e))return!1;r++}return!0}n.checkAdjacentItems=f}),ee(te[18],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function R(M){const i=this;let u=!1,f;return function(){return u||(u=!0,f=M.apply(i,arguments)),f}}n.once=R}),ee(te[19],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var R;(function(M){function i(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}M.is=i;const u=Object.freeze([]);function f(){return u}M.empty=f;function*v(C){yield C}M.single=v;function o(C){return i(C)?C:v(C)}M.wrap=o;function r(C){return C||u}M.from=r;function g(C){return!C||C[Symbol.iterator]().next().done===!0}M.isEmpty=g;function e(C){return C[Symbol.iterator]().next().value}M.first=e;function d(C,S){for(const s of C)if(S(s))return!0;return!1}M.some=d;function h(C,S){for(const s of C)if(S(s))return s}M.find=h;function*c(C,S){for(const s of C)S(s)&&(yield s)}M.filter=c;function*_(C,S){let s=0;for(const a of C)yield S(a,s++)}M.map=_;function*m(...C){for(const S of C)for(const s of S)yield s}M.concat=m;function y(C,S,s){let a=s;for(const l of C)a=S(a,l);return a}M.reduce=y;function*w(C,S,s=C.length){for(S<0&&(S+=C.length),s<0?s+=C.length:s>C.length&&(s=C.length);S<s;S++)yield C[S]}M.slice=w;function N(C,S=Number.POSITIVE_INFINITY){const s=[];if(S===0)return[s,C];const a=C[Symbol.iterator]();for(let l=0;l<S;l++){const p=a.next();if(p.done)return[s,M.empty()];s.push(p.value)}return[s,{[Symbol.iterator](){return a}}]}M.consume=N})(R||(n.Iterable=R={}))}),ee(te[33],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class R{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,h){this._keyCodeToStr[d]=h,this._strToKeyCode[h.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new R,i=new R,u=new R;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],v=Object.create(null),o=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",d=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],c=[];for(const _ of d){const[m,y,w,N,C,S,s,a,l]=_;if(c[y]||(c[y]=!0,f[y]=w,v[w]=y,o[w.toLowerCase()]=y,m&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=y))),!h[N]){if(h[N]=!0,!C)throw new Error(`String representation missing for key code ${N} around scan code ${w}`);M.define(N,C),i.define(N,a||C),u.define(N,l||a||C)}S&&(n.EVENT_KEY_CODE_MAP[S]=N),s&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var r;(function(e){function d(w){return M.keyCodeToStr(w)}e.toString=d;function h(w){return M.strToKeyCode(w)}e.fromString=h;function c(w){return i.keyCodeToStr(w)}e.toUserSettingsUS=c;function _(w){return u.keyCodeToStr(w)}e.toUserSettingsGeneral=_;function m(w){return i.strToKeyCode(w)||u.strToKeyCode(w)}e.fromUserSettings=m;function y(w){if(w>=98&&w<=113)return null;switch(w){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(w)}e.toElectronAccelerator=y})(r||(n.KeyCodeUtils=r={}));function g(e,d){const h=(d&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=g}),ee(te[34],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class R{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=R}),ee(te[10],ne([0,1,18,19]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let u=null;function f(s){u=s}if(n.setDisposableTracker=f,i){const s="__is_disposable_tracked__";f(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==y.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function v(s){return u?.trackDisposable(s),s}function o(s){u?.markAsDisposed(s)}function r(s,a){u?.setParent(s,a)}function g(s,a){if(u)for(const l of s)u.setParent(l,a)}function e(s){return u?.markAsSingleton(s),s}n.markAsSingleton=e;function d(s){return typeof s.dispose=="function"&&s.dispose.length===0}n.isDisposable=d;function h(s){if(M.Iterable.is(s)){const a=[];for(const l of s)if(l)try{l.dispose()}catch(p){a.push(p)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}n.dispose=h;function c(...s){const a=_(()=>h(s));return g(s,a),a}n.combinedDisposable=c;function _(s){const a=v({dispose:(0,R.once)(()=>{o(a),s()})});return a}n.toDisposable=_;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,v(this)}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{h(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return r(a,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}n.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new m,v(this),r(this._store,this)}dispose(){o(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,v(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var l;this._isDisposed||a===this._value||((l=this._value)===null||l===void 0||l.dispose(),a&&r(a,this),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,o(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}n.MutableDisposable=w;class N{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class C{constructor(a){this.object=a}dispose(){}}n.ImmortalReference=C;class S{constructor(){this._store=new Map,this._isDisposed=!1,v(this)}dispose(){o(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{h(this._store.values())}finally{this._store.clear()}}get(a){return this._store.get(a)}set(a,l,p=!1){var b;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||(b=this._store.get(a))===null||b===void 0||b.dispose(),this._store.set(a,l)}deleteAndDispose(a){var l;(l=this._store.get(a))===null||l===void 0||l.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=S}),ee(te[20],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class R{constructor(u){this.element=u,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class M{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let u=this._first;for(;u!==R.Undefined;){const f=u.next;u.prev=R.Undefined,u.next=R.Undefined,u=f}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,f){const v=new R(u);if(this._first===R.Undefined)this._first=v,this._last=v;else if(f){const r=this._last;this._last=v,v.prev=r,r.next=v}else{const r=this._first;this._first=v,v.next=r,r.prev=v}this._size+=1;let o=!1;return()=>{o||(o=!0,this._remove(v))}}shift(){if(this._first!==R.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==R.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==R.Undefined&&u.next!==R.Undefined){const f=u.prev;f.next=u.next,u.next.prev=f}else u.prev===R.Undefined&&u.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):u.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):u.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==R.Undefined;)yield u.element,u=u.next}}n.LinkedList=M}),ee(te[21],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(u){return new M(u)}constructor(u){this._now=R&&u===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=M}),ee(te[7],ne([0,1,4,18,10,20,21]),function(O,n,R,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const v=!1,o=!1;var r;(function(b){b.None=()=>i.Disposable.None;function L(Y){if(o){const{onDidAddListener:H}=Y,X=h.create();let J=0;Y.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),H?.()}}}function A(Y,H){return j(Y,()=>{},0,void 0,!0,void 0,H)}b.defer=A;function E(Y){return(H,X=null,J)=>{let ie=!1,le;return le=Y(ue=>{if(!ie)return le?le.dispose():ie=!0,H.call(X,ue)},null,J),ie&&le.dispose(),le}}b.once=E;function P(Y,H,X){return W((J,ie=null,le)=>Y(ue=>J.call(ie,H(ue)),null,le),X)}b.map=P;function T(Y,H,X){return W((J,ie=null,le)=>Y(ue=>{H(ue),J.call(ie,ue)},null,le),X)}b.forEach=T;function k(Y,H,X){return W((J,ie=null,le)=>Y(ue=>H(ue)&&J.call(ie,ue),null,le),X)}b.filter=k;function D(Y){return Y}b.signal=D;function F(...Y){return(H,X=null,J)=>(0,i.combinedDisposable)(...Y.map(ie=>ie(le=>H.call(X,le),null,J)))}b.any=F;function V(Y,H,X,J){let ie=X;return P(Y,le=>(ie=H(ie,le),ie),J)}b.reduce=V;function W(Y,H){let X;const J={onWillAddFirstListener(){X=Y(ie.fire,ie)},onDidRemoveLastListener(){X?.dispose()}};H||L(J);const ie=new y(J);return H?.add(ie),ie.event}function j(Y,H,X=100,J=!1,ie=!1,le,ue){let me,I,B,G=0,Z;const re={leakWarningThreshold:le,onWillAddFirstListener(){me=Y(be=>{G++,I=H(I,be),J&&!B&&(he.fire(I),I=void 0),Z=()=>{const Se=I;I=void 0,B=void 0,(!J||G>1)&&he.fire(Se),G=0},typeof X=="number"?(clearTimeout(B),B=setTimeout(Z,X)):B===void 0&&(B=0,queueMicrotask(Z))})},onWillRemoveListener(){ie&&G>0&&Z?.()},onDidRemoveLastListener(){Z=void 0,me.dispose()}};ue||L(re);const he=new y(re);return ue?.add(he),he.event}b.debounce=j;function z(Y,H=0,X){return b.debounce(Y,(J,ie)=>J?(J.push(ie),J):[ie],H,void 0,!0,void 0,X)}b.accumulate=z;function K(Y,H=(J,ie)=>J===ie,X){let J=!0,ie;return k(Y,le=>{const ue=J||!H(le,ie);return J=!1,ie=le,ue},X)}b.latch=K;function se(Y,H,X){return[b.filter(Y,H,X),b.filter(Y,J=>!H(J),X)]}b.split=se;function t(Y,H=!1,X=[]){let J=X.slice(),ie=Y(me=>{J?J.push(me):ue.fire(me)});const le=()=>{J?.forEach(me=>ue.fire(me)),J=null},ue=new y({onWillAddFirstListener(){ie||(ie=Y(me=>ue.fire(me)))},onDidAddFirstListener(){J&&(H?setTimeout(le):le())},onDidRemoveLastListener(){ie&&ie.dispose(),ie=null}});return ue.event}b.buffer=t;class x{constructor(H){this.event=H,this.disposables=new i.DisposableStore}map(H){return new x(P(this.event,H,this.disposables))}forEach(H){return new x(T(this.event,H,this.disposables))}filter(H){return new x(k(this.event,H,this.disposables))}reduce(H,X){return new x(V(this.event,H,X,this.disposables))}latch(){return new x(K(this.event,void 0,this.disposables))}debounce(H,X=100,J=!1,ie=!1,le){return new x(j(this.event,H,X,J,ie,le,this.disposables))}on(H,X,J){return this.event(H,X,J)}once(H,X,J){return E(this.event)(H,X,J)}dispose(){this.disposables.dispose()}}function U(Y){return new x(Y)}b.chain=U;function q(Y,H,X=J=>J){const J=(...me)=>ue.fire(X(...me)),ie=()=>Y.on(H,J),le=()=>Y.removeListener(H,J),ue=new y({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return ue.event}b.fromNodeEventEmitter=q;function $(Y,H,X=J=>J){const J=(...me)=>ue.fire(X(...me)),ie=()=>Y.addEventListener(H,J),le=()=>Y.removeEventListener(H,J),ue=new y({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return ue.event}b.fromDOMEventEmitter=$;function Q(Y){return new Promise(H=>E(Y)(H))}b.toPromise=Q;function ae(Y){const H=new y;return Y.then(X=>{H.fire(X)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}b.fromPromise=ae;function oe(Y,H){return H(void 0),Y(X=>H(X))}b.runAndSubscribe=oe;function ce(Y,H){let X=null;function J(le){X?.dispose(),X=new i.DisposableStore,H(le,X)}J(void 0);const ie=Y(le=>J(le));return(0,i.toDisposable)(()=>{ie.dispose(),X?.dispose()})}b.runAndSubscribeWithStore=ce;class fe{constructor(H,X){this._observable=H,this._counter=0,this._hasChanged=!1;const J={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};X||L(J),this.emitter=new y(J),X&&X.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,X){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function _e(Y,H){return new fe(Y,H).emitter.event}b.fromObservable=_e;function Le(Y){return H=>{let X=0,J=!1;const ie={beginUpdate(){X++},endUpdate(){X--,X===0&&(Y.reportChanges(),J&&(J=!1,H()))},handlePossibleChange(){},handleChange(){J=!0}};return Y.addObserver(ie),Y.reportChanges(),{dispose(){Y.removeObserver(ie)}}}}b.fromObservableLight=Le})(r||(n.Event=r={}));class g{constructor(L){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${L}_${g._idPool++}`,g.all.add(this)}start(L){this._stopWatch=new f.StopWatch,this.listenerCount=L}stop(){if(this._stopWatch){const L=this._stopWatch.elapsed();this.durations.push(L),this.elapsedOverall+=L,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=g,g.all=new Set,g._idPool=0;let e=-1;class d{constructor(L,A=Math.random().toString(18).slice(2,5)){this.threshold=L,this.name=A,this._warnCountdown=0}dispose(){var L;(L=this._stacks)===null||L===void 0||L.clear()}check(L,A){const E=this.threshold;if(E<=0||A<E)return;this._stacks||(this._stacks=new Map);const P=this._stacks.get(L.value)||0;if(this._stacks.set(L.value,P+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let T,k=0;for(const[D,F]of this._stacks)(!T||k<F)&&(T=D,k=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${k}):`),console.warn(T)}return()=>{const T=this._stacks.get(L.value)||0;this._stacks.set(L.value,T-1)}}}class h{static create(){var L;return new h((L=new Error().stack)!==null&&L!==void 0?L:"")}constructor(L){this.value=L}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class c{constructor(L){this.value=L}}const _=2,m=(b,L)=>{if(b instanceof c)L(b);else for(let A=0;A<b.length;A++){const E=b[A];E&&L(E)}};class y{constructor(L){var A,E,P,T,k;this._size=0,this._options=L,this._leakageMon=e>0||!((A=this._options)===null||A===void 0)&&A.leakWarningThreshold?new d((P=(E=this._options)===null||E===void 0?void 0:E.leakWarningThreshold)!==null&&P!==void 0?P:e):void 0,this._perfMon=!((T=this._options)===null||T===void 0)&&T._profName?new g(this._options._profName):void 0,this._deliveryQueue=(k=this._options)===null||k===void 0?void 0:k.deliveryQueue}dispose(){var L,A,E,P;if(!this._disposed){if(this._disposed=!0,((L=this._deliveryQueue)===null||L===void 0?void 0:L.current)===this&&this._deliveryQueue.reset(),this._listeners){if(v){const T=this._listeners;queueMicrotask(()=>{m(T,k=>{var D;return(D=k.stack)===null||D===void 0?void 0:D.print()})})}this._listeners=void 0,this._size=0}(E=(A=this._options)===null||A===void 0?void 0:A.onDidRemoveLastListener)===null||E===void 0||E.call(A),(P=this._leakageMon)===null||P===void 0||P.dispose()}}get event(){var L;return(L=this._event)!==null&&L!==void 0||(this._event=(A,E,P)=>{var T,k,D,F,V;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;E&&(A=A.bind(E));const W=new c(A);let j,z;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(W.stack=h.create(),j=this._leakageMon.check(W.stack,this._size+1)),v&&(W.stack=z??h.create()),this._listeners?this._listeners instanceof c?((V=this._deliveryQueue)!==null&&V!==void 0||(this._deliveryQueue=new N),this._listeners=[this._listeners,W]):this._listeners.push(W):((k=(T=this._options)===null||T===void 0?void 0:T.onWillAddFirstListener)===null||k===void 0||k.call(T,this),this._listeners=W,(F=(D=this._options)===null||D===void 0?void 0:D.onDidAddFirstListener)===null||F===void 0||F.call(D,this)),this._size++;const K=(0,i.toDisposable)(()=>{j?.(),this._removeListener(W)});return P instanceof i.DisposableStore?P.add(K):Array.isArray(P)&&P.push(K),K}),this._event}_removeListener(L){var A,E,P,T;if((E=(A=this._options)===null||A===void 0?void 0:A.onWillRemoveListener)===null||E===void 0||E.call(A,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(T=(P=this._options)===null||P===void 0?void 0:P.onDidRemoveLastListener)===null||T===void 0||T.call(P,this),this._size=0;return}const k=this._listeners,D=k.indexOf(L);if(D===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,k[D]=void 0;const F=this._deliveryQueue.current===this;if(this._size*_<=k.length){let V=0;for(let W=0;W<k.length;W++)k[W]?k[V++]=k[W]:F&&(this._deliveryQueue.end--,V<this._deliveryQueue.i&&this._deliveryQueue.i--);k.length=V}}_deliver(L,A){var E;if(!L)return;const P=((E=this._options)===null||E===void 0?void 0:E.onListenerError)||R.onUnexpectedError;if(!P){L.value(A);return}try{L.value(A)}catch(T){P(T)}}_deliverQueue(L){const A=L.current._listeners;for(;L.i<L.end;)this._deliver(A[L.i++],L.value);L.reset()}fire(L){var A,E,P,T;if(!((A=this._deliveryQueue)===null||A===void 0)&&A.current&&(this._deliverQueue(this._deliveryQueue),(E=this._perfMon)===null||E===void 0||E.stop()),(P=this._perfMon)===null||P===void 0||P.start(this._size),this._listeners)if(this._listeners instanceof c)this._deliver(this._listeners,L);else{const k=this._deliveryQueue;k.enqueue(this,L,this._listeners.length),this._deliverQueue(k)}(T=this._perfMon)===null||T===void 0||T.stop()}hasListeners(){return this._size>0}}n.Emitter=y;const w=()=>new N;n.createEventDeliveryQueue=w;class N{constructor(){this.i=-1,this.end=0}enqueue(L,A,E){this.i=0,this.end=E,this.current=L,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class C extends y{constructor(L){super(L),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=L?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const L=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(L))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(L){this._size&&(this._isPaused!==0?this._eventQueue.push(L):super.fire(L))}}n.PauseableEmitter=C;class S extends C{constructor(L){var A;super(L),this._delay=(A=L.delay)!==null&&A!==void 0?A:100}fire(L){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(L)}}n.DebounceEmitter=S;class s extends y{constructor(L){super(L),this._queuedEvents=[],this._mergeFn=L?.merge}fire(L){this.hasListeners()&&(this._queuedEvents.push(L),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(A=>super.fire(A)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=s;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(L){const A={event:L,listener:null};this.events.push(A),this.hasListeners&&this.hook(A);const E=()=>{this.hasListeners&&this.unhook(A);const P=this.events.indexOf(A);this.events.splice(P,1)};return(0,i.toDisposable)((0,M.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(L=>this.hook(L))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(L=>this.unhook(L))}hook(L){L.listener=L.event(A=>this.emitter.fire(A))}unhook(L){L.listener&&L.listener.dispose(),L.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=a;class l{constructor(){this.buffers=[]}wrapEvent(L){return(A,E,P)=>L(T=>{const k=this.buffers[this.buffers.length-1];k?k.push(()=>A.call(E,T)):A.call(E,T)},void 0,P)}bufferEvents(L){const A=[];this.buffers.push(A);const E=L();return this.buffers.pop(),A.forEach(P=>P()),E}}n.EventBufferer=l;class p{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=i.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(L){this.inputEvent=L,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=L(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=p}),ee(te[35],ne([0,1,7]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(v,o){const r=setTimeout(v.bind(o),0);return{dispose(){clearTimeout(r)}}});var i;(function(v){function o(r){return r===v.None||r===v.Cancelled||r instanceof u?!0:!r||typeof r!="object"?!1:typeof r.isCancellationRequested=="boolean"&&typeof r.onCancellationRequested=="function"}v.isCancellationToken=o,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i||(n.CancellationToken=i={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class f{constructor(o){this._token=void 0,this._parentListener=void 0,this._parentListener=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(o=!1){var r;o&&this.cancel(),(r=this._parentListener)===null||r===void 0||r.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=f}),ee(te[5],ne([0,1,29,34]),function(O,n,R,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function u(I){return!I||typeof I!="string"?!0:I.trim().length===0}n.isFalsyOrWhitespace=u;const f=/{(\d+)}/g;function v(I,...B){return B.length===0?I:I.replace(f,function(G,Z){const re=parseInt(Z,10);return isNaN(re)||re<0||re>=B.length?G:B[re]})}n.format=v;function o(I){return I.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=o;function r(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=r;function g(I,B=" "){const G=e(I,B);return d(G,B)}n.trim=g;function e(I,B){if(!I||!B)return I;const G=B.length;if(G===0||I.length===0)return I;let Z=0;for(;I.indexOf(B,Z)===Z;)Z=Z+G;return I.substring(Z)}n.ltrim=e;function d(I,B){if(!I||!B)return I;const G=B.length,Z=I.length;if(G===0||Z===0)return I;let re=Z,he=-1;for(;he=I.lastIndexOf(B,re-1),!(he===-1||he+G!==re);){if(he===0)return"";re=he}return I.substring(0,re)}n.rtrim=d;function h(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function c(I){return I.replace(/\*/g,"")}n.stripWildcards=c;function _(I,B,G={}){if(!I)throw new Error("Cannot create regex from empty string");B||(I=r(I)),G.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Z="";return G.global&&(Z+="g"),G.matchCase||(Z+="i"),G.multiline&&(Z+="m"),G.unicode&&(Z+="u"),new RegExp(I,Z)}n.createRegExp=_;function m(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}n.regExpLeadsToEndlessLoop=m;function y(I){return I.split(/\r\n|\r|\n/)}n.splitLines=y;function w(I){for(let B=0,G=I.length;B<G;B++){const Z=I.charCodeAt(B);if(Z!==32&&Z!==9)return B}return-1}n.firstNonWhitespaceIndex=w;function N(I,B=0,G=I.length){for(let Z=B;Z<G;Z++){const re=I.charCodeAt(Z);if(re!==32&&re!==9)return I.substring(B,Z)}return I.substring(B,G)}n.getLeadingWhitespace=N;function C(I,B=I.length-1){for(let G=B;G>=0;G--){const Z=I.charCodeAt(G);if(Z!==32&&Z!==9)return G}return-1}n.lastNonWhitespaceIndex=C;function S(I,B){return I<B?-1:I>B?1:0}n.compare=S;function s(I,B,G=0,Z=I.length,re=0,he=B.length){for(;G<Z&&re<he;G++,re++){const we=I.charCodeAt(G),de=B.charCodeAt(re);if(we<de)return-1;if(we>de)return 1}const be=Z-G,Se=he-re;return be<Se?-1:be>Se?1:0}n.compareSubstring=s;function a(I,B){return l(I,B,0,I.length,0,B.length)}n.compareIgnoreCase=a;function l(I,B,G=0,Z=I.length,re=0,he=B.length){for(;G<Z&&re<he;G++,re++){let we=I.charCodeAt(G),de=B.charCodeAt(re);if(we===de)continue;if(we>=128||de>=128)return s(I.toLowerCase(),B.toLowerCase(),G,Z,re,he);b(we)&&(we-=32),b(de)&&(de-=32);const pe=we-de;if(pe!==0)return pe}const be=Z-G,Se=he-re;return be<Se?-1:be>Se?1:0}n.compareSubstringIgnoreCase=l;function p(I){return I>=48&&I<=57}n.isAsciiDigit=p;function b(I){return I>=97&&I<=122}n.isLowerAsciiLetter=b;function L(I){return I>=65&&I<=90}n.isUpperAsciiLetter=L;function A(I,B){return I.length===B.length&&l(I,B)===0}n.equalsIgnoreCase=A;function E(I,B){const G=B.length;return B.length>I.length?!1:l(I,B,0,G)===0}n.startsWithIgnoreCase=E;function P(I,B){const G=Math.min(I.length,B.length);let Z;for(Z=0;Z<G;Z++)if(I.charCodeAt(Z)!==B.charCodeAt(Z))return Z;return G}n.commonPrefixLength=P;function T(I,B){const G=Math.min(I.length,B.length);let Z;const re=I.length-1,he=B.length-1;for(Z=0;Z<G;Z++)if(I.charCodeAt(re-Z)!==B.charCodeAt(he-Z))return Z;return G}n.commonSuffixLength=T;function k(I){return 55296<=I&&I<=56319}n.isHighSurrogate=k;function D(I){return 56320<=I&&I<=57343}n.isLowSurrogate=D;function F(I,B){return(I-55296<<10)+(B-56320)+65536}n.computeCodePoint=F;function V(I,B,G){const Z=I.charCodeAt(G);if(k(Z)&&G+1<B){const re=I.charCodeAt(G+1);if(D(re))return F(Z,re)}return Z}n.getNextCodePoint=V;function W(I,B){const G=I.charCodeAt(B-1);if(D(G)&&B>1){const Z=I.charCodeAt(B-2);if(k(Z))return F(Z,G)}return G}class j{get offset(){return this._offset}constructor(B,G=0){this._str=B,this._len=B.length,this._offset=G}setOffset(B){this._offset=B}prevCodePoint(){const B=W(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=V(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=j;class z{get offset(){return this._iterator.offset}constructor(B,G=0){this._iterator=new j(B,G)}nextGraphemeLength(){const B=H.getInstance(),G=this._iterator,Z=G.offset;let re=B.getGraphemeBreakType(G.nextCodePoint());for(;!G.eol();){const he=G.offset,be=B.getGraphemeBreakType(G.nextCodePoint());if(Y(re,be)){G.setOffset(he);break}re=be}return G.offset-Z}prevGraphemeLength(){const B=H.getInstance(),G=this._iterator,Z=G.offset;let re=B.getGraphemeBreakType(G.prevCodePoint());for(;G.offset>0;){const he=G.offset,be=B.getGraphemeBreakType(G.prevCodePoint());if(Y(be,re)){G.setOffset(he);break}re=be}return Z-G.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=z;function K(I,B){return new z(I,B).nextGraphemeLength()}n.nextCharLength=K;function se(I,B){return new z(I,B).prevGraphemeLength()}n.prevCharLength=se;function t(I,B){B>0&&D(I.charCodeAt(B))&&B--;const G=B+K(I,B);return[G-se(I,G),G]}n.getCharContainingOffset=t;let x;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(I){return x||(x=U()),x.test(I)}n.containsRTL=q;const $=/^[\t\n\r\x20-\x7E]*$/;function Q(I){return $.test(I)}n.isBasicASCII=Q,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ae(I){return n.UNUSUAL_LINE_TERMINATORS.test(I)}n.containsUnusualLineTerminators=ae;function oe(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}n.isFullWidthCharacter=oe;function ce(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}n.isEmojiImprecise=ce,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function fe(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}n.startsWithUTF8BOM=fe;function _e(I,B=!1){return I?(B&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}n.containsUppercaseCharacter=_e;function Le(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}n.singleLetterHash=Le;function Y(I,B){return I===0?B!==5&&B!==7:I===2&&B===3?!1:I===4||I===2||I===3||B===4||B===2||B===3?!0:!(I===8&&(B===8||B===9||B===11||B===12)||(I===11||I===9)&&(B===9||B===10)||(I===12||I===10)&&B===10||B===5||B===13||B===7||I===1||I===13&&B===14||I===6&&B===6)}class H{static getInstance(){return H._INSTANCE||(H._INSTANCE=new H),H._INSTANCE}constructor(){this._data=X()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const G=this._data,Z=G.length/3;let re=1;for(;re<=Z;)if(B<G[3*re])re=2*re;else if(B>G[3*re+1])re=2*re+1;else return G[3*re+2];return 0}}H._INSTANCE=null;function X(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function J(I,B){if(I===0)return 0;const G=ie(I,B);if(G!==void 0)return G;const Z=new j(B,I);return Z.prevCodePoint(),Z.offset}n.getLeftDeleteOffset=J;function ie(I,B){const G=new j(B,I);let Z=G.prevCodePoint();for(;le(Z)||Z===65039||Z===8419;){if(G.offset===0)return;Z=G.prevCodePoint()}if(!ce(Z))return;let re=G.offset;return re>0&&G.prevCodePoint()===8205&&(re=G.offset),re}function le(I){return 127995<=I&&I<=127999}n.noBreakWhitespace="\xA0";class ue{static getInstance(B){return i.cache.get(Array.from(B))}static getLocales(){return i._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=ue,i=ue,ue.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.cache=new R.LRUCachedFunction(I=>{function B(de){const pe=new Map;for(let Ce=0;Ce<de.length;Ce+=2)pe.set(de[Ce],de[Ce+1]);return pe}function G(de,pe){const Ce=new Map(de);for(const[ye,Ne]of pe)Ce.set(ye,Ne);return Ce}function Z(de,pe){if(!de)return pe;const Ce=new Map;for(const[ye,Ne]of de)pe.has(ye)&&Ce.set(ye,Ne);return Ce}const re=i.ambiguousCharacterData.value;let he=I.filter(de=>!de.startsWith("_")&&de in re);he.length===0&&(he=["_default"]);let be;for(const de of he){const pe=B(re[de]);be=Z(be,pe)}const Se=B(re._common),we=G(Se,be);return new i(we)}),ue._locales=new M.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(I=>!I.startsWith("_")));class me{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(me.getRawData())),this._data}static isInvisibleCharacter(B){return me.getData().has(B)}static get codePoints(){return me.getData()}}n.InvisibleCharacters=me,me._data=void 0}),ee(te[36],ne([0,1,5]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(_){return i(_,0)}n.hash=M;function i(_,m){switch(typeof _){case"object":return _===null?u(349,m):Array.isArray(_)?o(_,m):r(_,m);case"string":return v(_,m);case"boolean":return f(_,m);case"number":return u(_,m);case"undefined":return u(937,m);default:return u(617,m)}}n.doHash=i;function u(_,m){return(m<<5)-m+_|0}n.numberHash=u;function f(_,m){return u(_?433:863,m)}function v(_,m){m=u(149417,m);for(let y=0,w=_.length;y<w;y++)m=u(_.charCodeAt(y),m);return m}n.stringHash=v;function o(_,m){return m=u(104579,m),_.reduce((y,w)=>i(w,y),m)}function r(_,m){return m=u(181387,m),Object.keys(_).sort().reduce((y,w)=>(y=v(w,y),i(_[w],y)),m)}function g(_,m,y=32){const w=y-m,N=~((1<<w)-1);return(_<<m|(N&_)>>>w)>>>0}function e(_,m=0,y=_.byteLength,w=0){for(let N=0;N<y;N++)_[m+N]=w}function d(_,m,y="0"){for(;_.length<m;)_=y+_;return _}function h(_,m=32){return _ instanceof ArrayBuffer?Array.from(new Uint8Array(_)).map(y=>y.toString(16).padStart(2,"0")).join(""):d((_>>>0).toString(16),m/4)}n.toHexString=h;class c{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const y=m.length;if(y===0)return;const w=this._buff;let N=this._buffLen,C=this._leftoverHighSurrogate,S,s;for(C!==0?(S=C,s=-1,C=0):(S=m.charCodeAt(0),s=0);;){let a=S;if(R.isHighSurrogate(S))if(s+1<y){const l=m.charCodeAt(s+1);R.isLowSurrogate(l)?(s++,a=R.computeCodePoint(S,l)):a=65533}else{C=S;break}else R.isLowSurrogate(S)&&(a=65533);if(N=this._push(w,N,a),s++,s<y)S=m.charCodeAt(s);else break}this._buffLen=N,this._leftoverHighSurrogate=C}_push(m,y,w){return w<128?m[y++]=w:w<2048?(m[y++]=192|(w&1984)>>>6,m[y++]=128|(w&63)>>>0):w<65536?(m[y++]=224|(w&61440)>>>12,m[y++]=128|(w&4032)>>>6,m[y++]=128|(w&63)>>>0):(m[y++]=240|(w&1835008)>>>18,m[y++]=128|(w&258048)>>>12,m[y++]=128|(w&4032)>>>6,m[y++]=128|(w&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=c._bigBlock32,y=this._buffDV;for(let b=0;b<64;b+=4)m.setUint32(b,y.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)m.setUint32(b,g(m.getUint32(b-12,!1)^m.getUint32(b-32,!1)^m.getUint32(b-56,!1)^m.getUint32(b-64,!1),1),!1);let w=this._h0,N=this._h1,C=this._h2,S=this._h3,s=this._h4,a,l,p;for(let b=0;b<80;b++)b<20?(a=N&C|~N&S,l=1518500249):b<40?(a=N^C^S,l=1859775393):b<60?(a=N&C|N&S|C&S,l=2400959708):(a=N^C^S,l=3395469782),p=g(w,5)+a+s+l+m.getUint32(b*4,!1)&4294967295,s=S,S=C,C=g(N,30),N=w,w=p;this._h0=this._h0+w&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+C&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+s&4294967295}}n.StringSHA1=c,c._bigBlock32=new DataView(new ArrayBuffer(320))}),ee(te[22],ne([0,1,32,36]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,d=new Int32Array(e.length);for(let h=0,c=e.length;h<c;h++)d[h]=e.charCodeAt(h);return d}}n.StringDiffSequence=i;function u(g,e,d){return new r(new i(g),new i(e)).ComputeDiff(d).changes}n.stringDiff=u;class f{static Assert(e,d){if(!e)throw new Error(d)}}class v{static Copy(e,d,h,c,_){for(let m=0;m<_;m++)h[c+m]=e[d+m]}static Copy2(e,d,h,c,_){for(let m=0;m<_;m++)h[c+m]=e[d+m]}}class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new R.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,d){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_originalCount++}AddModifiedElement(e,d){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,d),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class r{constructor(e,d,h=null){this.ContinueProcessingPredicate=h,this._originalSequence=e,this._modifiedSequence=d;const[c,_,m]=r._getElements(e),[y,w,N]=r._getElements(d);this._hasStrings=m&&N,this._originalStringElements=c,this._originalElementsOrHash=_,this._modifiedStringElements=y,this._modifiedElementsOrHash=w,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const d=e.getElements();if(r._isStringArray(d)){const h=new Int32Array(d.length);for(let c=0,_=d.length;c<_;c++)h[c]=(0,M.stringHash)(d[c],0);return[d,h,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}ElementsAreEqual(e,d){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[d]:!0}ElementsAreStrictEqual(e,d){if(!this.ElementsAreEqual(e,d))return!1;const h=r._getStrictElement(this._originalSequence,e),c=r._getStrictElement(this._modifiedSequence,d);return h===c}static _getStrictElement(e,d){return typeof e.getStrictElement=="function"?e.getStrictElement(d):null}OriginalElementsAreEqual(e,d){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[d]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[d]:!0}ModifiedElementsAreEqual(e,d){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[d]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[d]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,d,h,c,_){const m=[!1];let y=this.ComputeDiffRecursive(e,d,h,c,m);return _&&(y=this.PrettifyChanges(y)),{quitEarly:m[0],changes:y}}ComputeDiffRecursive(e,d,h,c,_){for(_[0]=!1;e<=d&&h<=c&&this.ElementsAreEqual(e,h);)e++,h++;for(;d>=e&&c>=h&&this.ElementsAreEqual(d,c);)d--,c--;if(e>d||h>c){let S;return h<=c?(f.Assert(e===d+1,"originalStart should only be one more than originalEnd"),S=[new R.DiffChange(e,0,h,c-h+1)]):e<=d?(f.Assert(h===c+1,"modifiedStart should only be one more than modifiedEnd"),S=[new R.DiffChange(e,d-e+1,h,0)]):(f.Assert(e===d+1,"originalStart should only be one more than originalEnd"),f.Assert(h===c+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const m=[0],y=[0],w=this.ComputeRecursionPoint(e,d,h,c,m,y,_),N=m[0],C=y[0];if(w!==null)return w;if(!_[0]){const S=this.ComputeDiffRecursive(e,N,h,C,_);let s=[];return _[0]?s=[new R.DiffChange(N+1,d-(N+1)+1,C+1,c-(C+1)+1)]:s=this.ComputeDiffRecursive(N+1,d,C+1,c,_),this.ConcatenateChanges(S,s)}return[new R.DiffChange(e,d-e+1,h,c-h+1)]}WALKTRACE(e,d,h,c,_,m,y,w,N,C,S,s,a,l,p,b,L,A){let E=null,P=null,T=new o,k=d,D=h,F=a[0]-b[0]-c,V=-1073741824,W=this.m_forwardHistory.length-1;do{const j=F+e;j===k||j<D&&N[j-1]<N[j+1]?(S=N[j+1],l=S-F-c,S<V&&T.MarkNextChange(),V=S,T.AddModifiedElement(S+1,l),F=j+1-e):(S=N[j-1]+1,l=S-F-c,S<V&&T.MarkNextChange(),V=S-1,T.AddOriginalElement(S,l+1),F=j-1-e),W>=0&&(N=this.m_forwardHistory[W],e=N[0],k=1,D=N.length-1)}while(--W>=-1);if(E=T.getReverseChanges(),A[0]){let j=a[0]+1,z=b[0]+1;if(E!==null&&E.length>0){const K=E[E.length-1];j=Math.max(j,K.getOriginalEnd()),z=Math.max(z,K.getModifiedEnd())}P=[new R.DiffChange(j,s-j+1,z,p-z+1)]}else{T=new o,k=m,D=y,F=a[0]-b[0]-w,V=1073741824,W=L?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const j=F+_;j===k||j<D&&C[j-1]>=C[j+1]?(S=C[j+1]-1,l=S-F-w,S>V&&T.MarkNextChange(),V=S+1,T.AddOriginalElement(S+1,l+1),F=j+1-_):(S=C[j-1],l=S-F-w,S>V&&T.MarkNextChange(),V=S,T.AddModifiedElement(S+1,l+1),F=j-1-_),W>=0&&(C=this.m_reverseHistory[W],_=C[0],k=1,D=C.length-1)}while(--W>=-1);P=T.getChanges()}return this.ConcatenateChanges(E,P)}ComputeRecursionPoint(e,d,h,c,_,m,y){let w=0,N=0,C=0,S=0,s=0,a=0;e--,h--,_[0]=0,m[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=d-e+(c-h),p=l+1,b=new Int32Array(p),L=new Int32Array(p),A=c-h,E=d-e,P=e-h,T=d-c,D=(E-A)%2===0;b[A]=e,L[E]=d,y[0]=!1;for(let F=1;F<=l/2+1;F++){let V=0,W=0;C=this.ClipDiagonalBound(A-F,F,A,p),S=this.ClipDiagonalBound(A+F,F,A,p);for(let z=C;z<=S;z+=2){z===C||z<S&&b[z-1]<b[z+1]?w=b[z+1]:w=b[z-1]+1,N=w-(z-A)-P;const K=w;for(;w<d&&N<c&&this.ElementsAreEqual(w+1,N+1);)w++,N++;if(b[z]=w,w+N>V+W&&(V=w,W=N),!D&&Math.abs(z-E)<=F-1&&w>=L[z])return _[0]=w,m[0]=N,K<=L[z]&&1447>0&&F<=1447+1?this.WALKTRACE(A,C,S,P,E,s,a,T,b,L,w,d,_,N,c,m,D,y):null}const j=(V-e+(W-h)-F)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(V,j))return y[0]=!0,_[0]=V,m[0]=W,j>0&&1447>0&&F<=1447+1?this.WALKTRACE(A,C,S,P,E,s,a,T,b,L,w,d,_,N,c,m,D,y):(e++,h++,[new R.DiffChange(e,d-e+1,h,c-h+1)]);s=this.ClipDiagonalBound(E-F,F,E,p),a=this.ClipDiagonalBound(E+F,F,E,p);for(let z=s;z<=a;z+=2){z===s||z<a&&L[z-1]>=L[z+1]?w=L[z+1]-1:w=L[z-1],N=w-(z-E)-T;const K=w;for(;w>e&&N>h&&this.ElementsAreEqual(w,N);)w--,N--;if(L[z]=w,D&&Math.abs(z-A)<=F&&w<=b[z])return _[0]=w,m[0]=N,K>=b[z]&&1447>0&&F<=1447+1?this.WALKTRACE(A,C,S,P,E,s,a,T,b,L,w,d,_,N,c,m,D,y):null}if(F<=1447){let z=new Int32Array(S-C+2);z[0]=A-C+1,v.Copy2(b,C,z,1,S-C+1),this.m_forwardHistory.push(z),z=new Int32Array(a-s+2),z[0]=E-s+1,v.Copy2(L,s,z,1,a-s+1),this.m_reverseHistory.push(z)}}return this.WALKTRACE(A,C,S,P,E,s,a,T,b,L,w,d,_,N,c,m,D,y)}PrettifyChanges(e){for(let d=0;d<e.length;d++){const h=e[d],c=d<e.length-1?e[d+1].originalStart:this._originalElementsOrHash.length,_=d<e.length-1?e[d+1].modifiedStart:this._modifiedElementsOrHash.length,m=h.originalLength>0,y=h.modifiedLength>0;for(;h.originalStart+h.originalLength<c&&h.modifiedStart+h.modifiedLength<_&&(!m||this.OriginalElementsAreEqual(h.originalStart,h.originalStart+h.originalLength))&&(!y||this.ModifiedElementsAreEqual(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const N=this.ElementsAreStrictEqual(h.originalStart,h.modifiedStart);if(this.ElementsAreStrictEqual(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!N)break;h.originalStart++,h.modifiedStart++}const w=[null];if(d<e.length-1&&this.ChangesOverlap(e[d],e[d+1],w)){e[d]=w[0],e.splice(d+1,1),d--;continue}}for(let d=e.length-1;d>=0;d--){const h=e[d];let c=0,_=0;if(d>0){const S=e[d-1];c=S.originalStart+S.originalLength,_=S.modifiedStart+S.modifiedLength}const m=h.originalLength>0,y=h.modifiedLength>0;let w=0,N=this._boundaryScore(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let S=1;;S++){const s=h.originalStart-S,a=h.modifiedStart-S;if(s<c||a<_||m&&!this.OriginalElementsAreEqual(s,s+h.originalLength)||y&&!this.ModifiedElementsAreEqual(a,a+h.modifiedLength))break;const p=(s===c&&a===_?5:0)+this._boundaryScore(s,h.originalLength,a,h.modifiedLength);p>N&&(N=p,w=S)}h.originalStart-=w,h.modifiedStart-=w;const C=[null];if(d>0&&this.ChangesOverlap(e[d-1],e[d],C)){e[d-1]=C[0],e.splice(d,1),d++;continue}}if(this._hasStrings)for(let d=1,h=e.length;d<h;d++){const c=e[d-1],_=e[d],m=_.originalStart-c.originalStart-c.originalLength,y=c.originalStart,w=_.originalStart+_.originalLength,N=w-y,C=c.modifiedStart,S=_.modifiedStart+_.modifiedLength,s=S-C;if(m<5&&N<20&&s<20){const a=this._findBetterContiguousSequence(y,N,C,s,m);if(a){const[l,p]=a;(l!==c.originalStart+c.originalLength||p!==c.modifiedStart+c.modifiedLength)&&(c.originalLength=l-c.originalStart,c.modifiedLength=p-c.modifiedStart,_.originalStart=l+m,_.modifiedStart=p+m,_.originalLength=w-_.originalStart,_.modifiedLength=S-_.modifiedStart)}}}return e}_findBetterContiguousSequence(e,d,h,c,_){if(d<_||c<_)return null;const m=e+d-_+1,y=h+c-_+1;let w=0,N=0,C=0;for(let S=e;S<m;S++)for(let s=h;s<y;s++){const a=this._contiguousSequenceScore(S,s,_);a>0&&a>w&&(w=a,N=S,C=s)}return w>0?[N,C]:null}_contiguousSequenceScore(e,d,h){let c=0;for(let _=0;_<h;_++){if(!this.ElementsAreEqual(e+_,d+_))return 0;c+=this._originalStringElements[e+_].length}return c}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,d){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(d>0){const h=e+d;if(this._OriginalIsBoundary(h-1)||this._OriginalIsBoundary(h))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,d){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(d>0){const h=e+d;if(this._ModifiedIsBoundary(h-1)||this._ModifiedIsBoundary(h))return!0}return!1}_boundaryScore(e,d,h,c){const _=this._OriginalRegionIsBoundary(e,d)?1:0,m=this._ModifiedRegionIsBoundary(h,c)?1:0;return _+m}ConcatenateChanges(e,d){const h=[];if(e.length===0||d.length===0)return d.length>0?d:e;if(this.ChangesOverlap(e[e.length-1],d[0],h)){const c=new Array(e.length+d.length-1);return v.Copy(e,0,c,0,e.length-1),c[e.length-1]=h[0],v.Copy(d,1,c,e.length,d.length-1),c}else{const c=new Array(e.length+d.length);return v.Copy(e,0,c,0,e.length),v.Copy(d,0,c,e.length,d.length),c}}ChangesOverlap(e,d,h){if(f.Assert(e.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),f.Assert(e.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=d.originalStart||e.modifiedStart+e.modifiedLength>=d.modifiedStart){const c=e.originalStart;let _=e.originalLength;const m=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=d.originalStart&&(_=d.originalStart+d.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=d.modifiedStart&&(y=d.modifiedStart+d.modifiedLength-e.modifiedStart),h[0]=new R.DiffChange(c,_,m,y),!0}else return h[0]=null,!1}ClipDiagonalBound(e,d,h,c){if(e>=0&&e<c)return e;const _=h,m=c-h-1,y=d%2===0;if(e<0){const w=_%2===0;return y===w?0:1}else{const w=m%2===0;return y===w?c-1:c-2}}}n.LcsDiff=r}),ee(te[23],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function R(m){return typeof m=="string"}n.isString=R;function M(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}n.isObject=M;function i(m){const y=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof y}n.isTypedArray=i;function u(m){return typeof m=="number"&&!isNaN(m)}n.isNumber=u;function f(m){return!!m&&typeof m[Symbol.iterator]=="function"}n.isIterable=f;function v(m){return m===!0||m===!1}n.isBoolean=v;function o(m){return typeof m>"u"}n.isUndefined=o;function r(m){return!g(m)}n.isDefined=r;function g(m){return o(m)||m===null}n.isUndefinedOrNull=g;function e(m,y){if(!m)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}n.assertType=e;function d(m){if(g(m))throw new Error("Assertion Failed: argument is undefined or null");return m}n.assertIsDefined=d;function h(m){return typeof m=="function"}n.isFunction=h;function c(m,y){const w=Math.min(m.length,y.length);for(let N=0;N<w;N++)_(m[N],y[N])}n.validateConstraints=c;function _(m,y){if(R(y)){if(typeof m!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(h(y)){try{if(m instanceof y)return}catch{}if(!g(m)&&m.constructor===y||y.length===1&&y.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=_}),ee(te[37],ne([0,1,23]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(f,v){if((0,R.isString)(v)){const o=M[v];if(o===void 0)throw new Error(`${f} references an unknown codicon: ${v}`);v=o}return M[f]=v,{id:f}}function u(){return M}n.getCodiconFontCharacters=u,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),ee(te[11],ne([0,1,23]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const c=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([_,m])=>{c[_]=m&&typeof m=="object"?M(m):m}),c}n.deepClone=M;function i(h){if(!h||typeof h!="object")return h;const c=[h];for(;c.length>0;){const _=c.shift();Object.freeze(_);for(const m in _)if(u.call(_,m)){const y=_[m];typeof y=="object"&&!Object.isFrozen(y)&&!(0,R.isTypedArray)(y)&&c.push(y)}}return h}n.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function f(h,c){return v(h,c,new Set)}n.cloneAndChange=f;function v(h,c,_){if((0,R.isUndefinedOrNull)(h))return h;const m=c(h);if(typeof m<"u")return m;if(Array.isArray(h)){const y=[];for(const w of h)y.push(v(w,c,_));return y}if((0,R.isObject)(h)){if(_.has(h))throw new Error("Cannot clone recursive data-structure");_.add(h);const y={};for(const w in h)u.call(h,w)&&(y[w]=v(h[w],c,_));return _.delete(h),y}return h}function o(h,c,_=!0){return(0,R.isObject)(h)?((0,R.isObject)(c)&&Object.keys(c).forEach(m=>{m in h?_&&((0,R.isObject)(h[m])&&(0,R.isObject)(c[m])?o(h[m],c[m],_):h[m]=c[m]):h[m]=c[m]}),h):c}n.mixin=o;function r(h,c){if(h===c)return!0;if(h==null||c===null||c===void 0||typeof h!=typeof c||typeof h!="object"||Array.isArray(h)!==Array.isArray(c))return!1;let _,m;if(Array.isArray(h)){if(h.length!==c.length)return!1;for(_=0;_<h.length;_++)if(!r(h[_],c[_]))return!1}else{const y=[];for(m in h)y.push(m);y.sort();const w=[];for(m in c)w.push(m);if(w.sort(),!r(y,w))return!1;for(_=0;_<y.length;_++)if(!r(h[y[_]],c[y[_]]))return!1}return!0}n.equals=r;function g(h){let c=[];for(;Object.prototype!==h;)c=c.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return c}n.getAllPropertyNames=g;function e(h){const c=[];for(const _ of g(h))typeof h[_]=="function"&&c.push(_);return c}n.getAllMethodNames=e;function d(h,c){const _=y=>function(){const w=Array.prototype.slice.call(arguments,0);return c(y,w)},m={};for(const y of h)m[y]=_(y);return m}n.createProxyObject=d}),ee(te[24],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function R(i){return i<0?0:i>255?255:i|0}n.toUint8=R;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),ee(te[25],ne([0,1,24]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(f){const v=(0,R.toUint8)(f);this._defaultValue=v,this._asciiMap=M._createAsciiMap(v),this._map=new Map}static _createAsciiMap(f){const v=new Uint8Array(256);return v.fill(f),v}set(f,v){const o=(0,R.toUint8)(v);f>=0&&f<256?this._asciiMap[f]=o:this._map.set(f,o)}get(f){return f>=0&&f<256?this._asciiMap[f]:this._map.get(f)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class i{constructor(){this._actual=new M(0)}add(f){this._actual.set(f,1)}has(f){return this._actual.get(f)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),ee(te[6],ne([0,1,4]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class M{static addRange(f,v){let o=0;for(;o<v.length&&v[o].endExclusive<f.start;)o++;let r=o;for(;r<v.length&&v[r].start<=f.endExclusive;)r++;if(o===r)v.splice(o,0,f);else{const g=Math.min(f.start,v[o].start),e=Math.max(f.endExclusive,v[r-1].endExclusive);v.splice(o,r-o,new M(g,e))}}static tryCreate(f,v){if(!(f>v))return new M(f,v)}static ofLength(f){return new M(0,f)}constructor(f,v){if(this.start=f,this.endExclusive=v,f>v)throw new R.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(f){return new M(this.start+f,this.endExclusive+f)}deltaStart(f){return new M(this.start+f,this.endExclusive)}deltaEnd(f){return new M(this.start,this.endExclusive+f)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(f){return this.start===f.start&&this.endExclusive===f.endExclusive}containsRange(f){return this.start<=f.start&&f.endExclusive<=this.endExclusive}contains(f){return this.start<=f&&f<this.endExclusive}join(f){return new M(Math.min(this.start,f.start),Math.max(this.endExclusive,f.endExclusive))}intersect(f){const v=Math.max(this.start,f.start),o=Math.min(this.endExclusive,f.endExclusive);if(v<=o)return new M(v,o)}slice(f){return f.slice(this.start,this.endExclusive)}clip(f){if(this.isEmpty)throw new R.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,f))}clipCyclic(f){if(this.isEmpty)throw new R.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return f<this.start?this.endExclusive-(this.start-f)%this.length:f>=this.endExclusive?this.start+(f-this.start)%this.length:f}}n.OffsetRange=M;class i{constructor(){this._sortedRanges=[]}addRange(f){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<f.start;)v++;let o=v;for(;o<this._sortedRanges.length&&this._sortedRanges[o].start<=f.endExclusive;)o++;if(v===o)this._sortedRanges.splice(v,0,f);else{const r=Math.min(f.start,this._sortedRanges[v].start),g=Math.max(f.endExclusive,this._sortedRanges[o-1].endExclusive);this._sortedRanges.splice(v,o-v,new M(r,g))}}toString(){return this._sortedRanges.map(f=>f.toString()).join(", ")}intersectsStrict(f){let v=0;for(;v<this._sortedRanges.length&&this._sortedRanges[v].endExclusive<=f.start;)v++;return v<this._sortedRanges.length&&this._sortedRanges[v].start<f.endExclusive}intersectWithRange(f){const v=new i;for(const o of this._sortedRanges){const r=o.intersect(f);r&&v.addRange(r)}return v}intersectWithRangeLength(f){return this.intersectWithRange(f).length}get length(){return this._sortedRanges.reduce((f,v)=>f+v.length,0)}}n.OffsetRangeSet=i}),ee(te[3],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class R{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new R(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return R.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return R.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return R.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const f=i.lineNumber|0,v=u.lineNumber|0;if(f===v){const o=i.column|0,r=u.column|0;return o-r}return f-v}clone(){return new R(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new R(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=R}),ee(te[2],ne([0,1,3]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(u,f,v,o){u>v||u===v&&f>o?(this.startLineNumber=v,this.startColumn=o,this.endLineNumber=u,this.endColumn=f):(this.startLineNumber=u,this.startColumn=f,this.endLineNumber=v,this.endColumn=o)}isEmpty(){return M.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return M.containsPosition(this,u)}static containsPosition(u,f){return!(f.lineNumber<u.startLineNumber||f.lineNumber>u.endLineNumber||f.lineNumber===u.startLineNumber&&f.column<u.startColumn||f.lineNumber===u.endLineNumber&&f.column>u.endColumn)}static strictContainsPosition(u,f){return!(f.lineNumber<u.startLineNumber||f.lineNumber>u.endLineNumber||f.lineNumber===u.startLineNumber&&f.column<=u.startColumn||f.lineNumber===u.endLineNumber&&f.column>=u.endColumn)}containsRange(u){return M.containsRange(this,u)}static containsRange(u,f){return!(f.startLineNumber<u.startLineNumber||f.endLineNumber<u.startLineNumber||f.startLineNumber>u.endLineNumber||f.endLineNumber>u.endLineNumber||f.startLineNumber===u.startLineNumber&&f.startColumn<u.startColumn||f.endLineNumber===u.endLineNumber&&f.endColumn>u.endColumn)}strictContainsRange(u){return M.strictContainsRange(this,u)}static strictContainsRange(u,f){return!(f.startLineNumber<u.startLineNumber||f.endLineNumber<u.startLineNumber||f.startLineNumber>u.endLineNumber||f.endLineNumber>u.endLineNumber||f.startLineNumber===u.startLineNumber&&f.startColumn<=u.startColumn||f.endLineNumber===u.endLineNumber&&f.endColumn>=u.endColumn)}plusRange(u){return M.plusRange(this,u)}static plusRange(u,f){let v,o,r,g;return f.startLineNumber<u.startLineNumber?(v=f.startLineNumber,o=f.startColumn):f.startLineNumber===u.startLineNumber?(v=f.startLineNumber,o=Math.min(f.startColumn,u.startColumn)):(v=u.startLineNumber,o=u.startColumn),f.endLineNumber>u.endLineNumber?(r=f.endLineNumber,g=f.endColumn):f.endLineNumber===u.endLineNumber?(r=f.endLineNumber,g=Math.max(f.endColumn,u.endColumn)):(r=u.endLineNumber,g=u.endColumn),new M(v,o,r,g)}intersectRanges(u){return M.intersectRanges(this,u)}static intersectRanges(u,f){let v=u.startLineNumber,o=u.startColumn,r=u.endLineNumber,g=u.endColumn;const e=f.startLineNumber,d=f.startColumn,h=f.endLineNumber,c=f.endColumn;return v<e?(v=e,o=d):v===e&&(o=Math.max(o,d)),r>h?(r=h,g=c):r===h&&(g=Math.min(g,c)),v>r||v===r&&o>g?null:new M(v,o,r,g)}equalsRange(u){return M.equalsRange(this,u)}static equalsRange(u,f){return!u&&!f?!0:!!u&&!!f&&u.startLineNumber===f.startLineNumber&&u.startColumn===f.startColumn&&u.endLineNumber===f.endLineNumber&&u.endColumn===f.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(u){return new R.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(u){return new R.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,f){return new M(this.startLineNumber,this.startColumn,u,f)}setStartPosition(u,f){return new M(u,f,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(u){return new M(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(u){return new M(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new M(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,f=u){return new M(u.lineNumber,u.column,f.lineNumber,f.column)}static lift(u){return u?new M(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,f){return!(u.endLineNumber<f.startLineNumber||u.endLineNumber===f.startLineNumber&&u.endColumn<f.startColumn||f.endLineNumber<u.startLineNumber||f.endLineNumber===u.startLineNumber&&f.endColumn<u.startColumn)}static areIntersecting(u,f){return!(u.endLineNumber<f.startLineNumber||u.endLineNumber===f.startLineNumber&&u.endColumn<=f.startColumn||f.endLineNumber<u.startLineNumber||f.endLineNumber===u.startLineNumber&&f.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,f){if(u&&f){const r=u.startLineNumber|0,g=f.startLineNumber|0;if(r===g){const e=u.startColumn|0,d=f.startColumn|0;if(e===d){const h=u.endLineNumber|0,c=f.endLineNumber|0;if(h===c){const _=u.endColumn|0,m=f.endColumn|0;return _-m}return h-c}return e-d}return r-g}return(u?1:0)-(f?1:0)}static compareRangesUsingEnds(u,f){return u.endLineNumber===f.endLineNumber?u.endColumn===f.endColumn?u.startLineNumber===f.startLineNumber?u.startColumn-f.startColumn:u.startLineNumber-f.startLineNumber:u.endColumn-f.endColumn:u.endLineNumber-f.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}n.Range=M}),ee(te[12],ne([0,1,4,6,2,17]),function(O,n,R,M,i,u){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class f{static fromRange(r){return new f(r.startLineNumber,r.endLineNumber)}static subtract(r,g){return g?r.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<r.endLineNumberExclusive?[new f(r.startLineNumber,g.startLineNumber),new f(g.endLineNumberExclusive,r.endLineNumberExclusive)]:g.startLineNumber<=r.startLineNumber&&r.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<r.endLineNumberExclusive?[new f(Math.max(g.endLineNumberExclusive,r.startLineNumber),r.endLineNumberExclusive)]:[new f(r.startLineNumber,Math.min(g.startLineNumber,r.endLineNumberExclusive))]:[r]}static joinMany(r){if(r.length===0)return[];let g=new v(r[0].slice());for(let e=1;e<r.length;e++)g=g.getUnion(new v(r[e].slice()));return g.ranges}static ofLength(r,g){return new f(r,r+g)}static deserialize(r){return new f(r[0],r[1])}constructor(r,g){if(r>g)throw new R.BugIndicatingError(`startLineNumber ${r} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=r,this.endLineNumberExclusive=g}contains(r){return this.startLineNumber<=r&&r<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(r){return new f(this.startLineNumber+r,this.endLineNumberExclusive+r)}deltaLength(r){return new f(this.startLineNumber,this.endLineNumberExclusive+r)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(r){return new f(Math.min(this.startLineNumber,r.startLineNumber),Math.max(this.endLineNumberExclusive,r.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(r){const g=Math.max(this.startLineNumber,r.startLineNumber),e=Math.min(this.endLineNumberExclusive,r.endLineNumberExclusive);if(g<=e)return new f(g,e)}intersectsStrict(r){return this.startLineNumber<r.endLineNumberExclusive&&r.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(r){return this.startLineNumber<=r.endLineNumberExclusive&&r.startLineNumber<=this.endLineNumberExclusive}equals(r){return this.startLineNumber===r.startLineNumber&&this.endLineNumberExclusive===r.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(r){const g=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)g.push(r(e));return g}forEach(r){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)r(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(r){return this.startLineNumber<=r&&r<this.endLineNumberExclusive}toOffsetRange(){return new M.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=f;class v{constructor(r=[]){this._normalizedRanges=r}get ranges(){return this._normalizedRanges}addRange(r){if(r.length===0)return;const g=(0,u.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,d=>d.endLineNumberExclusive>=r.startLineNumber),e=(0,u.findLastIdxMonotonous)(this._normalizedRanges,d=>d.startLineNumber<=r.endLineNumberExclusive)+1;if(g===e)this._normalizedRanges.splice(g,0,r);else if(g===e-1){const d=this._normalizedRanges[g];this._normalizedRanges[g]=d.join(r)}else{const d=this._normalizedRanges[g].join(this._normalizedRanges[e-1]).join(r);this._normalizedRanges.splice(g,e-g,d)}}getUnion(r){if(this._normalizedRanges.length===0)return r;if(r._normalizedRanges.length===0)return this;const g=[];let e=0,d=0,h=null;for(;e<this._normalizedRanges.length||d<r._normalizedRanges.length;){let c=null;if(e<this._normalizedRanges.length&&d<r._normalizedRanges.length){const _=this._normalizedRanges[e],m=r._normalizedRanges[d];_.startLineNumber<m.startLineNumber?(c=_,e++):(c=m,d++)}else e<this._normalizedRanges.length?(c=this._normalizedRanges[e],e++):(c=r._normalizedRanges[d],d++);h===null?h=c:h.endLineNumberExclusive>=c.startLineNumber?h=new f(h.startLineNumber,Math.max(h.endLineNumberExclusive,c.endLineNumberExclusive)):(g.push(h),h=c)}return h!==null&&g.push(h),new v(g)}subtractFrom(r){const g=(0,u.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,c=>c.endLineNumberExclusive>=r.startLineNumber),e=(0,u.findLastIdxMonotonous)(this._normalizedRanges,c=>c.startLineNumber<=r.endLineNumberExclusive)+1;if(g===e)return new v([r]);const d=[];let h=r.startLineNumber;for(let c=g;c<e;c++){const _=this._normalizedRanges[c];_.startLineNumber>h&&d.push(new f(h,_.startLineNumber)),h=_.endLineNumberExclusive}return h<r.endLineNumberExclusive&&d.push(new f(h,r.endLineNumberExclusive)),new v(d)}toString(){return this._normalizedRanges.map(r=>r.toString()).join(", ")}getIntersection(r){const g=[];let e=0,d=0;for(;e<this._normalizedRanges.length&&d<r._normalizedRanges.length;){const h=this._normalizedRanges[e],c=r._normalizedRanges[d],_=h.intersect(c);_&&!_.isEmpty&&g.push(_),h.endLineNumberExclusive<c.endLineNumberExclusive?e++:d++}return new v(g)}getWithDelta(r){return new v(this._normalizedRanges.map(g=>g.delta(r)))}}n.LineRangeSet=v}),ee(te[38],ne([0,1,3,2]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(f,v,o,r){super(f,v,o,r),this.selectionStartLineNumber=f,this.selectionStartColumn=v,this.positionLineNumber=o,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return i.selectionsEqual(this,f)}static selectionsEqual(f,v){return f.selectionStartLineNumber===v.selectionStartLineNumber&&f.selectionStartColumn===v.selectionStartColumn&&f.positionLineNumber===v.positionLineNumber&&f.positionColumn===v.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,v){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,f,v):new i(f,v,this.startLineNumber,this.startColumn)}getPosition(){return new R.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new R.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,v){return this.getDirection()===0?new i(f,v,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,f,v)}static fromPositions(f,v=f){return new i(f.lineNumber,f.column,v.lineNumber,v.column)}static fromRange(f,v){return v===0?new i(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new i(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new i(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,v){if(f&&!v||!f&&v)return!1;if(!f&&!v)return!0;if(f.length!==v.length)return!1;for(let o=0,r=f.length;o<r;o++)if(!this.selectionsEqual(f[o],v[o]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,v,o,r,g){return g===0?new i(f,v,o,r):new i(o,r,f,v)}}n.Selection=i}),ee(te[39],ne([0,1,25]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends R.CharacterClassifier{constructor(f){super(0);for(let v=0,o=f.length;v<o;v++)this.set(f.charCodeAt(v),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(u){const f={};return v=>(f.hasOwnProperty(v)||(f[v]=u(v)),f[v])}n.getMapForWordSeparators=i(u=>new M(u))}),ee(te[26],ne([0,1,19,20]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(r=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)r.indexOf(e)>=0||(g+="\\"+e);return g+="\\s]+)",new RegExp(g,"g")}n.DEFAULT_WORD_REGEXP=i();function u(r){let g=n.DEFAULT_WORD_REGEXP;if(r&&r instanceof RegExp)if(r.global)g=r;else{let e="g";r.ignoreCase&&(e+="i"),r.multiline&&(e+="m"),r.unicode&&(e+="u"),g=new RegExp(r.source,e)}return g.lastIndex=0,g}n.ensureValidWordDefinition=u;const f=new M.LinkedList;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(r,g,e,d,h){if(h||(h=R.Iterable.first(f)),e.length>h.maxLen){let w=r-h.maxLen/2;return w<0?w=0:d+=w,e=e.substring(w,r+h.maxLen/2),v(r,g,e,d,h)}const c=Date.now(),_=r-1-d;let m=-1,y=null;for(let w=1;!(Date.now()-c>=h.timeBudget);w++){const N=_-h.windowSize*w;g.lastIndex=Math.max(0,N);const C=o(g,e,_,m);if(!C&&y||(y=C,N<=0))break;m=N}if(y){const w={word:y[0],startColumn:d+1+y.index,endColumn:d+1+y.index+y[0].length};return g.lastIndex=0,w}return null}n.getWordAtText=v;function o(r,g,e,d){let h;for(;h=r.exec(g);){const c=h.index||0;if(c<=e&&r.lastIndex>=e)return h;if(d>0&&c>d)return null}return null}}),ee(te[8],ne([0,1,4,6]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(r,g){return new i([new u(new M.OffsetRange(0,r.length),new M.OffsetRange(0,g.length))],!1)}static trivialTimedOut(r,g){return new i([new u(new M.OffsetRange(0,r.length),new M.OffsetRange(0,g.length))],!0)}constructor(r,g){this.diffs=r,this.hitTimeout=g}}n.DiffAlgorithmResult=i;class u{constructor(r,g){this.seq1Range=r,this.seq2Range=g}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(r){return new u(this.seq1Range.join(r.seq1Range),this.seq2Range.join(r.seq2Range))}delta(r){return r===0?this:new u(this.seq1Range.delta(r),this.seq2Range.delta(r))}}n.SequenceDiff=u;class f{isValid(){return!0}}n.InfiniteTimeout=f,f.instance=new f;class v{constructor(r){if(this.timeout=r,this.startTime=Date.now(),this.valid=!0,r<=0)throw new R.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=v}),ee(te[40],ne([0,1,6,8]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.removeRandomMatches=n.removeRandomLineMatches=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(e,d,h){let c=h;return c=o(e,d,c),c=r(e,d,c),c}n.optimizeSequenceDiffs=i;function u(e,d,h){const c=[];for(const _ of h){const m=c[c.length-1];if(!m){c.push(_);continue}_.seq1Range.start-m.seq1Range.endExclusive<=2||_.seq2Range.start-m.seq2Range.endExclusive<=2?c[c.length-1]=new M.SequenceDiff(m.seq1Range.join(_.seq1Range),m.seq2Range.join(_.seq2Range)):c.push(_)}return c}n.smoothenSequenceDiffs=u;function f(e,d,h){let c=h;if(c.length===0)return c;let _=0,m;do{m=!1;const y=[c[0]];for(let w=1;w<c.length;w++){let S=function(a,l){const p=new R.OffsetRange(C.seq1Range.endExclusive,N.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(a.seq1Range.length+a.seq2Range.length>5||l.seq1Range.length+l.seq2Range.length>5)};const N=c[w],C=y[y.length-1];S(C,N)?(m=!0,y[y.length-1]=y[y.length-1].join(N)):y.push(N)}c=y}while(_++<10&&m);return c}n.removeRandomLineMatches=f;function v(e,d,h){let c=h;if(c.length===0)return c;let _=0,m;do{m=!1;const y=[c[0]];for(let w=1;w<c.length;w++){let S=function(a,l){const p=new R.OffsetRange(C.seq1Range.endExclusive,N.seq1Range.start);if(e.countLinesIn(p)>5||p.length>500)return!1;const L=e.getText(p).trim();if(L.length>20||L.split(/\r\n|\r|\n/).length>1)return!1;const A=e.countLinesIn(a.seq1Range),E=a.seq1Range.length,P=d.countLinesIn(a.seq2Range),T=a.seq2Range.length,k=e.countLinesIn(l.seq1Range),D=l.seq1Range.length,F=d.countLinesIn(l.seq2Range),V=l.seq2Range.length,W=2*40+50;function j(z){return Math.min(z,W)}return Math.pow(Math.pow(j(A*40+E),1.5)+Math.pow(j(P*40+T),1.5),1.5)+Math.pow(Math.pow(j(k*40+D),1.5)+Math.pow(j(F*40+V),1.5),1.5)>Math.pow(Math.pow(W,1.5),1.5)*1.3};const N=c[w],C=y[y.length-1];S(C,N)?(m=!0,y[y.length-1]=y[y.length-1].join(N)):y.push(N)}c=y}while(_++<10&&m);for(let y=0;y<c.length;y++){const w=c[y];let N=w.seq1Range,C=w.seq2Range;const S=e.extendToFullLines(w.seq1Range),s=e.getText(new R.OffsetRange(S.start,w.seq1Range.start));s.length>0&&s.trim().length<=3&&w.seq1Range.length+w.seq2Range.length>100&&(N=w.seq1Range.deltaStart(-s.length),C=w.seq2Range.deltaStart(-s.length));const a=e.getText(new R.OffsetRange(w.seq1Range.endExclusive,S.endExclusive));a.length>0&&a.trim().length<=3&&w.seq1Range.length+w.seq2Range.length>150&&(N=N.deltaEnd(a.length),C=C.deltaEnd(a.length)),c[y]=new M.SequenceDiff(N,C)}return c}n.removeRandomMatches=v;function o(e,d,h){if(h.length===0)return h;const c=[];c.push(h[0]);for(let m=1;m<h.length;m++){const y=c[c.length-1];let w=h[m];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const N=w.seq1Range.start-y.seq1Range.endExclusive;let C;for(C=1;C<=N&&!(e.getElement(w.seq1Range.start-C)!==e.getElement(w.seq1Range.endExclusive-C)||d.getElement(w.seq2Range.start-C)!==d.getElement(w.seq2Range.endExclusive-C));C++);if(C--,C===N){c[c.length-1]=new M.SequenceDiff(new R.OffsetRange(y.seq1Range.start,w.seq1Range.endExclusive-N),new R.OffsetRange(y.seq2Range.start,w.seq2Range.endExclusive-N));continue}w=w.delta(-C)}c.push(w)}const _=[];for(let m=0;m<c.length-1;m++){const y=c[m+1];let w=c[m];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const N=y.seq1Range.start-w.seq1Range.endExclusive;let C;for(C=0;C<N&&!(e.getElement(w.seq1Range.start+C)!==e.getElement(w.seq1Range.endExclusive+C)||d.getElement(w.seq2Range.start+C)!==d.getElement(w.seq2Range.endExclusive+C));C++);if(C===N){c[m+1]=new M.SequenceDiff(new R.OffsetRange(w.seq1Range.start+N,y.seq1Range.endExclusive),new R.OffsetRange(w.seq2Range.start+N,y.seq2Range.endExclusive));continue}C>0&&(w=w.delta(C))}_.push(w)}return c.length>0&&_.push(c[c.length-1]),_}n.joinSequenceDiffs=o;function r(e,d,h){if(!e.getBoundaryScore||!d.getBoundaryScore)return h;for(let c=0;c<h.length;c++){const _=c>0?h[c-1]:void 0,m=h[c],y=c+1<h.length?h[c+1]:void 0,w=new R.OffsetRange(_?_.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:e.length),N=new R.OffsetRange(_?_.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:d.length);m.seq1Range.isEmpty?h[c]=g(m,e,d,w,N):m.seq2Range.isEmpty&&(h[c]=g(m.reverse(),d,e,N,w).reverse())}return h}n.shiftSequenceDiffs=r;function g(e,d,h,c,_){let y=1;for(;e.seq1Range.start-y>=c.start&&e.seq2Range.start-y>=_.start&&h.isStronglyEqual(e.seq2Range.start-y,e.seq2Range.endExclusive-y)&&y<100;)y++;y--;let w=0;for(;e.seq1Range.start+w<c.endExclusive&&e.seq2Range.endExclusive+w<_.endExclusive&&h.isStronglyEqual(e.seq2Range.start+w,e.seq2Range.endExclusive+w)&&w<100;)w++;if(y===0&&w===0)return e;let N=0,C=-1;for(let S=-y;S<=w;S++){const s=e.seq2Range.start+S,a=e.seq2Range.endExclusive+S,l=e.seq1Range.start+S,p=d.getBoundaryScore(l)+h.getBoundaryScore(s)+h.getBoundaryScore(a);p>C&&(C=p,N=S)}return e.delta(N)}}),ee(te[41],ne([0,1,6,8]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(r,g,e=M.InfiniteTimeout.instance){if(r.length===0||g.length===0)return M.DiffAlgorithmResult.trivial(r,g);function d(S,s){for(;S<r.length&&s<g.length&&r.getElement(S)===g.getElement(s);)S++,s++;return S}let h=0;const c=new f;c.set(0,d(0,0));const _=new v;_.set(0,c.get(0)===0?null:new u(null,0,0,c.get(0)));let m=0;e:for(;;){if(h++,!e.isValid())return M.DiffAlgorithmResult.trivialTimedOut(r,g);const S=-Math.min(h,g.length+h%2),s=Math.min(h,r.length+h%2);for(m=S;m<=s;m+=2){const a=m===s?-1:c.get(m+1),l=m===S?-1:c.get(m-1)+1,p=Math.min(Math.max(a,l),r.length),b=p-m;if(p>r.length||b>g.length)continue;const L=d(p,b);c.set(m,L);const A=p===a?_.get(m+1):_.get(m-1);if(_.set(m,L!==p?new u(A,p,b,L-p):A),c.get(m)===r.length&&c.get(m)-m===g.length)break e}}let y=_.get(m);const w=[];let N=r.length,C=g.length;for(;;){const S=y?y.x+y.length:0,s=y?y.y+y.length:0;if((S!==N||s!==C)&&w.push(new M.SequenceDiff(new R.OffsetRange(S,N),new R.OffsetRange(s,C))),!y)break;N=y.x,C=y.y,y=y.prev}return w.reverse(),new M.DiffAlgorithmResult(w,!1)}}n.MyersDiffAlgorithm=i;class u{constructor(r,g,e,d){this.prev=r,this.x=g,this.y=e,this.length=d}}class f{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(r){return r<0?(r=-r-1,this.negativeArr[r]):this.positiveArr[r]}set(r,g){if(r<0){if(r=-r-1,r>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[r]=g}else{if(r>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[r]=g}}}class v{constructor(){this.positiveArr=[],this.negativeArr=[]}get(r){return r<0?(r=-r-1,this.negativeArr[r]):this.positiveArr[r]}set(r,g){r<0?(r=-r-1,this.negativeArr[r]=g):this.positiveArr[r]=g}}}),ee(te[42],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class R{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,f){this.array[i+u*this.width]=f}}n.Array2D=R}),ee(te[43],ne([0,1,6,8,42]),function(O,n,R,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class u{compute(v,o,r=M.InfiniteTimeout.instance,g){if(v.length===0||o.length===0)return M.DiffAlgorithmResult.trivial(v,o);const e=new i.Array2D(v.length,o.length),d=new i.Array2D(v.length,o.length),h=new i.Array2D(v.length,o.length);for(let C=0;C<v.length;C++)for(let S=0;S<o.length;S++){if(!r.isValid())return M.DiffAlgorithmResult.trivialTimedOut(v,o);const s=C===0?0:e.get(C-1,S),a=S===0?0:e.get(C,S-1);let l;v.getElement(C)===o.getElement(S)?(C===0||S===0?l=0:l=e.get(C-1,S-1),C>0&&S>0&&d.get(C-1,S-1)===3&&(l+=h.get(C-1,S-1)),l+=g?g(C,S):1):l=-1;const p=Math.max(s,a,l);if(p===l){const b=C>0&&S>0?h.get(C-1,S-1):0;h.set(C,S,b+1),d.set(C,S,3)}else p===s?(h.set(C,S,0),d.set(C,S,1)):p===a&&(h.set(C,S,0),d.set(C,S,2));e.set(C,S,p)}const c=[];let _=v.length,m=o.length;function y(C,S){(C+1!==_||S+1!==m)&&c.push(new M.SequenceDiff(new R.OffsetRange(C+1,_),new R.OffsetRange(S+1,m))),_=C,m=S}let w=v.length-1,N=o.length-1;for(;w>=0&&N>=0;)d.get(w,N)===3?(y(w,N),w--,N--):d.get(w,N)===1?w--:N--;return y(-1,-1),c.reverse(),new M.DiffAlgorithmResult(c,!1)}}n.DynamicProgrammingDiffing=u}),ee(te[27],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class R{constructor(u,f,v){this.changes=u,this.moves=f,this.hitTimeout=v}}n.LinesDiff=R;class M{constructor(u,f){this.lineRangeMapping=u,this.changes=f}flip(){return new M(this.lineRangeMapping.flip(),this.changes.map(u=>u.flip()))}}n.MovedText=M}),ee(te[28],ne([0,1,12]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class M{static inverse(v,o,r){const g=[];let e=1,d=1;for(const c of v){const _=new i(new R.LineRange(e,c.original.startLineNumber),new R.LineRange(d,c.modified.startLineNumber),void 0);_.modified.isEmpty||g.push(_),e=c.original.endLineNumberExclusive,d=c.modified.endLineNumberExclusive}const h=new i(new R.LineRange(e,o+1),new R.LineRange(d,r+1),void 0);return h.modified.isEmpty||g.push(h),g}constructor(v,o){this.original=v,this.modified=o}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new M(this.modified,this.original)}join(v){return new M(this.original.join(v.original),this.modified.join(v.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}n.LineRangeMapping=M;class i extends M{constructor(v,o,r){super(v,o),this.innerChanges=r}flip(){var v;return new i(this.modified,this.original,(v=this.innerChanges)===null||v===void 0?void 0:v.map(o=>o.flip()))}}n.DetailedLineRangeMapping=i;class u{constructor(v,o){this.originalRange=v,this.modifiedRange=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new u(this.modifiedRange,this.originalRange)}}n.RangeMapping=u}),ee(te[44],ne([0,1,16,9,30,12,6,3,2,8,43,40,41,27,28,17]),function(O,n,R,M,i,u,f,v,o,r,g,e,d,h,c,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.AdvancedLinesDiffComputer=void 0;class m{constructor(){this.dynamicProgrammingDiffing=new g.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new d.MyersDiffAlgorithm}computeDiff(D,F,V){if(D.length<=1&&(0,R.equals)(D,F,(Y,H)=>Y===H))return new h.LinesDiff([],[],!1);if(D.length===1&&D[0].length===0||F.length===1&&F[0].length===0)return new h.LinesDiff([new c.DetailedLineRangeMapping(new u.LineRange(1,D.length+1),new u.LineRange(1,F.length+1),[new c.RangeMapping(new o.Range(1,1,D.length,D[0].length+1),new o.Range(1,1,F.length,F[0].length+1))])],[],!1);const W=V.maxComputationTimeMs===0?r.InfiniteTimeout.instance:new r.DateTimeout(V.maxComputationTimeMs),j=!V.ignoreTrimWhitespace,z=new Map;function K(Y){let H=z.get(Y);return H===void 0&&(H=z.size,z.set(Y,H)),H}const se=D.map(Y=>K(Y.trim())),t=F.map(Y=>K(Y.trim())),x=new S(se,D),U=new S(t,F),q=(()=>x.length+U.length<1700?this.dynamicProgrammingDiffing.compute(x,U,W,(Y,H)=>D[Y]===F[H]?F[H].length===0?.1:1+Math.log(1+F[H].length):.99):this.myersDiffingAlgorithm.compute(x,U))();let $=q.diffs,Q=q.hitTimeout;$=(0,e.optimizeSequenceDiffs)(x,U,$),$=(0,e.removeRandomLineMatches)(x,U,$);const ae=[],oe=Y=>{if(j)for(let H=0;H<Y;H++){const X=ce+H,J=fe+H;if(D[X]!==F[J]){const ie=this.refineDiff(D,F,new r.SequenceDiff(new f.OffsetRange(X,X+1),new f.OffsetRange(J,J+1)),W,j);for(const le of ie.mappings)ae.push(le);ie.hitTimeout&&(Q=!0)}}};let ce=0,fe=0;for(const Y of $){(0,M.assertFn)(()=>Y.seq1Range.start-ce===Y.seq2Range.start-fe);const H=Y.seq1Range.start-ce;oe(H),ce=Y.seq1Range.endExclusive,fe=Y.seq2Range.endExclusive;const X=this.refineDiff(D,F,Y,W,j);X.hitTimeout&&(Q=!0);for(const J of X.mappings)ae.push(J)}oe(D.length-ce);const _e=N(ae,D,F);let Le=[];return V.computeMoves&&(Le=this.computeMoves(_e,D,F,se,t,W,j)),(0,M.assertFn)(()=>{function Y(X,J){if(X.lineNumber<1||X.lineNumber>J.length)return!1;const ie=J[X.lineNumber-1];return!(X.column<1||X.column>ie.length+1)}function H(X,J){return!(X.startLineNumber<1||X.startLineNumber>J.length+1||X.endLineNumberExclusive<1||X.endLineNumberExclusive>J.length+1)}for(const X of _e){if(!X.innerChanges)return!1;for(const J of X.innerChanges)if(!(Y(J.modifiedRange.getStartPosition(),F)&&Y(J.modifiedRange.getEndPosition(),F)&&Y(J.originalRange.getStartPosition(),D)&&Y(J.originalRange.getEndPosition(),D)))return!1;if(!H(X.modified,F)||!H(X.original,D))return!1}return!0}),new h.LinesDiff(_e,Le,Q)}computeMoves(D,F,V,W,j,z,K){const{moves:se,excludedChanges:t}=this.computeMovesFromSimpleDeletionsToSimpleInsertions(D,F,V,z);if(!z.isValid())return[];const x=this.computeUnchangedMoves(D.filter(Q=>!t.has(Q)),W,j,z);if((0,R.pushMany)(se,x),se.sort((0,R.compareBy)(Q=>Q.original.startLineNumber,R.numberComparator)),se.length===0)return[];let U=[se[0]];for(let Q=1;Q<se.length;Q++){const ae=U[U.length-1],oe=se[Q],ce=oe.original.startLineNumber-ae.original.endLineNumberExclusive,fe=oe.modified.startLineNumber-ae.modified.endLineNumberExclusive;if(ce>=0&&fe>=0&&ce+fe<=2){U[U.length-1]=ae.join(oe);continue}oe.original.toOffsetRange().slice(F).map(Y=>Y.trim()).join(`
`).length<=10||U.push(oe)}const q=new _.MonotonousArray(D);return U=U.filter(Q=>{const ae=q.findLastMonotonous(_e=>_e.original.endLineNumberExclusive<=Q.original.startLineNumber)||new c.LineRangeMapping(new u.LineRange(1,1),new u.LineRange(1,1)),oe=Q.modified.startLineNumber-ae.modified.endLineNumberExclusive,ce=Q.original.startLineNumber-ae.original.endLineNumberExclusive;return oe!==ce}),U.map(Q=>{const ae=this.refineDiff(F,V,new r.SequenceDiff(Q.original.toOffsetRange(),Q.modified.toOffsetRange()),z,K),oe=N(ae.mappings,F,V,!0);return new h.MovedText(Q,oe)})}computeMovesFromSimpleDeletionsToSimpleInsertions(D,F,V,W){const j=[],z=D.filter(t=>t.modified.isEmpty&&t.original.length>=3).map(t=>new T(t.original,F,t)),K=new Set(D.filter(t=>t.original.isEmpty&&t.modified.length>=3).map(t=>new T(t.modified,V,t))),se=new Set;for(const t of z){let x=-1,U;for(const q of K){const $=t.computeSimilarity(q);$>x&&(x=$,U=q)}if(x>.9&&U&&(K.delete(U),j.push(new c.LineRangeMapping(t.range,U.range)),se.add(t.source),se.add(U.source)),!W.isValid())return{moves:j,excludedChanges:se}}return{moves:j,excludedChanges:se}}computeUnchangedMoves(D,F,V,W){const j=[],z=new i.SetMap;for(const x of D)for(let U=x.original.startLineNumber;U<x.original.endLineNumberExclusive-2;U++){const q=`${F[U-1]}:${F[U+1-1]}:${F[U+2-1]}`;z.add(q,{range:new u.LineRange(U,U+3)})}const K=[];D.sort((0,R.compareBy)(x=>x.modified.startLineNumber,R.numberComparator));for(const x of D){let U=[];for(let q=x.modified.startLineNumber;q<x.modified.endLineNumberExclusive-2;q++){const $=`${V[q-1]}:${V[q+1-1]}:${V[q+2-1]}`,Q=new u.LineRange(q,q+3),ae=[];z.forEach($,({range:oe})=>{for(const fe of U)if(fe.originalLineRange.endLineNumberExclusive+1===oe.endLineNumberExclusive&&fe.modifiedLineRange.endLineNumberExclusive+1===Q.endLineNumberExclusive){fe.originalLineRange=new u.LineRange(fe.originalLineRange.startLineNumber,oe.endLineNumberExclusive),fe.modifiedLineRange=new u.LineRange(fe.modifiedLineRange.startLineNumber,Q.endLineNumberExclusive),ae.push(fe);return}const ce={modifiedLineRange:Q,originalLineRange:oe};K.push(ce),ae.push(ce)}),U=ae}if(!W.isValid())return[]}K.sort((0,R.reverseOrder)((0,R.compareBy)(x=>x.modifiedLineRange.length,R.numberComparator)));const se=new u.LineRangeSet,t=new u.LineRangeSet;for(const x of K){const U=x.modifiedLineRange.startLineNumber-x.originalLineRange.startLineNumber,q=se.subtractFrom(x.modifiedLineRange),$=t.subtractFrom(x.originalLineRange).getWithDelta(U),Q=q.getIntersection($);for(const ae of Q.ranges){if(ae.length<3)continue;const oe=ae,ce=ae.delta(-U);j.push(new c.LineRangeMapping(ce,oe)),se.addRange(oe),t.addRange(ce)}}return j}refineDiff(D,F,V,W,j){const z=new a(D,V.seq1Range,j),K=new a(F,V.seq2Range,j),se=z.length+K.length<500?this.dynamicProgrammingDiffing.compute(z,K,W):this.myersDiffingAlgorithm.compute(z,K,W);let t=se.diffs;return t=(0,e.optimizeSequenceDiffs)(z,K,t),t=y(z,K,t),t=(0,e.smoothenSequenceDiffs)(z,K,t),t=(0,e.removeRandomMatches)(z,K,t),{mappings:t.map(U=>new c.RangeMapping(z.translateRange(U.seq1Range),K.translateRange(U.seq2Range))),hitTimeout:se.hitTimeout}}}n.AdvancedLinesDiffComputer=m;function y(k,D,F){const V=[];let W;function j(){if(!W)return;const K=W.s1Range.length-W.deleted,se=W.s2Range.length-W.added;Math.max(W.deleted,W.added)+(W.count-1)>K&&V.push(new r.SequenceDiff(W.s1Range,W.s2Range)),W=void 0}for(const K of F){let se=function($,Q){var ae,oe,ce,fe;if(!W||!W.s1Range.containsRange($)||!W.s2Range.containsRange(Q))if(W&&!(W.s1Range.endExclusive<$.start&&W.s2Range.endExclusive<Q.start)){const Y=f.OffsetRange.tryCreate(W.s1Range.endExclusive,$.start),H=f.OffsetRange.tryCreate(W.s2Range.endExclusive,Q.start);W.deleted+=(ae=Y?.length)!==null&&ae!==void 0?ae:0,W.added+=(oe=H?.length)!==null&&oe!==void 0?oe:0,W.s1Range=W.s1Range.join($),W.s2Range=W.s2Range.join(Q)}else j(),W={added:0,deleted:0,count:0,s1Range:$,s2Range:Q};const _e=$.intersect(K.seq1Range),Le=Q.intersect(K.seq2Range);W.count++,W.deleted+=(ce=_e?.length)!==null&&ce!==void 0?ce:0,W.added+=(fe=Le?.length)!==null&&fe!==void 0?fe:0};const t=k.findWordContaining(K.seq1Range.start-1),x=D.findWordContaining(K.seq2Range.start-1),U=k.findWordContaining(K.seq1Range.endExclusive),q=D.findWordContaining(K.seq2Range.endExclusive);t&&U&&x&&q&&t.equals(U)&&x.equals(q)?se(t,x):(t&&x&&se(t,x),U&&q&&se(U,q))}return j(),w(F,V)}function w(k,D){const F=[];for(;k.length>0||D.length>0;){const V=k[0],W=D[0];let j;V&&(!W||V.seq1Range.start<W.seq1Range.start)?j=k.shift():j=D.shift(),F.length>0&&F[F.length-1].seq1Range.endExclusive>=j.seq1Range.start?F[F.length-1]=F[F.length-1].join(j):F.push(j)}return F}function N(k,D,F,V=!1){const W=[];for(const j of(0,R.groupAdjacentBy)(k.map(z=>C(z,D,F)),(z,K)=>z.original.overlapOrTouch(K.original)||z.modified.overlapOrTouch(K.modified))){const z=j[0],K=j[j.length-1];W.push(new c.DetailedLineRangeMapping(z.original.join(K.original),z.modified.join(K.modified),j.map(se=>se.innerChanges[0])))}return(0,M.assertFn)(()=>!V&&W.length>0&&W[0].original.startLineNumber!==W[0].modified.startLineNumber?!1:(0,M.checkAdjacentItems)(W,(j,z)=>z.original.startLineNumber-j.original.endLineNumberExclusive===z.modified.startLineNumber-j.modified.endLineNumberExclusive&&j.original.endLineNumberExclusive<z.original.startLineNumber&&j.modified.endLineNumberExclusive<z.modified.startLineNumber)),W}n.lineRangeMappingFromRangeMappings=N;function C(k,D,F){let V=0,W=0;k.modifiedRange.endColumn===1&&k.originalRange.endColumn===1&&k.originalRange.startLineNumber+V<=k.originalRange.endLineNumber&&k.modifiedRange.startLineNumber+V<=k.modifiedRange.endLineNumber&&(W=-1),k.modifiedRange.startColumn-1>=F[k.modifiedRange.startLineNumber-1].length&&k.originalRange.startColumn-1>=D[k.originalRange.startLineNumber-1].length&&k.originalRange.startLineNumber<=k.originalRange.endLineNumber+W&&k.modifiedRange.startLineNumber<=k.modifiedRange.endLineNumber+W&&(V=1);const j=new u.LineRange(k.originalRange.startLineNumber+V,k.originalRange.endLineNumber+1+W),z=new u.LineRange(k.modifiedRange.startLineNumber+V,k.modifiedRange.endLineNumber+1+W);return new c.DetailedLineRangeMapping(j,z,[k])}n.getLineRangeMapping=C;class S{constructor(D,F){this.trimmedHash=D,this.lines=F}getElement(D){return this.trimmedHash[D]}get length(){return this.trimmedHash.length}getBoundaryScore(D){const F=D===0?0:s(this.lines[D-1]),V=D===this.lines.length?0:s(this.lines[D]);return 1e3-(F+V)}getText(D){return this.lines.slice(D.start,D.endExclusive).join(`
`)}isStronglyEqual(D,F){return this.lines[D]===this.lines[F]}}n.LineSequence=S;function s(k){let D=0;for(;D<k.length&&(k.charCodeAt(D)===32||k.charCodeAt(D)===9);)D++;return D}class a{constructor(D,F,V){this.lines=D,this.considerWhitespaceChanges=V,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let W=!1;F.start>0&&F.endExclusive>=D.length&&(F=new f.OffsetRange(F.start-1,F.endExclusive),W=!0),this.lineRange=F,this.firstCharOffsetByLine[0]=0;for(let j=this.lineRange.start;j<this.lineRange.endExclusive;j++){let z=D[j],K=0;if(W)K=z.length,z="",W=!1;else if(!V){const se=z.trimStart();K=z.length-se.length,z=se.trimEnd()}this.additionalOffsetByLine.push(K);for(let se=0;se<z.length;se++)this.elements.push(z.charCodeAt(se));j<D.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[j-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new f.OffsetRange(0,this.length))}getText(D){return this.elements.slice(D.start,D.endExclusive).map(F=>String.fromCharCode(F)).join("")}getElement(D){return this.elements[D]}get length(){return this.elements.length}getBoundaryScore(D){const F=L(D>0?this.elements[D-1]:-1),V=L(D<this.elements.length?this.elements[D]:-1);if(F===6&&V===7)return 0;let W=0;return F!==V&&(W+=10,V===1&&(W+=1)),W+=b(F),W+=b(V),W}translateOffset(D){if(this.lineRange.isEmpty)return new v.Position(this.lineRange.start+1,1);const F=(0,_.findLastIdxMonotonous)(this.firstCharOffsetByLine,V=>V<=D);return new v.Position(this.lineRange.start+F+1,D-this.firstCharOffsetByLine[F]+this.additionalOffsetByLine[F]+1)}translateRange(D){return o.Range.fromPositions(this.translateOffset(D.start),this.translateOffset(D.endExclusive))}findWordContaining(D){if(D<0||D>=this.elements.length||!l(this.elements[D]))return;let F=D;for(;F>0&&l(this.elements[F-1]);)F--;let V=D;for(;V<this.elements.length&&l(this.elements[V]);)V++;return new f.OffsetRange(F,V)}countLinesIn(D){return this.translateOffset(D.endExclusive).lineNumber-this.translateOffset(D.start).lineNumber}isStronglyEqual(D,F){return this.elements[D]===this.elements[F]}extendToFullLines(D){var F,V;const W=(F=(0,_.findLastMonotonous)(this.firstCharOffsetByLine,z=>z<=D.start))!==null&&F!==void 0?F:0,j=(V=(0,_.findFirstMonotonous)(this.firstCharOffsetByLine,z=>D.endExclusive<=z))!==null&&V!==void 0?V:this.elements.length;return new f.OffsetRange(W,j)}}n.LinesSliceCharSequence=a;function l(k){return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57}const p={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function b(k){return p[k]}function L(k){return k===10?7:k===13?6:A(k)?5:k>=97&&k<=122?0:k>=65&&k<=90?1:k>=48&&k<=57?2:k===-1?3:4}function A(k){return k===32||k===9}const E=new Map;function P(k){let D=E.get(k);return D===void 0&&(D=E.size,E.set(k,D)),D}class T{constructor(D,F,V){this.range=D,this.lines=F,this.source=V,this.histogram=[];let W=0;for(let j=D.startLineNumber-1;j<D.endLineNumberExclusive-1;j++){const z=F[j];for(let se=0;se<z.length;se++){W++;const t=z[se],x=P(t);this.histogram[x]=(this.histogram[x]||0)+1}W++;const K=P(`
`);this.histogram[K]=(this.histogram[K]||0)+1}this.totalCount=W}computeSimilarity(D){var F,V;let W=0;const j=Math.max(this.histogram.length,D.histogram.length);for(let z=0;z<j;z++)W+=Math.abs(((F=this.histogram[z])!==null&&F!==void 0?F:0)-((V=D.histogram[z])!==null&&V!==void 0?V:0));return 1-W/(this.totalCount+D.totalCount)}}}),ee(te[45],ne([0,1,22,27,28,5,2,9,12]),function(O,n,R,M,i,u,f,v,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const r=3;class g{computeDiff(s,a,l){var p;const L=new y(s,a,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let E=null;for(const P of L.changes){let T;P.originalEndLineNumber===0?T=new o.LineRange(P.originalStartLineNumber+1,P.originalStartLineNumber+1):T=new o.LineRange(P.originalStartLineNumber,P.originalEndLineNumber+1);let k;P.modifiedEndLineNumber===0?k=new o.LineRange(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):k=new o.LineRange(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let D=new i.DetailedLineRangeMapping(T,k,(p=P.charChanges)===null||p===void 0?void 0:p.map(F=>new i.RangeMapping(new f.Range(F.originalStartLineNumber,F.originalStartColumn,F.originalEndLineNumber,F.originalEndColumn),new f.Range(F.modifiedStartLineNumber,F.modifiedStartColumn,F.modifiedEndLineNumber,F.modifiedEndColumn))));E&&(E.modified.endLineNumberExclusive===D.modified.startLineNumber||E.original.endLineNumberExclusive===D.original.startLineNumber)&&(D=new i.DetailedLineRangeMapping(E.original.join(D.original),E.modified.join(D.modified),E.innerChanges&&D.innerChanges?E.innerChanges.concat(D.innerChanges):void 0),A.pop()),A.push(D),E=D}return(0,v.assertFn)(()=>(0,v.checkAdjacentItems)(A,(P,T)=>T.original.startLineNumber-P.original.endLineNumberExclusive===T.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<T.original.startLineNumber&&P.modified.endLineNumberExclusive<T.modified.startLineNumber)),new M.LinesDiff(A,[],L.quitEarly)}}n.LegacyLinesDiffComputer=g;function e(S,s,a,l){return new R.LcsDiff(S,s,a).ComputeDiff(l)}class d{constructor(s){const a=[],l=[];for(let p=0,b=s.length;p<b;p++)a[p]=w(s[p],1),l[p]=N(s[p],1);this.lines=s,this._startColumns=a,this._endColumns=l}getElements(){const s=[];for(let a=0,l=this.lines.length;a<l;a++)s[a]=this.lines[a].substring(this._startColumns[a]-1,this._endColumns[a]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,a,l){const p=[],b=[],L=[];let A=0;for(let E=a;E<=l;E++){const P=this.lines[E],T=s?this._startColumns[E]:1,k=s?this._endColumns[E]:P.length+1;for(let D=T;D<k;D++)p[A]=P.charCodeAt(D-1),b[A]=E+1,L[A]=D,A++;!s&&E<l&&(p[A]=10,b[A]=E+1,L[A]=P.length+1,A++)}return new h(p,b,L)}}class h{constructor(s,a,l){this._charCodes=s,this._lineNumbers=a,this._columns=l}toString(){return"["+this._charCodes.map((s,a)=>(s===10?"\\n":String.fromCharCode(s))+`-(${this._lineNumbers[a]},${this._columns[a]})`).join(", ")+"]"}_assertIndex(s,a){if(s<0||s>=a.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(s){return s>0&&s===this._lineNumbers.length?this.getEndLineNumber(s-1):(this._assertIndex(s,this._lineNumbers),this._lineNumbers[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this._assertIndex(s,this._lineNumbers),this._charCodes[s]===10?this._lineNumbers[s]+1:this._lineNumbers[s])}getStartColumn(s){return s>0&&s===this._columns.length?this.getEndColumn(s-1):(this._assertIndex(s,this._columns),this._columns[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this._assertIndex(s,this._columns),this._charCodes[s]===10?1:this._columns[s]+1)}}class c{constructor(s,a,l,p,b,L,A,E){this.originalStartLineNumber=s,this.originalStartColumn=a,this.originalEndLineNumber=l,this.originalEndColumn=p,this.modifiedStartLineNumber=b,this.modifiedStartColumn=L,this.modifiedEndLineNumber=A,this.modifiedEndColumn=E}static createFromDiffChange(s,a,l){const p=a.getStartLineNumber(s.originalStart),b=a.getStartColumn(s.originalStart),L=a.getEndLineNumber(s.originalStart+s.originalLength-1),A=a.getEndColumn(s.originalStart+s.originalLength-1),E=l.getStartLineNumber(s.modifiedStart),P=l.getStartColumn(s.modifiedStart),T=l.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),k=l.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new c(p,b,L,A,E,P,T,k)}}function _(S){if(S.length<=1)return S;const s=[S[0]];let a=s[0];for(let l=1,p=S.length;l<p;l++){const b=S[l],L=b.originalStart-(a.originalStart+a.originalLength),A=b.modifiedStart-(a.modifiedStart+a.modifiedLength);Math.min(L,A)<r?(a.originalLength=b.originalStart+b.originalLength-a.originalStart,a.modifiedLength=b.modifiedStart+b.modifiedLength-a.modifiedStart):(s.push(b),a=b)}return s}class m{constructor(s,a,l,p,b){this.originalStartLineNumber=s,this.originalEndLineNumber=a,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=p,this.charChanges=b}static createFromDiffResult(s,a,l,p,b,L,A){let E,P,T,k,D;if(a.originalLength===0?(E=l.getStartLineNumber(a.originalStart)-1,P=0):(E=l.getStartLineNumber(a.originalStart),P=l.getEndLineNumber(a.originalStart+a.originalLength-1)),a.modifiedLength===0?(T=p.getStartLineNumber(a.modifiedStart)-1,k=0):(T=p.getStartLineNumber(a.modifiedStart),k=p.getEndLineNumber(a.modifiedStart+a.modifiedLength-1)),L&&a.originalLength>0&&a.originalLength<20&&a.modifiedLength>0&&a.modifiedLength<20&&b()){const F=l.createCharSequence(s,a.originalStart,a.originalStart+a.originalLength-1),V=p.createCharSequence(s,a.modifiedStart,a.modifiedStart+a.modifiedLength-1);if(F.getElements().length>0&&V.getElements().length>0){let W=e(F,V,b,!0).changes;A&&(W=_(W)),D=[];for(let j=0,z=W.length;j<z;j++)D.push(c.createFromDiffChange(W[j],F,V))}}return new m(E,P,T,k,D)}}class y{constructor(s,a,l){this.shouldComputeCharChanges=l.shouldComputeCharChanges,this.shouldPostProcessCharChanges=l.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=l.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=l.shouldMakePrettyDiff,this.originalLines=s,this.modifiedLines=a,this.original=new d(s),this.modified=new d(a),this.continueLineDiff=C(l.maxComputationTime),this.continueCharDiff=C(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),a=s.changes,l=s.quitEarly;if(this.shouldIgnoreTrimWhitespace){const A=[];for(let E=0,P=a.length;E<P;E++)A.push(m.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a[E],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:l,changes:A}}const p=[];let b=0,L=0;for(let A=-1,E=a.length;A<E;A++){const P=A+1<E?a[A+1]:null,T=P?P.originalStart:this.originalLines.length,k=P?P.modifiedStart:this.modifiedLines.length;for(;b<T&&L<k;){const D=this.originalLines[b],F=this.modifiedLines[L];if(D!==F){{let V=w(D,1),W=w(F,1);for(;V>1&&W>1;){const j=D.charCodeAt(V-2),z=F.charCodeAt(W-2);if(j!==z)break;V--,W--}(V>1||W>1)&&this._pushTrimWhitespaceCharChange(p,b+1,1,V,L+1,1,W)}{let V=N(D,1),W=N(F,1);const j=D.length+1,z=F.length+1;for(;V<j&&W<z;){const K=D.charCodeAt(V-1),se=D.charCodeAt(W-1);if(K!==se)break;V++,W++}(V<j||W<z)&&this._pushTrimWhitespaceCharChange(p,b+1,V,j,L+1,W,z)}}b++,L++}P&&(p.push(m.createFromDiffResult(this.shouldIgnoreTrimWhitespace,P,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),b+=P.originalLength,L+=P.modifiedLength)}return{quitEarly:l,changes:p}}_pushTrimWhitespaceCharChange(s,a,l,p,b,L,A){if(this._mergeTrimWhitespaceCharChange(s,a,l,p,b,L,A))return;let E;this.shouldComputeCharChanges&&(E=[new c(a,l,a,p,b,L,b,A)]),s.push(new m(a,a,b,b,E))}_mergeTrimWhitespaceCharChange(s,a,l,p,b,L,A){const E=s.length;if(E===0)return!1;const P=s[E-1];return P.originalEndLineNumber===0||P.modifiedEndLineNumber===0?!1:P.originalEndLineNumber===a&&P.modifiedEndLineNumber===b?(this.shouldComputeCharChanges&&P.charChanges&&P.charChanges.push(new c(a,l,a,p,b,L,b,A)),!0):P.originalEndLineNumber+1===a&&P.modifiedEndLineNumber+1===b?(P.originalEndLineNumber=a,P.modifiedEndLineNumber=b,this.shouldComputeCharChanges&&P.charChanges&&P.charChanges.push(new c(a,l,a,p,b,L,b,A)),!0):!1}}n.DiffComputer=y;function w(S,s){const a=u.firstNonWhitespaceIndex(S);return a===-1?s:a+1}function N(S,s){const a=u.lastNonWhitespaceIndex(S);return a===-1?s:a+2}function C(S){if(S===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<S}}),ee(te[46],ne([0,1,45,44]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new R.LegacyLinesDiffComputer,getAdvanced:()=>new M.AdvancedLinesDiffComputer}}),ee(te[47],ne([0,1,31]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function M(d){const h=[];for(const c of d){const _=Number(c);(_||_===0&&c.replace(/\s/g,"")!=="")&&h.push(_)}return h}function i(d,h,c,_){return{red:d/255,blue:c/255,green:h/255,alpha:_}}function u(d,h){const c=h.index,_=h[0].length;if(!c)return;const m=d.positionAt(c);return{startLineNumber:m.lineNumber,startColumn:m.column,endLineNumber:m.lineNumber,endColumn:m.column+_}}function f(d,h){if(!d)return;const c=R.Color.Format.CSS.parseHex(h);if(c)return{range:d,color:i(c.rgba.r,c.rgba.g,c.rgba.b,c.rgba.a)}}function v(d,h,c){if(!d||h.length!==1)return;const m=h[0].values(),y=M(m);return{range:d,color:i(y[0],y[1],y[2],c?y[3]:1)}}function o(d,h,c){if(!d||h.length!==1)return;const m=h[0].values(),y=M(m),w=new R.Color(new R.HSLA(y[0],y[1]/100,y[2]/100,c?y[3]:1));return{range:d,color:i(w.rgba.r,w.rgba.g,w.rgba.b,w.rgba.a)}}function r(d,h){return typeof d=="string"?[...d.matchAll(h)]:d.findMatches(h)}function g(d){const h=[],_=r(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(_.length>0)for(const m of _){const y=m.filter(S=>S!==void 0),w=y[1],N=y[2];if(!N)continue;let C;if(w==="rgb"){const S=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;C=v(u(d,m),r(N,S),!1)}else if(w==="rgba"){const S=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;C=v(u(d,m),r(N,S),!0)}else if(w==="hsl"){const S=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;C=o(u(d,m),r(N,S),!1)}else if(w==="hsla"){const S=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;C=o(u(d,m),r(N,S),!0)}else w==="#"&&(C=f(u(d,m),w+N));C&&h.push(C)}return h}function e(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:g(d)}n.computeDefaultDocumentColors=e}),ee(te[48],ne([0,1,25]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(d,h,c){const _=new Uint8Array(d*h);for(let m=0,y=d*h;m<y;m++)_[m]=c;this._data=_,this.rows=d,this.cols=h}get(d,h){return this._data[d*this.cols+h]}set(d,h,c){this._data[d*this.cols+h]=c}}class i{constructor(d){let h=0,c=0;for(let m=0,y=d.length;m<y;m++){const[w,N,C]=d[m];N>h&&(h=N),w>c&&(c=w),C>c&&(c=C)}h++,c++;const _=new M(c,h,0);for(let m=0,y=d.length;m<y;m++){const[w,N,C]=d[m];_.set(w,N,C)}this._states=_,this._maxCharCode=h}nextState(d,h){return h<0||h>=this._maxCharCode?0:this._states.get(d,h)}}n.StateMachine=i;let u=null;function f(){return u===null&&(u=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),u}let v=null;function o(){if(v===null){v=new R.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)v.set(e.charCodeAt(h),1);const d=".,;:";for(let h=0;h<d.length;h++)v.set(d.charCodeAt(h),2)}return v}class r{static _createLink(d,h,c,_,m){let y=m-1;do{const w=h.charCodeAt(y);if(d.get(w)!==2)break;y--}while(y>_);if(_>0){const w=h.charCodeAt(_-1),N=h.charCodeAt(y);(w===40&&N===41||w===91&&N===93||w===123&&N===125)&&y--}return{range:{startLineNumber:c,startColumn:_+1,endLineNumber:c,endColumn:y+2},url:h.substring(_,y+1)}}static computeLinks(d,h=f()){const c=o(),_=[];for(let m=1,y=d.getLineCount();m<=y;m++){const w=d.getLineContent(m),N=w.length;let C=0,S=0,s=0,a=1,l=!1,p=!1,b=!1,L=!1;for(;C<N;){let A=!1;const E=w.charCodeAt(C);if(a===13){let P;switch(E){case 40:l=!0,P=0;break;case 41:P=l?0:1;break;case 91:b=!0,p=!0,P=0;break;case 93:b=!1,P=p?0:1;break;case 123:L=!0,P=0;break;case 125:P=L?0:1;break;case 39:case 34:case 96:s===E?P=1:s===39||s===34||s===96?P=0:P=1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=b?0:1;break;default:P=c.get(E)}P===1&&(_.push(r._createLink(c,w,m,S,C)),A=!0)}else if(a===12){let P;E===91?(p=!0,P=0):P=c.get(E),P===1?A=!0:a=13}else a=h.nextState(a,E),a===0&&(A=!0);A&&(a=1,l=!1,p=!1,L=!1,S=C+1,s=E),C++}a===13&&_.push(r._createLink(c,w,m,S,N))}return _}}n.LinkComputer=r;function g(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:r.computeLinks(e)}n.computeLinks=g}),ee(te[49],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class R{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,f,v,o){if(i&&u){const r=this.doNavigateValueSet(u,o);if(r)return{range:i,value:r}}if(f&&v){const r=this.doNavigateValueSet(v,o);if(r)return{range:f,value:r}}return null}doNavigateValueSet(i,u){const f=this.numberReplace(i,u);return f!==null?f:this.textReplace(i,u)}numberReplace(i,u){const f=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let v=Number(i);const o=parseFloat(i);return!isNaN(v)&&!isNaN(o)&&v===o?v===0&&!u?null:(v=Math.floor(v*f),v+=u?f:-f,String(v/f)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,f){let v=null;for(let o=0,r=i.length;v===null&&o<r;o++)v=this.valueSetReplace(i[o],u,f);return v}valueSetReplace(i,u,f){let v=i.indexOf(u);return v>=0?(v+=f?1:-1,v<0?v=i.length-1:v%=i.length,i[v]):null}}n.BasicInplaceReplace=R,R.INSTANCE=new R}),ee(te[50],ne([0,1,11]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var M;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var i;(function(c){c[c.Left=1]="Left",c[c.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var u;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(u||(n.MinimapPosition=u={}));var f;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(f||(n.InjectedTextCursorStops=f={}));class v{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),_.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,_.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!_.insertSpaces,this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=!!_.trimAutoWhitespace,this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this._indentSizeIsTabSize===_._indentSizeIsTabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,R.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}n.TextModelResolvedOptions=v;class o{constructor(_,m){this._findMatchBrand=void 0,this.range=_,this.matches=m}}n.FindMatch=o;function r(c){return c&&typeof c.read=="function"}n.isITextSnapshot=r;class g{constructor(_,m,y,w,N,C){this.identifier=_,this.range=m,this.text=y,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=N,this._isTracked=C}}n.ValidAnnotatedEditOperation=g;class e{constructor(_,m,y){this.regex=_,this.wordSeparators=m,this.simpleSearch=y}}n.SearchData=e;class d{constructor(_,m,y){this.reverseEdits=_,this.changes=m,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=d;function h(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}n.shouldSynchronizeModel=h}),ee(te[51],ne([0,1,16,24]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(o){this.values=o,this.prefixSum=new Uint32Array(o.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(o,r){o=(0,M.toUint32)(o);const g=this.values,e=this.prefixSum,d=r.length;return d===0?!1:(this.values=new Uint32Array(g.length+d),this.values.set(g.subarray(0,o),0),this.values.set(g.subarray(o),o+d),this.values.set(r,o),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(o,r){return o=(0,M.toUint32)(o),r=(0,M.toUint32)(r),this.values[o]===r?!1:(this.values[o]=r,o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),!0)}removeValues(o,r){o=(0,M.toUint32)(o),r=(0,M.toUint32)(r);const g=this.values,e=this.prefixSum;if(o>=g.length)return!1;const d=g.length-o;return r>=d&&(r=d),r===0?!1:(this.values=new Uint32Array(g.length-r),this.values.set(g.subarray(0,o),0),this.values.set(g.subarray(o+r),o),this.prefixSum=new Uint32Array(this.values.length),o-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=o-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(o){return o<0?0:(o=(0,M.toUint32)(o),this._getPrefixSum(o))}_getPrefixSum(o){if(o<=this.prefixSumValidIndex[0])return this.prefixSum[o];let r=this.prefixSumValidIndex[0]+1;r===0&&(this.prefixSum[0]=this.values[0],r++),o>=this.values.length&&(o=this.values.length-1);for(let g=r;g<=o;g++)this.prefixSum[g]=this.prefixSum[g-1]+this.values[g];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],o),this.prefixSum[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let r=0,g=this.values.length-1,e=0,d=0,h=0;for(;r<=g;)if(e=r+(g-r)/2|0,d=this.prefixSum[e],h=d-this.values[e],o<h)g=e-1;else if(o>=d)r=e+1;else break;return new f(e,o-h)}}n.PrefixSumComputer=i;class u{constructor(o){this._values=o,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(o){return this._ensureValid(),o===0?0:this._prefixSum[o-1]}getIndexOf(o){this._ensureValid();const r=this._indexBySum[o],g=r>0?this._prefixSum[r-1]:0;return new f(r,o-g)}removeValues(o,r){this._values.splice(o,r),this._invalidate(o)}insertValues(o,r){this._values=(0,R.arrayInsert)(this._values,o,r),this._invalidate(o)}_invalidate(o){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,o-1)}_ensureValid(){if(!this._isValid){for(let o=this._validEndIndex+1,r=this._values.length;o<r;o++){const g=this._values[o],e=o>0?this._prefixSum[o-1]:0;this._prefixSum[o]=e+g;for(let d=0;d<g;d++)this._indexBySum[e+d]=o}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(o,r){this._values[o]!==r&&(this._values[o]=r,this._invalidate(o))}}n.ConstantTimePrefixSumComputer=u;class f{constructor(o,r){this.index=o,this.remainder=r,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=r}}n.PrefixSumIndexOfResult=f}),ee(te[52],ne([0,1,5,3,51]),function(O,n,R,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class u{constructor(v,o,r,g){this._uri=v,this._lines=o,this._eol=r,this._versionId=g,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(v){v.eol&&v.eol!==this._eol&&(this._eol=v.eol,this._lineStarts=null);const o=v.changes;for(const r of o)this._acceptDeleteRange(r.range),this._acceptInsertText(new M.Position(r.range.startLineNumber,r.range.startColumn),r.text);this._versionId=v.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const v=this._eol.length,o=this._lines.length,r=new Uint32Array(o);for(let g=0;g<o;g++)r[g]=this._lines[g].length+v;this._lineStarts=new i.PrefixSumComputer(r)}}_setLineText(v,o){this._lines[v]=o,this._lineStarts&&this._lineStarts.setValue(v,this._lines[v].length+this._eol.length)}_acceptDeleteRange(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.startLineNumber-1].substring(v.endColumn-1));return}this._setLineText(v.startLineNumber-1,this._lines[v.startLineNumber-1].substring(0,v.startColumn-1)+this._lines[v.endLineNumber-1].substring(v.endColumn-1)),this._lines.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}_acceptInsertText(v,o){if(o.length===0)return;const r=(0,R.splitLines)(o);if(r.length===1){this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+r[0]+this._lines[v.lineNumber-1].substring(v.column-1));return}r[r.length-1]+=this._lines[v.lineNumber-1].substring(v.column-1),this._setLineText(v.lineNumber-1,this._lines[v.lineNumber-1].substring(0,v.column-1)+r[0]);const g=new Uint32Array(r.length-1);for(let e=1;e<r.length;e++)this._lines.splice(v.lineNumber+e-1,0,r[e]),g[e-1]=r[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(v.lineNumber,g)}}n.MirrorTextModel=u}),ee(te[53],ne([0,1,5,39,3,2,50]),function(O,n,R,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const v=999;class o{constructor(w,N,C,S){this.searchString=w,this.isRegex=N,this.matchCase=C,this.wordSeparators=S}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=r(this.searchString):w=this.searchString.indexOf(`
`)>=0;let N=null;try{N=R.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!N)return null;let C=!this.isRegex&&!w;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new f.SearchData(N,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}n.SearchParams=o;function r(y){if(!y||y.length===0)return!1;for(let w=0,N=y.length;w<N;w++){const C=y.charCodeAt(w);if(C===10)return!0;if(C===92){if(w++,w>=N)break;const S=y.charCodeAt(w);if(S===110||S===114||S===87)return!0}}return!1}n.isMultilineRegexSource=r;function g(y,w,N){if(!N)return new f.FindMatch(y,null);const C=[];for(let S=0,s=w.length;S<s;S++)C[S]=w[S];return new f.FindMatch(y,C)}n.createFindMatch=g;class e{constructor(w){const N=[];let C=0;for(let S=0,s=w.length;S<s;S++)w.charCodeAt(S)===10&&(N[C++]=S);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(w){const N=this._lineFeedsOffsets;let C=0,S=N.length-1;if(S===-1||w<=N[0])return 0;for(;C<S;){const s=C+((S-C)/2>>0);N[s]>=w?S=s-1:N[s+1]>=w?(C=s,S=s):C=s+1}return C+1}}class d{static findMatches(w,N,C,S,s){const a=N.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(w,C,new m(a.wordSeparators,a.regex),S,s):this._doFindMatchesLineByLine(w,C,a,S,s):[]}static _getMultilineMatchRange(w,N,C,S,s,a){let l,p=0;S?(p=S.findLineFeedCountBeforeOffset(s),l=N+s+p):l=N+s;let b;if(S){const P=S.findLineFeedCountBeforeOffset(s+a.length)-p;b=l+a.length+P}else b=l+a.length;const L=w.getPositionAt(l),A=w.getPositionAt(b);return new u.Range(L.lineNumber,L.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(w,N,C,S,s){const a=w.getOffsetAt(N.getStartPosition()),l=w.getValueInRange(N,1),p=w.getEOL()===`\r
`?new e(l):null,b=[];let L=0,A;for(C.reset(0);A=C.next(l);)if(b[L++]=g(this._getMultilineMatchRange(w,a,l,p,A.index,A[0]),A,S),L>=s)return b;return b}static _doFindMatchesLineByLine(w,N,C,S,s){const a=[];let l=0;if(N.startLineNumber===N.endLineNumber){const b=w.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return l=this._findMatchesInLine(C,b,N.startLineNumber,N.startColumn-1,l,a,S,s),a}const p=w.getLineContent(N.startLineNumber).substring(N.startColumn-1);l=this._findMatchesInLine(C,p,N.startLineNumber,N.startColumn-1,l,a,S,s);for(let b=N.startLineNumber+1;b<N.endLineNumber&&l<s;b++)l=this._findMatchesInLine(C,w.getLineContent(b),b,0,l,a,S,s);if(l<s){const b=w.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);l=this._findMatchesInLine(C,b,N.endLineNumber,0,l,a,S,s)}return a}static _findMatchesInLine(w,N,C,S,s,a,l,p){const b=w.wordSeparators;if(!l&&w.simpleSearch){const E=w.simpleSearch,P=E.length,T=N.length;let k=-P;for(;(k=N.indexOf(E,k+P))!==-1;)if((!b||_(b,N,T,k,P))&&(a[s++]=new f.FindMatch(new u.Range(C,k+1+S,C,k+1+P+S),null),s>=p))return s;return s}const L=new m(w.wordSeparators,w.regex);let A;L.reset(0);do if(A=L.next(N),A&&(a[s++]=g(new u.Range(C,A.index+1+S,C,A.index+1+A[0].length+S),A,l),s>=p))return s;while(A);return s}static findNextMatch(w,N,C,S){const s=N.parseSearchRequest();if(!s)return null;const a=new m(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(w,C,a,S):this._doFindNextMatchLineByLine(w,C,a,S)}static _doFindNextMatchMultiline(w,N,C,S){const s=new i.Position(N.lineNumber,1),a=w.getOffsetAt(s),l=w.getLineCount(),p=w.getValueInRange(new u.Range(s.lineNumber,s.column,l,w.getLineMaxColumn(l)),1),b=w.getEOL()===`\r
`?new e(p):null;C.reset(N.column-1);const L=C.next(p);return L?g(this._getMultilineMatchRange(w,a,p,b,L.index,L[0]),L,S):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(w,new i.Position(1,1),C,S):null}static _doFindNextMatchLineByLine(w,N,C,S){const s=w.getLineCount(),a=N.lineNumber,l=w.getLineContent(a),p=this._findFirstMatchInLine(C,l,a,N.column,S);if(p)return p;for(let b=1;b<=s;b++){const L=(a+b-1)%s,A=w.getLineContent(L+1),E=this._findFirstMatchInLine(C,A,L+1,1,S);if(E)return E}return null}static _findFirstMatchInLine(w,N,C,S,s){w.reset(S-1);const a=w.next(N);return a?g(new u.Range(C,a.index+1,C,a.index+1+a[0].length),a,s):null}static findPreviousMatch(w,N,C,S){const s=N.parseSearchRequest();if(!s)return null;const a=new m(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(w,C,a,S):this._doFindPreviousMatchLineByLine(w,C,a,S)}static _doFindPreviousMatchMultiline(w,N,C,S){const s=this._doFindMatchesMultiline(w,new u.Range(1,1,N.lineNumber,N.column),C,S,10*v);if(s.length>0)return s[s.length-1];const a=w.getLineCount();return N.lineNumber!==a||N.column!==w.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(w,new i.Position(a,w.getLineMaxColumn(a)),C,S):null}static _doFindPreviousMatchLineByLine(w,N,C,S){const s=w.getLineCount(),a=N.lineNumber,l=w.getLineContent(a).substring(0,N.column-1),p=this._findLastMatchInLine(C,l,a,S);if(p)return p;for(let b=1;b<=s;b++){const L=(s+a-b-1)%s,A=w.getLineContent(L+1),E=this._findLastMatchInLine(C,A,L+1,S);if(E)return E}return null}static _findLastMatchInLine(w,N,C,S){let s=null,a;for(w.reset(0);a=w.next(N);)s=g(new u.Range(C,a.index+1,C,a.index+1+a[0].length),a,S);return s}}n.TextModelSearch=d;function h(y,w,N,C,S){if(C===0)return!0;const s=w.charCodeAt(C-1);if(y.get(s)!==0||s===13||s===10)return!0;if(S>0){const a=w.charCodeAt(C);if(y.get(a)!==0)return!0}return!1}function c(y,w,N,C,S){if(C+S===N)return!0;const s=w.charCodeAt(C+S);if(y.get(s)!==0||s===13||s===10)return!0;if(S>0){const a=w.charCodeAt(C+S-1);if(y.get(a)!==0)return!0}return!1}function _(y,w,N,C,S){return h(y,w,N,C,S)&&c(y,w,N,C,S)}n.isValidMatch=_;class m{constructor(w,N){this._wordSeparators=w,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(w){this._searchRegex.lastIndex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(w){const N=w.length;let C;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(C=this._searchRegex.exec(w),!C))return null;const S=C.index,s=C[0].length;if(S===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){R.getNextCodePoint(w,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=S,this._prevMatchLength=s,!this._wordSeparators||_(this._wordSeparators,w,N,S,s))return C}while(C);return null}}n.Searcher=m}),ee(te[54],ne([0,1,2,53,5,9,26]),function(O,n,R,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class v{static computeUnicodeHighlights(d,h,c){const _=c?c.startLineNumber:1,m=c?c.endLineNumber:d.getLineCount(),y=new r(h),w=y.getCandidateCodePoints();let N;w==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${o(Array.from(w))}`,"g");const C=new M.Searcher(null,N),S=[];let s=!1,a,l=0,p=0,b=0;e:for(let L=_,A=m;L<=A;L++){const E=d.getLineContent(L),P=E.length;C.reset(0);do if(a=C.next(E),a){let T=a.index,k=a.index+a[0].length;if(T>0){const W=E.charCodeAt(T-1);i.isHighSurrogate(W)&&T--}if(k+1<P){const W=E.charCodeAt(k-1);i.isHighSurrogate(W)&&k++}const D=E.substring(T,k);let F=(0,f.getWordAtText)(T+1,f.DEFAULT_WORD_REGEXP,E,0);F&&F.endColumn<=T+1&&(F=null);const V=y.shouldHighlightNonBasicASCII(D,F?F.word:null);if(V!==0){V===3?l++:V===2?p++:V===1?b++:(0,u.assertNever)(V);const W=1e3;if(S.length>=W){s=!0;break e}S.push(new R.Range(L,T+1,L,k+1))}}while(a)}return{ranges:S,hasMore:s,ambiguousCharacterCount:l,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(d,h){const c=new r(h);switch(c.shouldHighlightNonBasicASCII(d,null)){case 0:return null;case 2:return{kind:1};case 3:{const m=d.codePointAt(0),y=c.ambiguousCharacters.getPrimaryConfusable(m),w=i.AmbiguousCharacters.getLocales().filter(N=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,N])).isAmbiguous(m));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:w}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=v;function o(e,d){return`[${i.escapeRegExpCharacters(e.map(c=>String.fromCodePoint(c)).join(""))}]`}class r{constructor(d){this.options=d,this.allowedCodePoints=new Set(d.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(d.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const d=new Set;if(this.options.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)g(String.fromCodePoint(h))||d.add(h);if(this.options.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())d.add(h);for(const h of this.allowedCodePoints)d.delete(h);return d}shouldHighlightNonBasicASCII(d,h){const c=d.codePointAt(0);if(this.allowedCodePoints.has(c))return 0;if(this.options.nonBasicASCII)return 1;let _=!1,m=!1;if(h)for(const y of h){const w=y.codePointAt(0),N=i.isBasicASCII(y);_=_||N,!N&&!this.ambiguousCharacters.isAmbiguous(w)&&!i.InvisibleCharacters.isInvisibleCharacter(w)&&(m=!0)}return!_&&m?0:this.options.invisibleCharacters&&!g(d)&&i.InvisibleCharacters.isInvisibleCharacter(c)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(c)?3:0}}function g(e){return e===" "||e===`
`||e==="	"}}),ee(te[55],ne([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var R;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(R||(n.AccessibilitySupport=R={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M||(n.CodeActionTriggerType=M={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var u;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(u||(n.CompletionItemKind=u={}));var f;(function(t){t[t.Deprecated=1]="Deprecated"})(f||(n.CompletionItemTag=f={}));var v;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(v||(n.CompletionTriggerKind=v={}));var o;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(o||(n.ContentWidgetPositionPreference=o={}));var r;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(r||(n.CursorChangeReason=r={}));var g;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(g||(n.DefaultEndOfLine=g={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var d;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(d||(n.EditorAutoIndentStrategy=d={}));var h;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=8]="autoClosingDelete",t[t.autoClosingOvertype=9]="autoClosingOvertype",t[t.autoClosingQuotes=10]="autoClosingQuotes",t[t.autoIndent=11]="autoIndent",t[t.automaticLayout=12]="automaticLayout",t[t.autoSurround=13]="autoSurround",t[t.bracketPairColorization=14]="bracketPairColorization",t[t.guides=15]="guides",t[t.codeLens=16]="codeLens",t[t.codeLensFontFamily=17]="codeLensFontFamily",t[t.codeLensFontSize=18]="codeLensFontSize",t[t.colorDecorators=19]="colorDecorators",t[t.colorDecoratorsLimit=20]="colorDecoratorsLimit",t[t.columnSelection=21]="columnSelection",t[t.comments=22]="comments",t[t.contextmenu=23]="contextmenu",t[t.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",t[t.cursorBlinking=25]="cursorBlinking",t[t.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",t[t.cursorStyle=27]="cursorStyle",t[t.cursorSurroundingLines=28]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",t[t.cursorWidth=30]="cursorWidth",t[t.disableLayerHinting=31]="disableLayerHinting",t[t.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",t[t.domReadOnly=33]="domReadOnly",t[t.dragAndDrop=34]="dragAndDrop",t[t.dropIntoEditor=35]="dropIntoEditor",t[t.emptySelectionClipboard=36]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",t[t.extraEditorClassName=38]="extraEditorClassName",t[t.fastScrollSensitivity=39]="fastScrollSensitivity",t[t.find=40]="find",t[t.fixedOverflowWidgets=41]="fixedOverflowWidgets",t[t.folding=42]="folding",t[t.foldingStrategy=43]="foldingStrategy",t[t.foldingHighlight=44]="foldingHighlight",t[t.foldingImportsByDefault=45]="foldingImportsByDefault",t[t.foldingMaximumRegions=46]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=48]="fontFamily",t[t.fontInfo=49]="fontInfo",t[t.fontLigatures=50]="fontLigatures",t[t.fontSize=51]="fontSize",t[t.fontWeight=52]="fontWeight",t[t.fontVariations=53]="fontVariations",t[t.formatOnPaste=54]="formatOnPaste",t[t.formatOnType=55]="formatOnType",t[t.glyphMargin=56]="glyphMargin",t[t.gotoLocation=57]="gotoLocation",t[t.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",t[t.hover=59]="hover",t[t.inDiffEditor=60]="inDiffEditor",t[t.inlineSuggest=61]="inlineSuggest",t[t.letterSpacing=62]="letterSpacing",t[t.lightbulb=63]="lightbulb",t[t.lineDecorationsWidth=64]="lineDecorationsWidth",t[t.lineHeight=65]="lineHeight",t[t.lineNumbers=66]="lineNumbers",t[t.lineNumbersMinChars=67]="lineNumbersMinChars",t[t.linkedEditing=68]="linkedEditing",t[t.links=69]="links",t[t.matchBrackets=70]="matchBrackets",t[t.minimap=71]="minimap",t[t.mouseStyle=72]="mouseStyle",t[t.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=74]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",t[t.multiCursorModifier=76]="multiCursorModifier",t[t.multiCursorPaste=77]="multiCursorPaste",t[t.multiCursorLimit=78]="multiCursorLimit",t[t.occurrencesHighlight=79]="occurrencesHighlight",t[t.overviewRulerBorder=80]="overviewRulerBorder",t[t.overviewRulerLanes=81]="overviewRulerLanes",t[t.padding=82]="padding",t[t.pasteAs=83]="pasteAs",t[t.parameterHints=84]="parameterHints",t[t.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",t[t.quickSuggestions=87]="quickSuggestions",t[t.quickSuggestionsDelay=88]="quickSuggestionsDelay",t[t.readOnly=89]="readOnly",t[t.readOnlyMessage=90]="readOnlyMessage",t[t.renameOnType=91]="renameOnType",t[t.renderControlCharacters=92]="renderControlCharacters",t[t.renderFinalNewline=93]="renderFinalNewline",t[t.renderLineHighlight=94]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=96]="renderValidationDecorations",t[t.renderWhitespace=97]="renderWhitespace",t[t.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",t[t.roundedSelection=99]="roundedSelection",t[t.rulers=100]="rulers",t[t.scrollbar=101]="scrollbar",t[t.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=103]="scrollBeyondLastLine",t[t.scrollPredominantAxis=104]="scrollPredominantAxis",t[t.selectionClipboard=105]="selectionClipboard",t[t.selectionHighlight=106]="selectionHighlight",t[t.selectOnLineNumbers=107]="selectOnLineNumbers",t[t.showFoldingControls=108]="showFoldingControls",t[t.showUnused=109]="showUnused",t[t.snippetSuggestions=110]="snippetSuggestions",t[t.smartSelect=111]="smartSelect",t[t.smoothScrolling=112]="smoothScrolling",t[t.stickyScroll=113]="stickyScroll",t[t.stickyTabStops=114]="stickyTabStops",t[t.stopRenderingLineAfter=115]="stopRenderingLineAfter",t[t.suggest=116]="suggest",t[t.suggestFontSize=117]="suggestFontSize",t[t.suggestLineHeight=118]="suggestLineHeight",t[t.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",t[t.suggestSelection=120]="suggestSelection",t[t.tabCompletion=121]="tabCompletion",t[t.tabIndex=122]="tabIndex",t[t.unicodeHighlighting=123]="unicodeHighlighting",t[t.unusualLineTerminators=124]="unusualLineTerminators",t[t.useShadowDOM=125]="useShadowDOM",t[t.useTabStops=126]="useTabStops",t[t.wordBreak=127]="wordBreak",t[t.wordSeparators=128]="wordSeparators",t[t.wordWrap=129]="wordWrap",t[t.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=132]="wordWrapColumn",t[t.wordWrapOverride1=133]="wordWrapOverride1",t[t.wordWrapOverride2=134]="wordWrapOverride2",t[t.wrappingIndent=135]="wrappingIndent",t[t.wrappingStrategy=136]="wrappingStrategy",t[t.showDeprecated=137]="showDeprecated",t[t.inlayHints=138]="inlayHints",t[t.editorClassName=139]="editorClassName",t[t.pixelRatio=140]="pixelRatio",t[t.tabFocusMode=141]="tabFocusMode",t[t.layoutInfo=142]="layoutInfo",t[t.wrappingInfo=143]="wrappingInfo",t[t.defaultColorDecorators=144]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(h||(n.EditorOption=h={}));var c;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(c||(n.EndOfLinePreference=c={}));var _;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(_||(n.EndOfLineSequence=_={}));var m;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(m||(n.GlyphMarginLane=m={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var w;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(w||(n.InjectedTextCursorStops=w={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var C;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(C||(n.InlineCompletionTriggerKind=C={}));var S;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(S||(n.KeyCode=S={}));var s;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(s||(n.MarkerSeverity=s={}));var a;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(a||(n.MarkerTag=a={}));var l;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(l||(n.MinimapPosition=l={}));var p;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(p||(n.MouseTargetType=p={}));var b;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(b||(n.OverlayWidgetPositionPreference=b={}));var L;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(L||(n.OverviewRulerLane=L={}));var A;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(A||(n.PositionAffinity=A={}));var E;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(E||(n.RenderLineNumbersType=E={}));var P;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(P||(n.RenderMinimap=P={}));var T;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(T||(n.ScrollType=T={}));var k;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(k||(n.ScrollbarVisibility=k={}));var D;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(D||(n.SelectionDirection=D={}));var F;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(F||(n.SignatureHelpTriggerKind=F={}));var V;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(V||(n.SymbolKind=V={}));var W;(function(t){t[t.Deprecated=1]="Deprecated"})(W||(n.SymbolTag=W={}));var j;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(j||(n.TextEditorCursorBlinkingStyle=j={}));var z;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(z||(n.TextEditorCursorStyle=z={}));var K;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(K||(n.TrackedRangeStickiness=K={}));var se;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(se||(n.WrappingIndent=se={}))}),ee(te[56],ne([0,1,7,10]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(v){this._onDidChange.fire({changedLanguages:v,changedColorMap:!1})}register(v,o){return this._tokenizationSupports.set(v,o),this.handleChange([v]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(v)===o&&(this._tokenizationSupports.delete(v),this.handleChange([v]))})}get(v){return this._tokenizationSupports.get(v)||null}registerFactory(v,o){var r;(r=this._factories.get(v))===null||r===void 0||r.dispose();const g=new u(this,v,o);return this._factories.set(v,g),(0,M.toDisposable)(()=>{const e=this._factories.get(v);!e||e!==g||(this._factories.delete(v),e.dispose())})}getOrCreate(v){return ve(this,void 0,void 0,function*(){const o=this.get(v);if(o)return o;const r=this._factories.get(v);return!r||r.isResolved?null:(yield r.resolve(),this.get(v))})}isResolved(v){if(this.get(v))return!0;const r=this._factories.get(v);return!!(!r||r.isResolved)}setColorMap(v){this._colorMap=v,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class u extends M.Disposable{get isResolved(){return this._isResolved}constructor(v,o,r){super(),this._registry=v,this._languageId=o,this._factory=r,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return ve(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return ve(this,void 0,void 0,function*(){const v=yield this._factory.tokenizationSupport;this._isResolved=!0,v&&!this._isDisposed&&this._register(this._registry.register(this._languageId,v))})}}}),ee(te[57],ne([15,58]),function(O,n){return O.create("vs/base/common/platform",n)}),ee(te[13],ne([0,1,57]),function(O,n,R){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,u=!1,f=!1,v=!1,o=!1,r=!1,g=!1,e=!1,d=!1,h=!1,c,_=n.LANGUAGE_DEFAULT,m=n.LANGUAGE_DEFAULT,y,w;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let N;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?N=n.globals.vscode.process:typeof process<"u"&&(N=process);const C=typeof((M=N?.versions)===null||M===void 0?void 0:M.electron)=="string",S=C&&N?.type==="renderer";if(typeof navigator=="object"&&!S)w=navigator.userAgent,i=w.indexOf("Windows")>=0,u=w.indexOf("Macintosh")>=0,e=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=w.indexOf("Linux")>=0,h=w?.indexOf("Mobi")>=0,r=!0,c=R.getConfiguredDefaultLocale(R.localize(0,null))||n.LANGUAGE_DEFAULT,_=c,m=navigator.language;else if(typeof N=="object"){i=N.platform==="win32",u=N.platform==="darwin",f=N.platform==="linux",v=f&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,g=C,d=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=n.LANGUAGE_DEFAULT,_=n.LANGUAGE_DEFAULT;const b=N.env.VSCODE_NLS_CONFIG;if(b)try{const L=JSON.parse(b),A=L.availableLanguages["*"];c=L.locale,m=L.osLocale,_=A||n.LANGUAGE_DEFAULT,y=L._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");let s=0;u?s=1:i?s=3:f&&(s=2),n.isWindows=i,n.isMacintosh=u,n.isLinux=f,n.isNative=o,n.isWeb=r,n.isWebWorker=r&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=h,n.userAgent=w,n.language=_,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const b=[];n.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let E=0,P=b.length;E<P;E++){const T=b[E];if(T.id===A.data.vscodeScheduleAsyncWork){b.splice(E,1),T.callback();return}}});let L=0;return A=>{const E=++L;b.push({id:E,callback:A}),n.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return b=>setTimeout(b)})(),n.OS=u||e?2:i?1:3;let a=!0,l=!1;function p(){if(!l){l=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,a=new Uint16Array(b.buffer)[0]===(2<<8)+1}return a}n.isLittleEndian=p,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),ee(te[59],ne([0,1,13]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const i=R.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),ee(te[60],ne([0,1,59]),function(O,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,u=90,f=122,v=46,o=47,r=92,g=58,e=63;class d extends Error{constructor(a,l,p){let b;typeof l=="string"&&l.indexOf("not ")===0?(b="must not be",l=l.replace(/^not /,"")):b="must be";const L=a.indexOf(".")!==-1?"property":"argument";let A=`The "${a}" ${L} ${b} of type ${l}`;A+=`. Received type ${typeof p}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,a){if(s===null||typeof s!="object")throw new d(a,"Object",s)}function c(s,a){if(typeof s!="string")throw new d(a,"string",s)}const _=R.platform==="win32";function m(s){return s===o||s===r}function y(s){return s===o}function w(s){return s>=M&&s<=u||s>=i&&s<=f}function N(s,a,l,p){let b="",L=0,A=-1,E=0,P=0;for(let T=0;T<=s.length;++T){if(T<s.length)P=s.charCodeAt(T);else{if(p(P))break;P=o}if(p(P)){if(!(A===T-1||E===1))if(E===2){if(b.length<2||L!==2||b.charCodeAt(b.length-1)!==v||b.charCodeAt(b.length-2)!==v){if(b.length>2){const k=b.lastIndexOf(l);k===-1?(b="",L=0):(b=b.slice(0,k),L=b.length-1-b.lastIndexOf(l)),A=T,E=0;continue}else if(b.length!==0){b="",L=0,A=T,E=0;continue}}a&&(b+=b.length>0?`${l}..`:"..",L=2)}else b.length>0?b+=`${l}${s.slice(A+1,T)}`:b=s.slice(A+1,T),L=T-A-1;A=T,E=0}else P===v&&E!==-1?++E:E=-1}return b}function C(s,a){h(a,"pathObject");const l=a.dir||a.root,p=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${p}`:`${l}${s}${p}`:p}n.win32={resolve(...s){let a="",l="",p=!1;for(let b=s.length-1;b>=-1;b--){let L;if(b>=0){if(L=s[b],c(L,"path"),L.length===0)continue}else a.length===0?L=R.cwd():(L=R.env[`=${a}`]||R.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==a.toLowerCase()&&L.charCodeAt(2)===r)&&(L=`${a}\\`));const A=L.length;let E=0,P="",T=!1;const k=L.charCodeAt(0);if(A===1)m(k)&&(E=1,T=!0);else if(m(k))if(T=!0,m(L.charCodeAt(1))){let D=2,F=D;for(;D<A&&!m(L.charCodeAt(D));)D++;if(D<A&&D!==F){const V=L.slice(F,D);for(F=D;D<A&&m(L.charCodeAt(D));)D++;if(D<A&&D!==F){for(F=D;D<A&&!m(L.charCodeAt(D));)D++;(D===A||D!==F)&&(P=`\\\\${V}\\${L.slice(F,D)}`,E=D)}}}else E=1;else w(k)&&L.charCodeAt(1)===g&&(P=L.slice(0,2),E=2,A>2&&m(L.charCodeAt(2))&&(T=!0,E=3));if(P.length>0)if(a.length>0){if(P.toLowerCase()!==a.toLowerCase())continue}else a=P;if(p){if(a.length>0)break}else if(l=`${L.slice(E)}\\${l}`,p=T,T&&a.length>0)break}return l=N(l,!p,"\\",m),p?`${a}\\${l}`:`${a}${l}`||"."},normalize(s){c(s,"path");const a=s.length;if(a===0)return".";let l=0,p,b=!1;const L=s.charCodeAt(0);if(a===1)return y(L)?"\\":s;if(m(L))if(b=!0,m(s.charCodeAt(1))){let E=2,P=E;for(;E<a&&!m(s.charCodeAt(E));)E++;if(E<a&&E!==P){const T=s.slice(P,E);for(P=E;E<a&&m(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&!m(s.charCodeAt(E));)E++;if(E===a)return`\\\\${T}\\${s.slice(P)}\\`;E!==P&&(p=`\\\\${T}\\${s.slice(P,E)}`,l=E)}}}else l=1;else w(L)&&s.charCodeAt(1)===g&&(p=s.slice(0,2),l=2,a>2&&m(s.charCodeAt(2))&&(b=!0,l=3));let A=l<a?N(s.slice(l),!b,"\\",m):"";return A.length===0&&!b&&(A="."),A.length>0&&m(s.charCodeAt(a-1))&&(A+="\\"),p===void 0?b?`\\${A}`:A:b?`${p}\\${A}`:`${p}${A}`},isAbsolute(s){c(s,"path");const a=s.length;if(a===0)return!1;const l=s.charCodeAt(0);return m(l)||a>2&&w(l)&&s.charCodeAt(1)===g&&m(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,l;for(let L=0;L<s.length;++L){const A=s[L];c(A,"path"),A.length>0&&(a===void 0?a=l=A:a+=`\\${A}`)}if(a===void 0)return".";let p=!0,b=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++b;const L=l.length;L>1&&m(l.charCodeAt(1))&&(++b,L>2&&(m(l.charCodeAt(2))?++b:p=!1))}if(p){for(;b<a.length&&m(a.charCodeAt(b));)b++;b>=2&&(a=`\\${a.slice(b)}`)}return n.win32.normalize(a)},relative(s,a){if(c(s,"from"),c(a,"to"),s===a)return"";const l=n.win32.resolve(s),p=n.win32.resolve(a);if(l===p||(s=l.toLowerCase(),a=p.toLowerCase(),s===a))return"";let b=0;for(;b<s.length&&s.charCodeAt(b)===r;)b++;let L=s.length;for(;L-1>b&&s.charCodeAt(L-1)===r;)L--;const A=L-b;let E=0;for(;E<a.length&&a.charCodeAt(E)===r;)E++;let P=a.length;for(;P-1>E&&a.charCodeAt(P-1)===r;)P--;const T=P-E,k=A<T?A:T;let D=-1,F=0;for(;F<k;F++){const W=s.charCodeAt(b+F);if(W!==a.charCodeAt(E+F))break;W===r&&(D=F)}if(F!==k){if(D===-1)return p}else{if(T>k){if(a.charCodeAt(E+F)===r)return p.slice(E+F+1);if(F===2)return p.slice(E+F)}A>k&&(s.charCodeAt(b+F)===r?D=F:F===2&&(D=3)),D===-1&&(D=0)}let V="";for(F=b+D+1;F<=L;++F)(F===L||s.charCodeAt(F)===r)&&(V+=V.length===0?"..":"\\..");return E+=D,V.length>0?`${V}${p.slice(E,P)}`:(p.charCodeAt(E)===r&&++E,p.slice(E,P))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=n.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===r){if(a.charCodeAt(1)===r){const l=a.charCodeAt(2);if(l!==e&&l!==v)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(w(a.charCodeAt(0))&&a.charCodeAt(1)===g&&a.charCodeAt(2)===r)return`\\\\?\\${a}`;return s},dirname(s){c(s,"path");const a=s.length;if(a===0)return".";let l=-1,p=0;const b=s.charCodeAt(0);if(a===1)return m(b)?s:".";if(m(b)){if(l=p=1,m(s.charCodeAt(1))){let E=2,P=E;for(;E<a&&!m(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&m(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&!m(s.charCodeAt(E));)E++;if(E===a)return s;E!==P&&(l=p=E+1)}}}}else w(b)&&s.charCodeAt(1)===g&&(l=a>2&&m(s.charCodeAt(2))?3:2,p=l);let L=-1,A=!0;for(let E=a-1;E>=p;--E)if(m(s.charCodeAt(E))){if(!A){L=E;break}}else A=!1;if(L===-1){if(l===-1)return".";L=l}return s.slice(0,L)},basename(s,a){a!==void 0&&c(a,"ext"),c(s,"path");let l=0,p=-1,b=!0,L;if(s.length>=2&&w(s.charCodeAt(0))&&s.charCodeAt(1)===g&&(l=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let A=a.length-1,E=-1;for(L=s.length-1;L>=l;--L){const P=s.charCodeAt(L);if(m(P)){if(!b){l=L+1;break}}else E===-1&&(b=!1,E=L+1),A>=0&&(P===a.charCodeAt(A)?--A===-1&&(p=L):(A=-1,p=E))}return l===p?p=E:p===-1&&(p=s.length),s.slice(l,p)}for(L=s.length-1;L>=l;--L)if(m(s.charCodeAt(L))){if(!b){l=L+1;break}}else p===-1&&(b=!1,p=L+1);return p===-1?"":s.slice(l,p)},extname(s){c(s,"path");let a=0,l=-1,p=0,b=-1,L=!0,A=0;s.length>=2&&s.charCodeAt(1)===g&&w(s.charCodeAt(0))&&(a=p=2);for(let E=s.length-1;E>=a;--E){const P=s.charCodeAt(E);if(m(P)){if(!L){p=E+1;break}continue}b===-1&&(L=!1,b=E+1),P===v?l===-1?l=E:A!==1&&(A=1):l!==-1&&(A=-1)}return l===-1||b===-1||A===0||A===1&&l===b-1&&l===p+1?"":s.slice(l,b)},format:C.bind(null,"\\"),parse(s){c(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const l=s.length;let p=0,b=s.charCodeAt(0);if(l===1)return m(b)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(m(b)){if(p=1,m(s.charCodeAt(1))){let D=2,F=D;for(;D<l&&!m(s.charCodeAt(D));)D++;if(D<l&&D!==F){for(F=D;D<l&&m(s.charCodeAt(D));)D++;if(D<l&&D!==F){for(F=D;D<l&&!m(s.charCodeAt(D));)D++;D===l?p=D:D!==F&&(p=D+1)}}}}else if(w(b)&&s.charCodeAt(1)===g){if(l<=2)return a.root=a.dir=s,a;if(p=2,m(s.charCodeAt(2))){if(l===3)return a.root=a.dir=s,a;p=3}}p>0&&(a.root=s.slice(0,p));let L=-1,A=p,E=-1,P=!0,T=s.length-1,k=0;for(;T>=p;--T){if(b=s.charCodeAt(T),m(b)){if(!P){A=T+1;break}continue}E===-1&&(P=!1,E=T+1),b===v?L===-1?L=T:k!==1&&(k=1):L!==-1&&(k=-1)}return E!==-1&&(L===-1||k===0||k===1&&L===E-1&&L===A+1?a.base=a.name=s.slice(A,E):(a.name=s.slice(A,L),a.base=s.slice(A,E),a.ext=s.slice(L,E))),A>0&&A!==p?a.dir=s.slice(0,A-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(_){const s=/\\/g;return()=>{const a=R.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>R.cwd()})();n.posix={resolve(...s){let a="",l=!1;for(let p=s.length-1;p>=-1&&!l;p--){const b=p>=0?s[p]:S();c(b,"path"),b.length!==0&&(a=`${b}/${a}`,l=b.charCodeAt(0)===o)}return a=N(a,!l,"/",y),l?`/${a}`:a.length>0?a:"."},normalize(s){if(c(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o,l=s.charCodeAt(s.length-1)===o;return s=N(s,!a,"/",y),s.length===0?a?"/":l?"./":".":(l&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return c(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let a;for(let l=0;l<s.length;++l){const p=s[l];c(p,"path"),p.length>0&&(a===void 0?a=p:a+=`/${p}`)}return a===void 0?".":n.posix.normalize(a)},relative(s,a){if(c(s,"from"),c(a,"to"),s===a||(s=n.posix.resolve(s),a=n.posix.resolve(a),s===a))return"";const l=1,p=s.length,b=p-l,L=1,A=a.length-L,E=b<A?b:A;let P=-1,T=0;for(;T<E;T++){const D=s.charCodeAt(l+T);if(D!==a.charCodeAt(L+T))break;D===o&&(P=T)}if(T===E)if(A>E){if(a.charCodeAt(L+T)===o)return a.slice(L+T+1);if(T===0)return a.slice(L+T)}else b>E&&(s.charCodeAt(l+T)===o?P=T:T===0&&(P=0));let k="";for(T=l+P+1;T<=p;++T)(T===p||s.charCodeAt(T)===o)&&(k+=k.length===0?"..":"/..");return`${k}${a.slice(L+P)}`},toNamespacedPath(s){return s},dirname(s){if(c(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o;let l=-1,p=!0;for(let b=s.length-1;b>=1;--b)if(s.charCodeAt(b)===o){if(!p){l=b;break}}else p=!1;return l===-1?a?"/":".":a&&l===1?"//":s.slice(0,l)},basename(s,a){a!==void 0&&c(a,"ext"),c(s,"path");let l=0,p=-1,b=!0,L;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let A=a.length-1,E=-1;for(L=s.length-1;L>=0;--L){const P=s.charCodeAt(L);if(P===o){if(!b){l=L+1;break}}else E===-1&&(b=!1,E=L+1),A>=0&&(P===a.charCodeAt(A)?--A===-1&&(p=L):(A=-1,p=E))}return l===p?p=E:p===-1&&(p=s.length),s.slice(l,p)}for(L=s.length-1;L>=0;--L)if(s.charCodeAt(L)===o){if(!b){l=L+1;break}}else p===-1&&(b=!1,p=L+1);return p===-1?"":s.slice(l,p)},extname(s){c(s,"path");let a=-1,l=0,p=-1,b=!0,L=0;for(let A=s.length-1;A>=0;--A){const E=s.charCodeAt(A);if(E===o){if(!b){l=A+1;break}continue}p===-1&&(b=!1,p=A+1),E===v?a===-1?a=A:L!==1&&(L=1):a!==-1&&(L=-1)}return a===-1||p===-1||L===0||L===1&&a===p-1&&a===l+1?"":s.slice(a,p)},format:C.bind(null,"/"),parse(s){c(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const l=s.charCodeAt(0)===o;let p;l?(a.root="/",p=1):p=0;let b=-1,L=0,A=-1,E=!0,P=s.length-1,T=0;for(;P>=p;--P){const k=s.charCodeAt(P);if(k===o){if(!E){L=P+1;break}continue}A===-1&&(E=!1,A=P+1),k===v?b===-1?b=P:T!==1&&(T=1):b!==-1&&(T=-1)}if(A!==-1){const k=L===0&&l?1:L;b===-1||T===0||T===1&&b===A-1&&b===L+1?a.base=a.name=s.slice(k,A):(a.name=s.slice(k,b),a.base=s.slice(k,A),a.ext=s.slice(b,A))}return L>0?a.dir=s.slice(0,L-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=_?n.win32.normalize:n.posix.normalize,n.resolve=_?n.win32.resolve:n.posix.resolve,n.relative=_?n.win32.relative:n.posix.relative,n.dirname=_?n.win32.dirname:n.posix.dirname,n.basename=_?n.win32.basename:n.posix.basename,n.extname=_?n.win32.extname:n.posix.extname,n.sep=_?n.win32.sep:n.posix.sep}),ee(te[14],ne([0,1,60,13]),function(O,n,R,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,f=/^\/\//;function v(l,p){if(!l.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!i.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!u.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(f.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(l,p){return!l&&!p?"file":l}function r(l,p){switch(l){case"https":case"http":case"file":p?p[0]!==e&&(p=e+p):p=e;break}return p}const g="",e="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(p){return p instanceof h?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,b,L,A,E,P=!1){typeof p=="object"?(this.scheme=p.scheme||g,this.authority=p.authority||g,this.path=p.path||g,this.query=p.query||g,this.fragment=p.fragment||g):(this.scheme=o(p,P),this.authority=b||g,this.path=r(this.scheme,L||g),this.query=A||g,this.fragment=E||g,v(this,P))}get fsPath(){return N(this,!1)}with(p){if(!p)return this;let{scheme:b,authority:L,path:A,query:E,fragment:P}=p;return b===void 0?b=this.scheme:b===null&&(b=g),L===void 0?L=this.authority:L===null&&(L=g),A===void 0?A=this.path:A===null&&(A=g),E===void 0?E=this.query:E===null&&(E=g),P===void 0?P=this.fragment:P===null&&(P=g),b===this.scheme&&L===this.authority&&A===this.path&&E===this.query&&P===this.fragment?this:new _(b,L,A,E,P)}static parse(p,b=!1){const L=d.exec(p);return L?new _(L[2]||g,a(L[4]||g),a(L[5]||g),a(L[7]||g),a(L[9]||g),b):new _(g,g,g,g,g)}static file(p){let b=g;if(M.isWindows&&(p=p.replace(/\\/g,e)),p[0]===e&&p[1]===e){const L=p.indexOf(e,2);L===-1?(b=p.substring(2),p=e):(b=p.substring(2,L),p=p.substring(L)||e)}return new _("file",b,p,g,g)}static from(p,b){return new _(p.scheme,p.authority,p.path,p.query,p.fragment,b)}static joinPath(p,...b){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return M.isWindows&&p.scheme==="file"?L=h.file(R.win32.join(N(p,!0),...b)).path:L=R.posix.join(p.path,...b),p.with({path:L})}toString(p=!1){return C(this,p)}toJSON(){return this}static revive(p){var b,L;if(p){if(p instanceof h)return p;{const A=new _(p);return A._formatted=(b=p.external)!==null&&b!==void 0?b:null,A._fsPath=p._sep===c&&(L=p.fsPath)!==null&&L!==void 0?L:null,A}}else return p}}n.URI=h;const c=M.isWindows?1:void 0;class _ extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(p=!1){return p?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const p={$mid:1};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=c),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(l,p,b){let L,A=-1;for(let E=0;E<l.length;E++){const P=l.charCodeAt(E);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||p&&P===47||b&&P===91||b&&P===93||b&&P===58)A!==-1&&(L+=encodeURIComponent(l.substring(A,E)),A=-1),L!==void 0&&(L+=l.charAt(E));else{L===void 0&&(L=l.substr(0,E));const T=m[P];T!==void 0?(A!==-1&&(L+=encodeURIComponent(l.substring(A,E)),A=-1),L+=T):A===-1&&(A=E)}}return A!==-1&&(L+=encodeURIComponent(l.substring(A))),L!==void 0?L:l}function w(l){let p;for(let b=0;b<l.length;b++){const L=l.charCodeAt(b);L===35||L===63?(p===void 0&&(p=l.substr(0,b)),p+=m[L]):p!==void 0&&(p+=l[b])}return p!==void 0?p:l}function N(l,p){let b;return l.authority&&l.path.length>1&&l.scheme==="file"?b=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?p?b=l.path.substr(1):b=l.path[1].toLowerCase()+l.path.substr(2):b=l.path,M.isWindows&&(b=b.replace(/\//g,"\\")),b}n.uriToFsPath=N;function C(l,p){const b=p?w:y;let L="",{scheme:A,authority:E,path:P,query:T,fragment:k}=l;if(A&&(L+=A,L+=":"),(E||A==="file")&&(L+=e,L+=e),E){let D=E.indexOf("@");if(D!==-1){const F=E.substr(0,D);E=E.substr(D+1),D=F.lastIndexOf(":"),D===-1?L+=b(F,!1,!1):(L+=b(F.substr(0,D),!1,!1),L+=":",L+=b(F.substr(D+1),!1,!0)),L+="@"}E=E.toLowerCase(),D=E.lastIndexOf(":"),D===-1?L+=b(E,!1,!0):(L+=b(E.substr(0,D),!1,!0),L+=E.substr(D))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const D=P.charCodeAt(1);D>=65&&D<=90&&(P=`/${String.fromCharCode(D+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const D=P.charCodeAt(0);D>=65&&D<=90&&(P=`${String.fromCharCode(D+32)}:${P.substr(2)}`)}L+=b(P,!0,!1)}return T&&(L+="?",L+=b(T,!1,!1)),k&&(L+="#",L+=p?k:y(k,!1,!1)),L}function S(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+S(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,p=>S(p)):l}}),ee(te[64],ne([0,1,4,7,10,11,13,5]),function(O,n,R,M,i,u,f,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let r=!1;function g(a){f.isWeb&&(r||(r=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}n.logOnceWebWorkerWarning=g;class e{constructor(l,p,b,L){this.vsWorker=l,this.req=p,this.method=b,this.args=L,this.type=0}}class d{constructor(l,p,b,L){this.vsWorker=l,this.seq=p,this.res=b,this.err=L,this.type=1}}class h{constructor(l,p,b,L){this.vsWorker=l,this.req=p,this.eventName=b,this.arg=L,this.type=2}}class c{constructor(l,p,b){this.vsWorker=l,this.req=p,this.event=b,this.type=3}}class _{constructor(l,p){this.vsWorker=l,this.req=p,this.type=4}}class m{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,p){const b=String(++this._lastSentReq);return new Promise((L,A)=>{this._pendingReplies[b]={resolve:L,reject:A},this._send(new e(this._workerId,b,l,p))})}listen(l,p){let b=null;const L=new M.Emitter({onWillAddFirstListener:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,L),this._send(new h(this._workerId,b,l,p))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(b),this._send(new _(this._workerId,b)),b=null}});return L.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}const p=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let b=l.err;l.err.$isError&&(b=new Error,b.name=l.err.name,b.message=l.err.message,b.stack=l.err.stack),p.reject(b);return}p.resolve(l.res)}_handleRequestMessage(l){const p=l.req;this._handler.handleMessage(l.method,l.args).then(L=>{this._send(new d(this._workerId,p,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,R.transformErrorForSerialization)(L.detail)),this._send(new d(this._workerId,p,void 0,(0,R.transformErrorForSerialization)(L)))})}_handleSubscribeEventMessage(l){const p=l.req,b=this._handler.handleEvent(l.eventName,l.arg)(L=>{this._send(new c(this._workerId,p,L))});this._pendingEvents.set(p,b)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){const p=[];if(l.type===0)for(let b=0;b<l.args.length;b++)l.args[b]instanceof ArrayBuffer&&p.push(l.args[b]);else l.type===1&&l.res instanceof ArrayBuffer&&p.push(l.res);this._handler.sendMessage(l,p)}}class y extends i.Disposable{constructor(l,p,b){super();let L=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",D=>{this._protocol.handleMessage(D)},D=>{L?.(D)})),this._protocol=new m({sendMessage:(D,F)=>{this._worker.postMessage(D,F)},handleMessage:(D,F)=>{if(typeof b[D]!="function")return Promise.reject(new Error("Missing method "+D+" on main thread host."));try{return Promise.resolve(b[D].apply(b,F))}catch(V){return Promise.reject(V)}},handleEvent:(D,F)=>{if(N(D)){const V=b[D].call(b,F);if(typeof V!="function")throw new Error(`Missing dynamic event ${D} on main thread host.`);return V}if(w(D)){const V=b[D];if(typeof V!="function")throw new Error(`Missing event ${D} on main thread host.`);return V}throw new Error(`Malformed event name ${D}`)}}),this._protocol.setWorkerId(this._worker.getId());let A=null;const E=globalThis.require;typeof E<"u"&&typeof E.getConfig=="function"?A=E.getConfig():typeof globalThis.requirejs<"u"&&(A=globalThis.requirejs.s.contexts._.config);const P=(0,u.getAllMethodNames)(b);this._onModuleLoaded=this._protocol.sendMessage(o,[this._worker.getId(),JSON.parse(JSON.stringify(A)),p,P]);const T=(D,F)=>this._request(D,F),k=(D,F)=>this._protocol.listen(D,F);this._lazyProxy=new Promise((D,F)=>{L=F,this._onModuleLoaded.then(V=>{D(C(V,T,k))},V=>{F(V),this._onError("Worker failed to load "+p,V)})})}getProxyObject(){return this._lazyProxy}_request(l,p){return new Promise((b,L)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,p).then(b,L)},L)})}_onError(l,p){console.error(l),console.info(p)}}n.SimpleWorkerClient=y;function w(a){return a[0]==="o"&&a[1]==="n"&&v.isUpperAsciiLetter(a.charCodeAt(2))}function N(a){return/^onDynamic/.test(a)&&v.isUpperAsciiLetter(a.charCodeAt(9))}function C(a,l,p){const b=E=>function(){const P=Array.prototype.slice.call(arguments,0);return l(E,P)},L=E=>function(P){return p(E,P)},A={};for(const E of a){if(N(E)){A[E]=L(E);continue}if(w(E)){A[E]=p(E,void 0);continue}A[E]=b(E)}return A}class S{constructor(l,p){this._requestHandlerFactory=p,this._requestHandler=null,this._protocol=new m({sendMessage:(b,L)=>{l(b,L)},handleMessage:(b,L)=>this._handleMessage(b,L),handleEvent:(b,L)=>this._handleEvent(b,L)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,p){if(l===o)return this.initialize(p[0],p[1],p[2],p[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,p))}catch(b){return Promise.reject(b)}}_handleEvent(l,p){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(l)){const b=this._requestHandler[l].call(this._requestHandler,p);if(typeof b!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return b}if(w(l)){const b=this._requestHandler[l];if(typeof b!="function")throw new Error(`Missing event ${l} on request handler.`);return b}throw new Error(`Malformed event name ${l}`)}initialize(l,p,b,L){this._protocol.setWorkerId(l);const P=C(L,(T,k)=>this._protocol.sendMessage(T,k),(T,k)=>this._protocol.listen(T,k));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(P),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,globalThis.require.config(p)),new Promise((T,k)=>{(globalThis.require||O)([b],F=>{if(this._requestHandler=F.create(P),!this._requestHandler){k(new Error("No RequestHandler!"));return}T((0,u.getAllMethodNames)(this._requestHandler))},k)}))}}n.SimpleWorkerServer=S;function s(a){return new S(a,null)}n.create=s}),ee(te[61],ne([15,58]),function(O,n){return O.create("vs/editor/common/languages",n)}),ee(te[62],ne([0,1,37,14,2,56,61]),function(O,n,R,M,i,u,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class v{constructor(l,p,b){this.offset=l,this.type=p,this.language=b,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=v;class o{constructor(l,p){this.tokens=l,this.endState=p,this._tokenizationResultBrand=void 0}}n.TokenizationResult=o;class r{constructor(l,p){this.tokens=l,this.endState=p,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=r;var g;(function(a){const l=new Map;l.set(0,R.Codicon.symbolMethod),l.set(1,R.Codicon.symbolFunction),l.set(2,R.Codicon.symbolConstructor),l.set(3,R.Codicon.symbolField),l.set(4,R.Codicon.symbolVariable),l.set(5,R.Codicon.symbolClass),l.set(6,R.Codicon.symbolStruct),l.set(7,R.Codicon.symbolInterface),l.set(8,R.Codicon.symbolModule),l.set(9,R.Codicon.symbolProperty),l.set(10,R.Codicon.symbolEvent),l.set(11,R.Codicon.symbolOperator),l.set(12,R.Codicon.symbolUnit),l.set(13,R.Codicon.symbolValue),l.set(15,R.Codicon.symbolEnum),l.set(14,R.Codicon.symbolConstant),l.set(15,R.Codicon.symbolEnum),l.set(16,R.Codicon.symbolEnumMember),l.set(17,R.Codicon.symbolKeyword),l.set(27,R.Codicon.symbolSnippet),l.set(18,R.Codicon.symbolText),l.set(19,R.Codicon.symbolColor),l.set(20,R.Codicon.symbolFile),l.set(21,R.Codicon.symbolReference),l.set(22,R.Codicon.symbolCustomColor),l.set(23,R.Codicon.symbolFolder),l.set(24,R.Codicon.symbolTypeParameter),l.set(25,R.Codicon.account),l.set(26,R.Codicon.issues);function p(A){let E=l.get(A);return E||(console.info("No codicon found for CompletionItemKind "+A),E=R.Codicon.symbolProperty),E}a.toIcon=p;const b=new Map;b.set("method",0),b.set("function",1),b.set("constructor",2),b.set("field",3),b.set("variable",4),b.set("class",5),b.set("struct",6),b.set("interface",7),b.set("module",8),b.set("property",9),b.set("event",10),b.set("operator",11),b.set("unit",12),b.set("value",13),b.set("constant",14),b.set("enum",15),b.set("enum-member",16),b.set("enumMember",16),b.set("keyword",17),b.set("snippet",27),b.set("text",18),b.set("color",19),b.set("file",20),b.set("reference",21),b.set("customcolor",22),b.set("folder",23),b.set("type-parameter",24),b.set("typeParameter",24),b.set("account",25),b.set("issue",26);function L(A,E){let P=b.get(A);return typeof P>"u"&&!E&&(P=9),P}a.fromString=L})(g||(n.CompletionItemKinds=g={}));var e;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class d{constructor(l,p,b,L){this.range=l,this.text=p,this.completionKind=b,this.isSnippetText=L}equals(l){return i.Range.lift(this.range).equalsRange(l.range)&&this.text===l.text&&this.completionKind===l.completionKind&&this.isSnippetText===l.isSnippetText}}n.SelectedSuggestionInfo=d;var h;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(h||(n.SignatureHelpTriggerKind=h={}));var c;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(c||(n.DocumentHighlightKind=c={}));function _(a){return a&&M.URI.isUri(a.uri)&&i.Range.isIRange(a.range)&&(i.Range.isIRange(a.originSelectionRange)||i.Range.isIRange(a.targetSelectionRange))}n.isLocationLink=_,n.symbolKindNames={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function m(a,l){return(0,f.localize)(26,null,a,n.symbolKindNames[l])}n.getAriaLabelForSymbol=m;var y;(function(a){const l=new Map;l.set(0,R.Codicon.symbolFile),l.set(1,R.Codicon.symbolModule),l.set(2,R.Codicon.symbolNamespace),l.set(3,R.Codicon.symbolPackage),l.set(4,R.Codicon.symbolClass),l.set(5,R.Codicon.symbolMethod),l.set(6,R.Codicon.symbolProperty),l.set(7,R.Codicon.symbolField),l.set(8,R.Codicon.symbolConstructor),l.set(9,R.Codicon.symbolEnum),l.set(10,R.Codicon.symbolInterface),l.set(11,R.Codicon.symbolFunction),l.set(12,R.Codicon.symbolVariable),l.set(13,R.Codicon.symbolConstant),l.set(14,R.Codicon.symbolString),l.set(15,R.Codicon.symbolNumber),l.set(16,R.Codicon.symbolBoolean),l.set(17,R.Codicon.symbolArray),l.set(18,R.Codicon.symbolObject),l.set(19,R.Codicon.symbolKey),l.set(20,R.Codicon.symbolNull),l.set(21,R.Codicon.symbolEnumMember),l.set(22,R.Codicon.symbolStruct),l.set(23,R.Codicon.symbolEvent),l.set(24,R.Codicon.symbolOperator),l.set(25,R.Codicon.symbolTypeParameter);function p(b){let L=l.get(b);return L||(console.info("No codicon found for SymbolKind "+b),L=R.Codicon.symbolProperty),L}a.toIcon=p})(y||(n.SymbolKinds=y={}));class w{}n.TextEdit=w;class N{static fromValue(l){switch(l){case"comment":return N.Comment;case"imports":return N.Imports;case"region":return N.Region}return new N(l)}constructor(l){this.value=l}}n.FoldingRangeKind=N,N.Comment=new N("comment"),N.Imports=new N("imports"),N.Region=new N("region");var C;(function(a){function l(p){return!p||typeof p!="object"?!1:typeof p.id=="string"&&typeof p.title=="string"}a.is=l})(C||(n.Command=C={}));var S;(function(a){a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(S||(n.InlayHintKind=S={}));class s{constructor(l){this.createSupport=l,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(l=>{l&&l.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=s,n.TokenizationRegistry=new u.TokenizationRegistry}),ee(te[63],ne([0,1,35,7,33,14,3,2,38,62,55]),function(O,n,R,M,i,u,f,v,o,r,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(c,_){return(0,i.KeyChord)(c,_)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:R.CancellationTokenSource,Emitter:M.Emitter,KeyCode:g.KeyCode,KeyMod:e,Position:f.Position,Range:v.Range,Selection:o.Selection,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:u.URI,Token:r.Token}}n.createMonacoBaseAPI=d}),ee(te[65],ne([0,1,22,14,3,2,52,26,48,49,63,21,54,46,11,47]),function(O,n,R,M,i,u,f,v,o,r,g,e,d,h,c,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class m extends f.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(C){const S=[];for(let s=0;s<this._lines.length;s++){const a=this._lines[s],l=this.offsetAt(new i.Position(s+1,1)),p=a.matchAll(C);for(const b of p)(b.index||b.index===0)&&(b.index=b.index+l),S.push(b)}return S}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(C){return this._lines[C-1]}getWordAtPosition(C,S){const s=(0,v.getWordAtText)(C.column,(0,v.ensureValidWordDefinition)(S),this._lines[C.lineNumber-1],0);return s?new u.Range(C.lineNumber,s.startColumn,C.lineNumber,s.endColumn):null}words(C){const S=this._lines,s=this._wordenize.bind(this);let a=0,l="",p=0,b=[];return{*[Symbol.iterator](){for(;;)if(p<b.length){const L=l.substring(b[p].start,b[p].end);p+=1,yield L}else if(a<S.length)l=S[a],b=s(l,C),p=0,a+=1;else break}}}getLineWords(C,S){const s=this._lines[C-1],a=this._wordenize(s,S),l=[];for(const p of a)l.push({word:s.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return l}_wordenize(C,S){const s=[];let a;for(S.lastIndex=0;(a=S.exec(C))&&a[0].length!==0;)s.push({start:a.index,end:a.index+a[0].length});return s}getValueInRange(C){if(C=this._validateRange(C),C.startLineNumber===C.endLineNumber)return this._lines[C.startLineNumber-1].substring(C.startColumn-1,C.endColumn-1);const S=this._eol,s=C.startLineNumber-1,a=C.endLineNumber-1,l=[];l.push(this._lines[s].substring(C.startColumn-1));for(let p=s+1;p<a;p++)l.push(this._lines[p]);return l.push(this._lines[a].substring(0,C.endColumn-1)),l.join(S)}offsetAt(C){return C=this._validatePosition(C),this._ensureLineStarts(),this._lineStarts.getPrefixSum(C.lineNumber-2)+(C.column-1)}positionAt(C){C=Math.floor(C),C=Math.max(0,C),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(C),s=this._lines[S.index].length;return{lineNumber:1+S.index,column:1+Math.min(S.remainder,s)}}_validateRange(C){const S=this._validatePosition({lineNumber:C.startLineNumber,column:C.startColumn}),s=this._validatePosition({lineNumber:C.endLineNumber,column:C.endColumn});return S.lineNumber!==C.startLineNumber||S.column!==C.startColumn||s.lineNumber!==C.endLineNumber||s.column!==C.endColumn?{startLineNumber:S.lineNumber,startColumn:S.column,endLineNumber:s.lineNumber,endColumn:s.column}:C}_validatePosition(C){if(!i.Position.isIPosition(C))throw new Error("bad position");let{lineNumber:S,column:s}=C,a=!1;if(S<1)S=1,s=1,a=!0;else if(S>this._lines.length)S=this._lines.length,s=this._lines[S-1].length+1,a=!0;else{const l=this._lines[S-1].length+1;s<1?(s=1,a=!0):s>l&&(s=l,a=!0)}return a?{lineNumber:S,column:s}:C}}class y{constructor(C,S){this._host=C,this._models=Object.create(null),this._foreignModuleFactory=S,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(C){return this._models[C]}_getModels(){const C=[];return Object.keys(this._models).forEach(S=>C.push(this._models[S])),C}acceptNewModel(C){this._models[C.url]=new m(M.URI.parse(C.url),C.lines,C.EOL,C.versionId)}acceptModelChanged(C,S){if(!this._models[C])return;this._models[C].onEvents(S)}acceptRemovedModel(C){this._models[C]&&delete this._models[C]}computeUnicodeHighlights(C,S,s){return ve(this,void 0,void 0,function*(){const a=this._getModel(C);return a?d.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,S,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(C,S,s,a){return ve(this,void 0,void 0,function*(){const l=this._getModel(C),p=this._getModel(S);return!l||!p?null:y.computeDiff(l,p,s,a)})}static computeDiff(C,S,s,a){const l=a==="advanced"?h.linesDiffComputers.getAdvanced():h.linesDiffComputers.getLegacy(),p=C.getLinesContent(),b=S.getLinesContent(),L=l.computeDiff(p,b,s),A=L.changes.length>0?!1:this._modelsAreIdentical(C,S);function E(P){return P.map(T=>{var k;return[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,(k=T.innerChanges)===null||k===void 0?void 0:k.map(D=>[D.originalRange.startLineNumber,D.originalRange.startColumn,D.originalRange.endLineNumber,D.originalRange.endColumn,D.modifiedRange.startLineNumber,D.modifiedRange.startColumn,D.modifiedRange.endLineNumber,D.modifiedRange.endColumn])]})}return{identical:A,quitEarly:L.hitTimeout,changes:E(L.changes),moves:L.moves.map(P=>[P.lineRangeMapping.original.startLineNumber,P.lineRangeMapping.original.endLineNumberExclusive,P.lineRangeMapping.modified.startLineNumber,P.lineRangeMapping.modified.endLineNumberExclusive,E(P.changes)])}}static _modelsAreIdentical(C,S){const s=C.getLineCount(),a=S.getLineCount();if(s!==a)return!1;for(let l=1;l<=s;l++){const p=C.getLineContent(l),b=S.getLineContent(l);if(p!==b)return!1}return!0}computeMoreMinimalEdits(C,S,s){return ve(this,void 0,void 0,function*(){const a=this._getModel(C);if(!a)return S;const l=[];let p;S=S.slice(0).sort((b,L)=>{if(b.range&&L.range)return u.Range.compareRangesUsingStarts(b.range,L.range);const A=b.range?0:1,E=L.range?0:1;return A-E});for(let{range:b,text:L,eol:A}of S){if(typeof A=="number"&&(p=A),u.Range.isEmpty(b)&&!L)continue;const E=a.getValueInRange(b);if(L=L.replace(/\r\n|\n|\r/g,a.eol),E===L)continue;if(Math.max(L.length,E.length)>y._diffLimit){l.push({range:b,text:L});continue}const P=(0,R.stringDiff)(E,L,s),T=a.offsetAt(u.Range.lift(b).getStartPosition());for(const k of P){const D=a.positionAt(T+k.originalStart),F=a.positionAt(T+k.originalStart+k.originalLength),V={text:L.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:D.lineNumber,startColumn:D.column,endLineNumber:F.lineNumber,endColumn:F.column}};a.getValueInRange(V.range)!==V.text&&l.push(V)}}return typeof p=="number"&&l.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),l})}computeLinks(C){return ve(this,void 0,void 0,function*(){const S=this._getModel(C);return S?(0,o.computeLinks)(S):null})}computeDefaultDocumentColors(C){return ve(this,void 0,void 0,function*(){const S=this._getModel(C);return S?(0,_.computeDefaultDocumentColors)(S):null})}textualSuggest(C,S,s,a){return ve(this,void 0,void 0,function*(){const l=new e.StopWatch,p=new RegExp(s,a),b=new Set;e:for(const L of C){const A=this._getModel(L);if(A){for(const E of A.words(p))if(!(E===S||!isNaN(Number(E)))&&(b.add(E),b.size>y._suggestionsLimit))break e}}return{words:Array.from(b),duration:l.elapsed()}})}computeWordRanges(C,S,s,a){return ve(this,void 0,void 0,function*(){const l=this._getModel(C);if(!l)return Object.create(null);const p=new RegExp(s,a),b=Object.create(null);for(let L=S.startLineNumber;L<S.endLineNumber;L++){const A=l.getLineWords(L,p);for(const E of A){if(!isNaN(Number(E.word)))continue;let P=b[E.word];P||(P=[],b[E.word]=P),P.push({startLineNumber:L,startColumn:E.startColumn,endLineNumber:L,endColumn:E.endColumn})}}return b})}navigateValueSet(C,S,s,a,l){return ve(this,void 0,void 0,function*(){const p=this._getModel(C);if(!p)return null;const b=new RegExp(a,l);S.startColumn===S.endColumn&&(S={startLineNumber:S.startLineNumber,startColumn:S.startColumn,endLineNumber:S.endLineNumber,endColumn:S.endColumn+1});const L=p.getValueInRange(S),A=p.getWordAtPosition({lineNumber:S.startLineNumber,column:S.startColumn},b);if(!A)return null;const E=p.getValueInRange(A);return r.BasicInplaceReplace.INSTANCE.navigateValueSet(S,L,A,E,s)})}loadForeignModule(C,S,s){const a=(b,L)=>this._host.fhr(b,L),p={host:(0,c.createProxyObject)(s,a),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(p,S),Promise.resolve((0,c.getAllMethodNames)(this._foreignModule))):new Promise((b,L)=>{O([C],A=>{this._foreignModule=A.create(p,S),b((0,c.getAllMethodNames)(this._foreignModule))},L)})}fmr(C,S){if(!this._foreignModule||typeof this._foreignModule[C]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+C));try{return Promise.resolve(this._foreignModule[C].apply(this._foreignModule,S))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function w(N){return new y(N,null)}n.create=w,typeof importScripts=="function"&&(globalThis.monaco=(0,g.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map